﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace WINDF7CSharp.AD_Filter
{
    public partial class FStepRespDF : Form
    {
        FormMain meinMain;

        public FStepRespDF(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            CRLF = "\r\n";

        }

        int points;
        double t0sr;
        string CRLF = "\r\n";
        string SRDF = "Step Resp of DF";



        private void rBUnitStep_CheckedChanged(object sender, EventArgs e)
        {
            points = (int) nudSteps.Value;
            dataGridView1.RowCount = 1;
            dataGridView1.Rows.Add(points);
            dataGridView1.Rows[0].Cells[0].Value = "1";
            dataGridView1.Rows[0].HeaderCell.Value = "0";
            for (int i = 1; i < points; i++)
            {
                if (rBUnitStep.Checked)
                    dataGridView1.Rows[i].Cells[0].Value = "1";
                else if (rBUnitImpulse.Checked)
                    dataGridView1.Rows[i].Cells[0].Value = "0";

                dataGridView1.Rows[i].HeaderCell.Value = i.ToString();
            }

        }

        private void butCalcOutp_Click(object sender, EventArgs e)
        {
            int i = 0;
            double sum = 0,tout=0;

            points = (int)nudSteps.Value;
            meinMain.fdigfilt.initDF();
            textBoxResponse.Clear();
            textBoxResponse.Visible = false;
            meinMain.ConvertToDouble(Et0run.Text, ref t0sr);
            //textBoxResponse.AppendText("0 0" + CRLF);
            for (int j = 0; j < points; j++)
            {
                double inp = 0;
                meinMain.ConvertToDouble(dataGridView1.Rows[j].Cells[0].Value.ToString(), ref inp); // Hole input(n)
                for (i = meinMain.fdigfilt.Dmgrad + 1; i >= 2; i--)    /* shifting */
                {
                    meinMain.fdigfilt.Dxout[i] = meinMain.fdigfilt.Dxout[i - 1];
                    meinMain.fdigfilt.Dxein[i] = meinMain.fdigfilt.Dxein[i - 1];
                }
                meinMain.fdigfilt.Dxout[1] = sum; sum = 0;
                meinMain.fdigfilt.Dxein[1] = inp;
                sum = meinMain.fdigfilt.DF2[0] * meinMain.fdigfilt.Dxein[1];      /* b0*xein(n) */
                for (i = 1; i <= meinMain.fdigfilt.Dmgrad; i++)
                {
                    sum = sum - meinMain.fdigfilt.DF1[i] * meinMain.fdigfilt.Dxout[i];      /*-ai*old outputs */
                    sum = sum + meinMain.fdigfilt.DF2[i] * meinMain.fdigfilt.Dxein[i + 1];    /*+bi*inputs */
                }
                
                if (rBWithSteps.Checked)
                {
                    textBoxResponse.AppendText(tout.ToString() + " " + sum.ToString() + CRLF);
                    if (j == points - 1) CRLF = ""; // Last line without Line feed + carriage return
                    textBoxResponse.AppendText((tout + t0sr).ToString() + " " + sum.ToString() + CRLF);
                }
                else
                {
                    if (j == points - 1) CRLF = ""; // Last line without Line feed + carriage return
                    textBoxResponse.AppendText(tout.ToString() + " " + sum.ToString() + CRLF);
                }
                tout = tout + t0sr;
            }
            textBoxResponse.Visible = true;
            CRLF = "\r\n";
        }

        private void butDraw_Click(object sender, EventArgs e)
        {
            meinMain.LOMain.init();
            meinMain.LOMain.XaxisLog = false;
            meinMain.LOMain.toptitle = SRDF + "  " + label1.Text + "  " + points;
            //meinMain.LOMain.bottomtitle = bottomtitle;
            meinMain.LOMain.legend = SRDF;
            meinMain.BringToFront();
            meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBoxResponse, ref meinMain.minmaxMain, meinMain.LOMain);
            meinMain.enableCurveButtons();

        }

        private void FStepRespDF_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Hide();
        }

        private void butloadinp_Click(object sender, EventArgs e)
        {
            meinMain.frmLO.ShowDialog();
            double t1=0, t2=0;
            if (meinMain.frmLO.DialogResult == DialogResult.OK)
            {
                string[] outStr = new string[10];
                int nb = meinMain.frmLO.textBox1.Lines.Length;
                string[] TBtemp = new string[nb]; // temporary array to accelerate
                //meinMain.toolStripProgressBar1.Visible = true;

                TBtemp = meinMain.frmLO.textBox1.Lines; // convert TB.text into Array 1 time

                int select = meinMain.frmLO.LO1.selectedCurve;
                if (select > 0)
                {
                    int i, cnt = 0;
                    while (TBtemp[nb - 1].Length < 3) nb--; //ignore last lines if empty or too less char
                    int starti = meinMain.frmLO.LO1.IgnoreFirstLines;

                    if (nb > starti) nb = nb - starti;

                    meinMain.frmLO.LO1.nbofpointslastcurve = nb;

                    double x = 0, y = 0, factor, offset, delay;
                    factor = meinMain.frmLO.LO1.factor;
                    offset = meinMain.frmLO.LO1.offset;
                    delay = meinMain.frmLO.LO1.delay;
                    dataGridView1.RowCount = nb+1;
                    for (i = 0; i < nb; i++)
                    {
                        cnt = meinMain.datatools.Str2NString(TBtemp[i + starti], ref outStr, meinMain.frmLO.LO1.separator);
                        // Now in outStr are all readable values between the separators, cnt is number of read values, cnt-1 is nb of curves

                        meinMain.ConvertToDouble(outStr[0], ref x);
                        x = x - delay;
                        if (i == 0) t1 = x;
                        if (i == 1) t2 = x;

                        meinMain.ConvertToDouble(outStr[select], ref y);
                        y = factor * (y - offset);
                        dataGridView1.Rows[i].Cells[0].Value = y;

                    }
                    nudSteps.Value = nb;
                    t0sr = t2 - t1;
                    Et0run.Text = t0sr.ToString();
                }
            }

        }

        private void butInsertDelay_Click(object sender, EventArgs e)
        {
            nudSteps.Value++;
            for (int i = dataGridView1.RowCount-1; i > 0; i--)
                dataGridView1.Rows[i].Cells[0].Value = dataGridView1.Rows[i - 1].Cells[0].Value;
            dataGridView1.Rows[0].Cells[0].Value = 0;

        }

        private void nudSteps_ValueChanged(object sender, EventArgs e)
        {
            points = (int)nudSteps.Value;
            dataGridView1.RowCount = points;
            for (int i = 1; i < points; i++)
            {
                dataGridView1.Rows[i].HeaderCell.Value = i.ToString();
                if (dataGridView1.Rows[i].Cells[0].Value == null)
                    dataGridView1.Rows[i].Cells[0].Value = 0;
            }
            

        }

        private void butStoreInp_Click(object sender, EventArgs e)
        {
            tBInput.Clear();
            int i;
            meinMain.ConvertToDouble(Et0run.Text, ref t0sr);
            for (i = 0; i < points - 1; i++)
            {
                tBInput.AppendText((i * t0sr).ToString() + " " + dataGridView1.Rows[i].Cells[0].Value.ToString() + CRLF);
            }
            tBInput.AppendText((i * t0sr).ToString() + " " + dataGridView1.Rows[i].Cells[0].Value.ToString());
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBInput.Text);
                myStream1.Close();
            }
            tBInput.Visible = true;
        }

        private void dataGridView1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            tBInput.Visible = false;
        }

        private void FStepRespDF_Load(object sender, EventArgs e)
        {
            Et0run.Text = meinMain.fdigfilt.Et0run.Text;  // Copy the To
            //rBUnitStep_CheckedChanged(sender, e);
            meinMain.ConvertToDouble(Et0run.Text, ref t0sr);

        }

        private void butStoreOut_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(textBoxResponse.Text);
                myStream1.Close();
            }


        }
    }
}
