using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.IO;

using System.Collections.ObjectModel;


namespace WINDF7CSharp
{
    public partial class frmLoadOptions : Form
    {

        FormMain meinMain;
        public LoadOpt LO1;

 
        public frmLoadOptions(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            LO1 = new LoadOpt();
            LO1.init();
        }


        public void deutsch()
        {
            toolStripButton1.ToolTipText = "ffne Info - Seite";
            toolStripButton2.ToolTipText = "Lade eine Datei mit Daten, 1 Zeile pro Punkt";
            toolStripButtonOK.ToolTipText = "Schliee und zeichne Kurve";
            toolStripButton4.ToolTipText = "Schliee ohne Zeichnen";
            grpOffset.Text = "Verstrkung und Offset";
            Text="Lade Datei mit Kurvendaten";
            optBlank.Text = "Leerzeichen";
            optTab.Text = "Tabulator";
            optComma.Text = "Komma";
            chkIgnoreFirst.Text = "Ignoriere erste: ";
            label6.Text = "Zeile(n)";
            label8.Text = "ffne Fenster zur Zeilenanalyse--->";
            groupBox2.Text = "X- Werte";
            optNoChange.Text = "unverndert";
            ChkOptLog.Text = "Logaritmiert";
            ChkOptTimeDelay.Text = "Zeitverschoben, positiv nach links";
        }

        private char getSeparator()
        {
            char def = ' ';

            if (optBlank.Checked) return ' ';
            if (optComma.Checked) return ',';
            if (optTab.Checked)   return '\t';

            return def;
        } 


        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            this.tabInfo.Focus();
        }

        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Abort;
            this.Close();
        }

        private void checkseps()
        {       // counts the number of strings separated with chosen separator
                // multiple separators are ignored
                 // Check content of third last line (last line could be empty) 
                char c=getSeparator();
                string sep = c.ToString();
                if (textBox1.Lines.Length > 4)
                {
                    // check third last line
                    int pos, cnt = 0, x = 0, line = textBox1.Lines.Length - 3;
                    string txt = textBox1.Lines[line];
                    if (txt.Length > 2) //Minimum Length is 3 char
                    {
                        while (txt.Substring(x, 1) == sep) x++; //skip leading seps
                        pos = x + 1;
                        while (x >= 0)  // search for all separators
                        {
                            x = txt.IndexOf(sep, pos);
                            while ((x > -1) && (x < txt.Length - 1) && (txt.Substring(x + 1, 1) == sep)) x++; // if more than one sep skip
                            pos = x + 1;
                            if (pos < txt.Length) cnt++;
                        }
                    }
                    else cnt = 0;
                    numericUpDownNbCvs.Maximum = cnt - 1;// gets the number of curves (x,y1,y2,y3,...) 
                    numericUpDownNbCvs.Value = cnt - 1;
                    label4.Text = "nb of crvs:" + (cnt - 1).ToString();
                }
                else MessageBox.Show(meinMain.wrongDataFormat);

        }


        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                StreamReader myStream1 = new StreamReader(openFileDialog1.OpenFile());
                textBox1.Text = myStream1.ReadToEnd();

                // Remove all Lines with less than 3 char 1 curve must have at least two numbers and a sep like "0 0";
                //Collection<string> strcoll = new Collection<string>();


                //for (int i = 0; i < textBox1.Lines.Length; i++)
                //    if (textBox1.Lines[i].Length > 2) strcoll.Add(textBox1.Lines[i]);
                //textBox1.Clear();// copy Back to Textbox
                //for (int i = 0; i < strcoll.Count - 1; i++)
                //    textBox1.AppendText(strcoll[i] + "\x0d" + "\x0a");
                //textBox1.AppendText(strcoll[strcoll.Count - 1]); // last line
                labelNbofPoint.Text = "Nb of points= "+textBox1.Lines.Length.ToString();
                numericUpDownNbCvs.Focus();
                checkseps();

            }
        }

        private void optTab_Click(object sender, EventArgs e)
        {
            checkseps();
        }


        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            meinMain.ConvertToDouble(txtFactor.Text,ref LO1.factor );
            meinMain.ConvertToDouble(txtOffset.Text,ref LO1.offset );
            if (ChkOptTimeDelay.Checked)  meinMain.ConvertToDouble(txtTimeDelay.Text,ref LO1.delay);
            else LO1.delay=0;
            LO1.selectedCurve=(int)numericUpDownNbCvs.Value;
            LO1.separator=getSeparator();
            LO1.XaxisLog=ChkOptLog.Checked;
            if (chkIgnoreFirst.Checked) LO1.IgnoreFirstLines = Convert.ToInt32(NUD_ignoreFirstLines.Value);
            else LO1.IgnoreFirstLines = 0;
            LO1.legend = System.IO.Path.GetFileName(openFileDialog1.FileName);
            Close();
        }

         private void button1_Click(object sender, EventArgs e)
        {// Test function to check the converter function
            string[] val = new string[20];
            int cnt = 0;
            numericUpDown1.Maximum = textBox1.Lines.Length - 1;
            string txt = textBox1.Lines[(int)numericUpDown1.Value];
            cnt = meinMain.datatools.Str2NString(txt, ref val,getSeparator());
            
            listBox1.Items.Clear();
            for (int i = 0; i < cnt; i++)
            {

                double x= 0;
                meinMain.ConvertToDouble(val[i],ref x);
                listBox1.Items.Add(val[i]+"   Zahl=  "+x.ToString());
            }

        }

         private void rBnoWrap_Click(object sender, EventArgs e)
         {
             if (rBnoWrap.Checked) LO1.phasewrap = "no";
         }

         private void rB90_CheckedChanged(object sender, EventArgs e)
         {
             if (rB90.Checked) LO1.phasewrap = "90";
         }

         private void rB180_CheckedChanged(object sender, EventArgs e)
         {
             if (rB180.Checked) LO1.phasewrap = "180";
         }

         private void numericUpDownNbCvs_KeyDown(object sender, KeyEventArgs e)
         {
             if (e.KeyValue == 0x0d) toolStripButton3_Click(sender, e);
         }

      

    }
}