﻿/* ----------------------------------------------------------------------
 * This is a port of the original UcontrollerdesignD19 - project into C#
 * 
 * Please take a second and have a short look at the documentation which
 * is provided as readme.txt within the project - folder
 * 
 * Author: Stefan Graham
 * Date:   06/03/2009
 * Build:  Visual Studio 2008 with .net 3.5
   ---------------------------------------------------------------------- */


using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO; // needed to instantiate a StreamWriter - object


namespace WINDF7CSharp
{
    public partial class FpidPQ : Form
    {
        //
        // variable declaration
        //
        double k, t1d;
        double t0rtc, p1, p2, q0, q1, q2,q0PD,q1PD,q2PD; // externUnitcontroller
        double kp, ti, td, kri, tni, tvi, si;   //externUcontrdes
        int designmethod;
        string noEquivalentBode, withMethod, AnalogController, DigitalController,dMethod;
        
        

        //
        // constructor
        //
        FormMain meinMain;
        
        public FpidPQ(FormMain m)
        {
            InitializeComponent();

            // definitons for startup
            designmethod = 4;
            noEquivalentBode = "No equivalent bodeform available";
            withMethod = "With method IV not implemented";
            dMethod = "II";
            AnalogController="Analog Controller";
            DigitalController = "Digital Controller, Design Method ";
            meinMain = m;

        }
        // constructor
        public void deutsch()
        {
            noEquivalentBode = "Keine äquivalente Bodeform möglich";
            withMethod = "Mit Methode IV nicht implementiert";

            this.Text = "Berechnung der Koeffizienten von digitalen Reglern";
            button1.Text = "&berechne";
            button3.Text = "&Schließe";
            label1.Text = "Bode Form";
            label2.Text = "Parallele Form";
            groupBox1.Text = "Methode s.S. D19a";
            radioButton1.Text = "II Rechteck/Sek.";
            radioButton3.Text = "IV Trapez-Näherung";
            radioButton2.Text = "III dito mit st-Korr.";
            label20.Text = "st effektiv";
            label21.Text = "Abtastzeit T0";
            labelDontFit.Text = "Werte passen nicht";
            groupBox2.Text = "Sonderfälle";
            button2.Text = "&rückwärts ";
            //button2.to.to->Hint="Berechne die K/T-Werte aus den p/q-Werten";
            //BCopy->Hint="Kopiere p,q-Werte ins Digital-Filter-Fenster (Bodeplot)";
            label18.Text = "rekursiver Algorithmus:";
            button5.Text = "Zum Report";
            AnalogController = "Analoger Regler";
            DigitalController = "Digitaler Regler, Entwurfsmethode ";
            groupBox3.Text = "Digitaler Regler";
            toolTip1.SetToolTip(butPF_BF, "Konvertiere K, Ti, TD, T1 nach KR, TN, Tv, st ");
            toolTip1.SetToolTip(butBF_PF, "Konvertiere KR, TN, Tv, st nach K, Ti, TD, T1 ");
            toolTip1.SetToolTip(button1, "Konvertiere K,T nach p,q");
            toolTip1.SetToolTip(button2, "Berechne aus den p,q die Werte K,T zurück, geht nicht bei Methode IV Trapez");
            toolTip1.SetToolTip(button4, "Kopiere p,q in die Regler- Fenster");
            toolTip1.SetToolTip(button5, "Kopiere alle Werte in den Report");
        }


        //
        // load gui
        //
        private void Form1_Load(object sender, EventArgs e)
        {
            // textBox3.Text = String.Format("{0:" + getFormatString(0.1, 4, 1) + "}", 0.1);
            textBox15.Text = String.Format("{0:" + getFormatString(0.01, 4, 2) + "}", 0.01);
            radioButton3.Checked = true;  // Start with trapezoidal
            radioButton4.Checked = true;   // Start with PIDT1
            edit1Exit(sender);
        }
        // load gui


        //
        // edit1Exit
        // fills textBoxs 5 to 14 with desired values
        // recalculates 9 to 14
        //
        private void edit1Exit(object sender)
        {
            // declarations
            double  alpha, steff, k;

            // get values from textBox 1 to 4
            meinMain.ConvertToDouble(textBox1.Text,ref kri );
            meinMain.ConvertToDouble(textBox2.Text,ref tni );
            meinMain.ConvertToDouble(textBox3.Text,ref tvi );
            meinMain.ConvertToDouble(textBox4.Text,ref si );
            meinMain.ConvertToDouble(textBox15.Text,ref t0rtc );

            // dont't know
            if (Math.Abs(tni) < 1e-10) tni = 1e-10;
            if ((si) < 1e-10) si = 1e-10;
            if (Math.Abs(t0rtc) < 1e-10) t0rtc = 1e-10;

            k = kri * (tni + tvi) / tni; ti = tni + tvi; td = tvi * tni / ti; t1d = tvi / si;

            // set textBox 5 to 8 with calculated values
            textBox5.Text = k.ToString(getFormatString(k, 16, 2));
            textBox6.Text = ti.ToString(getFormatString(ti, 16, 2));
            textBox7.Text = td.ToString(getFormatString(td, 16, 2));
            textBox8.Text = t1d.ToString(getFormatString(t1d, 16, 2));

            // handle different designmethods
            switch (designmethod)
            {
                case 2:
                    {
                        alpha = 1 / (1 + t1d / t0rtc);
                        q0 = k * (1 + td / t0rtc + t0rtc / ti) * alpha;
                        q1 = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2 = k * td / t0rtc * alpha;
                        q0PD = k * (1 + td / t0rtc ) * alpha;
                        q1PD = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2PD = k * td / t0rtc * alpha;
                        p1 = (1 + 2 * t1d / t0rtc) * alpha; p2 = -t1d / t0rtc * alpha;
                        break;
                    }
                case 3:
                    {
                        if (Math.Abs(t1d) < 1e-10) t1d = 1e-10;
                        alpha = td / t1d / (1 + td / t0rtc);
                        q0 = k * (1 + td / t0rtc + t0rtc / ti) * alpha;
                        q1 = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2 = k * td / t0rtc * alpha;
                        q0PD = k * (1 + td / t0rtc ) * alpha;
                        q1PD = -k * (1 + 2 * td / t0rtc) * alpha;
                        q2PD = k * td / t0rtc * alpha;
                        p1 = 2 - alpha; p2 = alpha - 1;
                        break;
                    }
                case 4:
                    {
                        q0 = kri * t0rtc / 2 / tni * (1 + 2 * tni / t0rtc) * (1 + 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        q1 = kri * t0rtc / 2 / tni * ((1 + 2 * tvi / t0rtc) * (1 - 2 * tni / t0rtc) + (1 + 2 * tni / t0rtc)
                             * (1 - 2 * tvi / t0rtc)) / (1 + 2 * t1d / t0rtc);
                        q2 = kri * t0rtc / 2 / tni * (1 - 2 * tni / t0rtc) * (1 - 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        q0PD = kri  * (1 + 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        q1PD = kri * (-4 * tvi / t0rtc)  / (1 + 2 * t1d / t0rtc);
                        q2PD = -kri  * (1 - 2 * tvi / t0rtc) / (1 + 2 * t1d / t0rtc);
                        p1 = 4 * t1d / t0rtc / (1 + 2 * t1d / t0rtc); p2 = 1 - p1;
                        break;
                    }
            } // switch designmethods
            
            // set textBox 9 to 14 with calculated values
            textBox9.Text = p1.ToString(getFormatString(p1, 16, 2)); 
            textBox10.Text = p2.ToString(getFormatString(p2, 16, 2));
            textBox11.Text = q0.ToString(getFormatString(q0, 16, 2));
            textBox12.Text = q1.ToString(getFormatString(q1, 16, 2));
            textBox13.Text = q2.ToString(getFormatString(q2, 16, 2));
            steff = q0 / kri;

            textBox14.Text = steff.ToString(getFormatString(steff, 16, 2));

            // warning-label hidden
            labelDontFit.Visible = false;
        }
        // edit1Exit


        //
        // designmethods
        //
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            designmethod = 2;
            dMethod = "II";
            edit1Exit(sender);
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            designmethod = 3;
            dMethod = "III";
            edit1Exit(sender);
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
             designmethod=4;
             dMethod="IV";
             edit1Exit(sender);
        }
        // designmethods


        //
        // special cases
        //
        // PIDT1
        private void radioButton4_CheckedChanged(object sender, EventArgs e)
        {
            edit1Exit(sender);
            textBox4.BackColor = SystemColors.Window; /*st*/
            textBox4.ReadOnly = false; /*st*/
            textBox3.BackColor = SystemColors.Window; /*tv*/
            textBox3.ReadOnly = false; /*tv*/
            textBox2.BackColor = SystemColors.Window; /*tn*/
            textBox2.ReadOnly = false; /*tn*/
        }

        // PID
        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            textBox4.Text = String.Format("{0:" + getFormatString(1e10, 10, 4) + "}", 1e10); /*st*/
            textBox4.BackColor = Color.Silver; /*st*/
            textBox4.ReadOnly = true; /*st*/
            textBox3.BackColor = SystemColors.Window; /*tv*/
            textBox3.ReadOnly = false; /*tv*/
            textBox2.BackColor = SystemColors.Window; /*tn*/
            textBox2.ReadOnly = false; /*tn*/
            edit1Exit(sender);
        }

        // PI
        private void radioButton6_CheckedChanged(object sender, EventArgs e)
        {
            textBox4.Text = String.Format("{0:" + getFormatString(1, 10, 4) + "}", 1); /*st*/
            textBox4.BackColor = Color.Silver; /*st*/
            textBox4.ReadOnly = true; /*st*/
            textBox3.Text = String.Format("{0:" + getFormatString(0, 10, 4) + "}", 0); /*tv*/
            textBox3.BackColor = Color.Silver; /*tv*/
            textBox3.ReadOnly = true; /*tv*/
            textBox2.BackColor = SystemColors.Window; /*tn*/
            textBox2.ReadOnly = false; /*tn*/
            edit1Exit(sender);
        }

        // PDT1
        private void radioButton7_CheckedChanged(object sender, EventArgs e)
        {
            textBox4.BackColor = SystemColors.Window; /*st*/ 
            textBox4.ReadOnly = false; /*st*/
            textBox3.BackColor = SystemColors.Window; /*tv*/
            textBox3.ReadOnly = false; /*tv*/
            textBox2.Text = String.Format("{0:" + getFormatString(1e10, 10, 4) + "}", 1e10); /*tn*/
            textBox2.BackColor = Color.Silver; /*tn*/
            textBox2.ReadOnly = true; /*tn*/
            edit1Exit(sender);
        }

        // PD
        private void radioButton8_CheckedChanged(object sender, EventArgs e)
        {
            textBox4.Text = String.Format("{0:" + getFormatString(1e10, 10, 4) + "}", 1e10); /*st*/ 
            textBox4.BackColor = Color.Silver; /*st*/
            textBox4.ReadOnly = true; /*st*/
            textBox3.BackColor = SystemColors.Window; /*tv*/
            textBox3.ReadOnly = false; /*tv*/
            textBox2.Text = String.Format("{0:" + getFormatString(1e10, 10, 4) + "}", 1e10); /*tn*/
            textBox2.BackColor = Color.Silver; /*tn*/
            textBox2.ReadOnly = true; /*tn*/
            edit1Exit(sender);
        }
        // special cases


        //
        // recompute
        // handles textBoxes 5 to 8 first
        // then takes care of 1 to 4 by envoking edit5Exit
        //
        private void button2_Click(object sender, EventArgs e)
        {
            double alpha, x;
            // make sure selected designmethod is implemented
            bool letsDoThis = false;

            // get values for variables from textBoxes 9 to 13
            meinMain.ConvertToDouble(textBox9.Text,ref p1 );
            meinMain.ConvertToDouble(textBox10.Text,ref p2 );
            meinMain.ConvertToDouble(textBox11.Text,ref q0 );
            meinMain.ConvertToDouble(textBox12.Text,ref q1 );
            meinMain.ConvertToDouble(textBox13.Text,ref q2 );

            // handle designmethods
            switch (designmethod)
            {
                case 2:
                    {
                        t1d = t0rtc * (-p2 / (1 + p2));
                        x = 1 + t1d / t0rtc;
                        kp = (-q1 - 2 * q2) * x;
                        alpha = q0 + q1 + q2;
                        if (Math.Abs(alpha) < 1e-10) alpha = 1e-10;
                        ti = kp * t0rtc / x / alpha;
                        if (Math.Abs(kp) < 1e-10) td = 1e10; else td = t0rtc * q2 / kp * x;
                        letsDoThis = true;
                        break;
                    }
                case 3:
                    {
                        x = 1 + p2;
                        kp = (-q1 - 2 * q2) / x;
                        alpha = q0 + q1 + q2;
                        if (Math.Abs(alpha) < 1e-10) alpha = 1e-10;
                        ti = kp * t0rtc * x / alpha;
                        if (Math.Abs(kp) < 1e-10) td = 1e10; else td = t0rtc * q2 / kp / x;
                        t1d = td / x / (1 + td / t0rtc);
                        letsDoThis = true;
                        break;
                    }
                case 4:
                    {
                        MessageBox.Show(withMethod);
                        letsDoThis = false;
                        break;
                    }
            } // switch

            // do this if only designmethod 2 or 3 was selected
            if (letsDoThis)
            {
                // write calculated values into textBoxes 5 to 8
                textBox5.Text = kp.ToString(getFormatString(kp, 16, 2));
                textBox6.Text = ti.ToString(getFormatString(ti, 16, 2));
                textBox7.Text = td.ToString(getFormatString(td, 16, 2));
                textBox8.Text = t1d.ToString(getFormatString(t1d, 16, 2));

                // taking care of textBoxes 1 to 4
                edit5Exit(sender);
            }
        }
        // recompute


        //
        // edit5Exit
        // recalculate textBox-values 1 to 4
        // rewrite them , call edit1Exit
        //
        private void edit5Exit(object sender)
        {
            // get values for variables
            meinMain.ConvertToDouble(textBox5.Text,ref k );
            meinMain.ConvertToDouble(textBox6.Text,ref ti );
            meinMain.ConvertToDouble(textBox7.Text,ref td );
            meinMain.ConvertToDouble(textBox8.Text,ref t1d );

            // some calculation
            double help = 1 - 4 * td / ti;

            if (help < 0)
            {
                MessageBox.Show(noEquivalentBode);
            }
            else
            {
                help = Math.Sqrt(help);
                kri = 0.5 * k * (1 + help);
                tni = 0.5 * ti * (1 + help);
                tvi = 0.5 * ti * (1 - help);
            }
            if (Math.Abs(t1d) < 1e-10)
            {
                si = 1e10;
            }
            else
            {
                si = tvi / t1d;
            }

            // write recalculated values into textBoxes 1 to 4
            textBox1.Text = kri.ToString(getFormatString(kri, 16, 2)); 
            textBox2.Text = tni.ToString(getFormatString(tni, 16, 2));
            textBox3.Text = tvi.ToString(getFormatString(tvi, 16, 2));
            textBox4.Text = si.ToString(getFormatString(si, 16, 2));

            // recalculate and rewrite everything except textBoxes 1 to 4
            edit1Exit(sender);
        }
        // edit5Exit


        //
        // add to main report
        //
        private void button5_Click(object sender, EventArgs e)
        {
            string s = "      ";

            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(s + this.Text+"\r\n");
            meinMain.tBMainReport.AppendText("\r\n");

            meinMain.tBMainReport.AppendText(s + AnalogController+"\r\n");
            meinMain.tBMainReport.AppendText(s + "Kr = " + textBox1.Text + s + "K = " + textBox5.Text + "\r\n");
            meinMain.tBMainReport.AppendText(s + "TN = " + textBox2.Text + s + "Ti = " + textBox6.Text + "\r\n");
            meinMain.tBMainReport.AppendText(s + "Tv = " + textBox3.Text + s + "Td = " + textBox7.Text + "\r\n");
            meinMain.tBMainReport.AppendText(s + "st = " + textBox4.Text + s + "T1 = " + textBox8.Text + "\r\n");
            meinMain.tBMainReport.AppendText("\r\n");

            meinMain.tBMainReport.AppendText(s + DigitalController + dMethod + "\n");
            meinMain.tBMainReport.AppendText("\r\n");

            meinMain.tBMainReport.AppendText(s + "T0 = " + textBox15.Text + "\r\n");
            meinMain.tBMainReport.AppendText(s + "                  " + s + "q0 = " + textBox11.Text + "\r\n");
            meinMain.tBMainReport.AppendText(s + "p1 = " + textBox9.Text + s + "q1 = " + textBox12.Text + "\r\n");
            meinMain.tBMainReport.AppendText(s + "p2 = " + textBox10.Text + s + "q1 = " + textBox13.Text + "\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
        }
        // add to main report


        //
        // copy
        //
        private void button4_Click(object sender, EventArgs e)
        {
            // copy results into both real time controller 
            meinMain.ConvertToDouble(textBox9.Text, ref meinMain.frmStudContr.p1f);
            meinMain.ConvertToDouble(textBox10.Text, ref meinMain.frmStudContr.p2f);
            meinMain.ConvertToDouble(textBox11.Text, ref meinMain.frmStudContr.q0f);
            meinMain.ConvertToDouble(textBox12.Text, ref meinMain.frmStudContr.q1f);
            meinMain.ConvertToDouble(textBox13.Text, ref meinMain.frmStudContr.q2f);
            meinMain.frmStudContr.q0fPD = q0PD; // AWU Params
            meinMain.frmStudContr.q1fPD = q1PD;
            meinMain.frmStudContr.q2fPD = q2PD;

            meinMain.ConvertToDouble(textBox9.Text, ref meinMain.frmadaptcon.p1f);
            meinMain.ConvertToDouble(textBox10.Text, ref meinMain.frmadaptcon.p2f);
            meinMain.ConvertToDouble(textBox11.Text, ref meinMain.frmadaptcon.q0f);
            meinMain.ConvertToDouble(textBox12.Text, ref meinMain.frmadaptcon.q1f);
            meinMain.ConvertToDouble(textBox13.Text, ref meinMain.frmadaptcon.q2f);
            meinMain.frmadaptcon.q0fPD = q0PD; // AWU Params
            meinMain.frmadaptcon.q1fPD = q1PD;
            meinMain.frmadaptcon.q2fPD = q2PD;
            
        }
        // copy


        //
        // close
        //
        private void button3_Click(object sender, EventArgs e)
        {
            Hide();
        }
        // close


        //
        // getFormatString
        // returns a format-string according to
        // the corresponding method FloatToStrF
        // from the original C++ - code
        //
        // the method looks for the dec-point-position of the
        // value and puts together a proper format-string
        // by finding out how many decimal-places are really needed,
        // then subtracting them from the overall size to get
        // the resulting floating-precision
        //
        private string getFormatString(double value, int size, int decimals)
        {
            string formatString = ""; // empty format-string
            string valueString = value.ToString(); // 1:1 casting of the double value
            int indexOfDecPoint = valueString.IndexOf('.'); // where is the dec-point

            // if there are less deciamls than
            // original format want's to provide
            // correct this value
            if (indexOfDecPoint < decimals)
            {
                decimals = indexOfDecPoint;
            }

            // put together the format-string
            // starting with the decimals
            for(int i = 1; i < decimals; i++)
            {
                formatString += "#";
            }

            // add a zero to make sure that
            // at least one decimal is shown
            // and ad the dec-point
            formatString += "0.";

            size -= decimals; // correct size for floats

            // add the number of floats to
            // the format-string
            for (int i = 1; i <= size; i++)
            {
                formatString += "#";
            }

            // finally return the correct
            // format-string
            return formatString;
        }
        // getFormatString


        //
        // show "Values don't fit" - warning
        // note: this method was neither called in
        // the original code nor will it in this
        //
        private void showValueWarning(object sender)
        {
            labelDontFit.Visible = true;
        }

        private void butBF_PF_Click(object sender, EventArgs e)
        {
            edit1Exit(sender);
        }

        private void butPF_BF_Click(object sender, EventArgs e)
        {
            edit5Exit(sender);
        }

        private void FpidPQ_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Hide();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            edit1Exit(sender);
        }
        // show Warning
    }
}
