using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Schwarze;                 //FormSchschwarze
using PReuter;                  //FormReuter
using FRADesign;                // FormFRADesign
using Flash;                    //FlashForm
using smallTools;               //in small tools/
using System.Drawing.Printing;   // Printer settings 
using System.IO;
using DFUFK;                    //in UFKmodule
using System.Globalization;
using ZPR;                      //in Identification/FormZPR
using idregress;                // in FRegression
using UScope;                   // in FScope
using System.Diagnostics;       // stopwatch
using CraneModelMuk;
using RealTimerDevice;
using DAQmx_Basics;
using cRIO_Basics;
using USBOrlowskiDLL;
using WINDF7CSharp.ChartTools;
using DT9062;
using me4660;
using USBOrlowskiDLL20;

namespace WINDF7CSharp
{
 
    
    public partial class FormMain : Form
    {

        FormSchwarze schwarze;
        FormReuter reuter;
        public FormFRA fra;
        public FlashForm flash;
        wrc2pt1 wrc2;
        pt2equ pt2;
        pt1id pt1;
        nichols nichol;
        DFUFK1 dfufk;
        FormInfo frminfo;
        public frmLoadOptions frmLO;
        FormZPR frmZpr;
        public F_Regress fregress;
        public FScope fscope;
        public DataTools datatools;
        public TFAnalogfilter fanalogfilter;
        public FContrdes fcontrdes;
        public FpidPQ fpidpq;
        public Fa2d fa2d;
        public FDigitalFilter fdigfilt;
        FormGPA frmGPA;
        FormNI frmNI;
        FormME2600 frmMe2600;
        public FormXWCalc frmxwcalc;
        FormCraneModelMuk frmCrane;
        public Hardwaretools.FormHardwareSimul frmSimul;
        public StudControl.FormStudControl frmStudContr;
        small_tools.FormPIDMagPhase frmPID;
        public FormRTdevice frmRTdevice;
        DAQmx_Basic frmDACmx;
        cRIO_Basics_2Channels frmcRIO;
        Hardwaretools.FDigitalRTFilter frmRTFilt;
        Init.FInit frmInit;
        FormUSBOrl frmusborl;
        public FormLSOffline frmlsoff;
        public AdaptControl.FormAdaptControl frmadaptcon;
        RealTimeController.FormDRTKranregler frmDTRKran;
        FormTestComma frmtestComma;
        AD_Filter.FStepRespDF fstepresp;
        public FormSaveCurve frmsavecurve;
        FormDT9062 frmDT9062;
        public FormME4660 frmME4660;
        FormUSBOrl20 frmusborl20;
        public fuzzy.FormFuzEditor frmFuzEdit;
        Hardwaretools.FormSampleHold frmSH;
        Formxypendel frmXYPendel;
        public UNIT_Interface_RS232 frmUNI_T;

        

        private int startSeite;		    // Anzahl der Druckseiten
        private int anzahlSeiten;		// aktuelle Seitenzahl
        private int seitenNummer;		// zu druckender Text
        private string strPrintText;    // der Name der geffneten Datei
        public string wrongDataFormat = "Wrong Data format";
        string strDateiName = "";
        public string errorConvert = "Fehler bei Konvertierung Nr.: ";
        public string selectedADC = "no card";
        public string controlBoxSelector = "";
        public string notmorethan10curves="Not more than 10 curves";

        public char comF, comR;   // to correct Comma- / point problem comF : wrong seperator
                                 // comR  : correct separator

        PrinterSettings printsetgs = new PrinterSettings();


        public FormMain()
        {
            InitializeComponent();

            printDialog1.PrinterSettings = new PrinterSettings();
            schwarze = new FormSchwarze(this);
            reuter = new FormReuter(this);
            fra = new FormFRA(this);
            flash = new FlashForm(this);
            wrc2 = new wrc2pt1(this);
            pt2 = new pt2equ(this);
            pt1 = new pt1id(this);
            nichol = new nichols(this);
            dfufk = new DFUFK1(this);
            frminfo = new FormInfo();
            frmLO = new frmLoadOptions(this);
            frmZpr = new FormZPR(this);
            fregress = new F_Regress(this);
            fscope = new FScope(this);
            initChart();
            LOMain.init();
            datatools = new DataTools();
            fanalogfilter = new TFAnalogfilter(this);
            fcontrdes = new FContrdes(this);
            fpidpq = new FpidPQ(this);
            fa2d = new Fa2d(this);
            fdigfilt = new FDigitalFilter(this);
            frmGPA = new FormGPA(this);
            frmNI = new FormNI(this);
            frmMe2600 = new FormME2600(this);
            frmxwcalc = new FormXWCalc(this);
            frmCrane = new FormCraneModelMuk(this);
            frmSimul = new Hardwaretools.FormHardwareSimul(this);
            frmStudContr = new StudControl.FormStudControl(this);
            frmPID = new small_tools.FormPIDMagPhase(this);
            frmRTdevice = new FormRTdevice(this);
            frmDACmx = new DAQmx_Basic();
            frmcRIO = new cRIO_Basics_2Channels();
            frmRTFilt = new Hardwaretools.FDigitalRTFilter(this);
            frmInit = new Init.FInit();
            frmusborl = new FormUSBOrl();
            frmlsoff = new FormLSOffline(this);
            frmadaptcon = new AdaptControl.FormAdaptControl(this);
            frmDTRKran = new RealTimeController.FormDRTKranregler(this);
            frmtestComma = new FormTestComma(this);
            fstepresp = new AD_Filter.FStepRespDF(this);
            frmsavecurve = new FormSaveCurve();
            frmDT9062 = new FormDT9062(this);
            frmcp = new FormCurvePlotter(this);
            frmME4660 = new FormME4660();
            frmFuzEdit = new fuzzy.FormFuzEditor(this);
            frmusborl20 = new FormUSBOrl20();
            frmSH = new Hardwaretools.FormSampleHold(this);
            frmXYPendel = new Formxypendel(this);
            frmUNI_T = new UNIT_Interface_RS232(this);

            stopwatch.Start();
        }




        //----------------------------------------------------------------------------------
        //chartfx- init
        //----------------------------------------------------------------------------------


        FormCurvePlotter frmcp ;

        Stopwatch stopwatch=new Stopwatch();



        public CHMinMax minmaxMain = new CHMinMax();
        public LoadOpt LOMain = new LoadOpt();

        public void ConvertToDouble(string text,ref double nb)
        {
            // Secure Conversion independant of Komma- Version of PC
            // comF contains String with wrong camma, comR contains string with correct comma
            // if number format is wrong, result is old number
            // Call :  ConvertToDouble(text,ref number);
            // removes all thousand- Seperators
            // examples: (if decimal sep =".")
            // 1000,000,000.23 --> 1000000000.23
            // 1000.000.000,23 --> 1000000000.23
            // 0.23 --> 0.23
            // 0,23 --> 0.23
            // 1000,023 --> 1000.023
            // 1000.023 --> 1000.023

            // examples: (if decimal sep =",")
            // 1000,000,000.23 --> 1000000000,23
            // 1000.000.000,23 --> 1000000000,23
            // 0.23 --> 0,23
            // 0,23 --> 0,23
            // 1000,023 --> 1000,023
            // 1000.023 --> 1000,023

            string TestText = (0.1).ToString("f1");

            if (TestText.Substring(1, 1) == ".")  // Check which is the actual Decimal separator
            { comF = ','; comR = '.'; }
            else
            { comF = '.'; comR = ','; }
            
            double number = 0;
            char []seps =new char[2];
            seps[0]=','; // both possible decimal seperators
            seps[1]='.';
            // check if Thousand- group sign is available. If more than one sign, all left signs are removed
            int index=0,cnt=0;
            while(index>-1)  // count number of seperators
            {
                index=text.IndexOfAny(seps,index);  // look for next position of seps
                if (index>-1) {cnt++;index++;}
            }
            string newtext=text;
            if (cnt > 1)  // If more than one sign, all left signs are removed
            {
                string leftSign=text.Substring(text.IndexOfAny(seps),1);  // what is the left sign?
                newtext = text.Replace(leftSign, "");// Remove all left signs
            }
            string help = newtext.Replace(comF,comR); // Change into correct decimal sep
            if (Double.TryParse(help, out number))
                nb = number;
            else MessageBox.Show(wrongDataFormat);
        
        }
        
        private void initChart()
        {

            chart2D1.AllClearButton = false;
            chart2D1.LastClearButton = false;
            //axChartfx1.Dock = DockStyle.Fill;
            //axChartfx1.Visible = false;
            //axChartfx1.Type = def.SCATTER;
            //axChartfx1.Type = axChartfx1.Type | def.CT_SCATTERLINE;
            //axChartfx1.Type = axChartfx1.Type | def.CT_COLORLINE;
            //axChartfx1.Type = axChartfx1.Type | def.CT_TOOL;
            //axChartfx1.Type = axChartfx1.Type | def.CT_LEGEND;
            //axChartfx1.Type = axChartfx1.Type | def.CST_VGRID;
            //axChartfx1.Type = axChartfx1.Type | def.CT_HORZ;



            //axChartfx1.CustTool = axChartfx1.CustTool | def.CST_SCATTER;

            //deleteAllPoints();
            
            //frmcs.axChartfx1 = axChartfx1;  // pointer verbiegen 
            //frmcs.LoadDefault();
            //frmcs.Text = "Change Color in Chart of Main Form";
        }

        public void enableCurveButtons()
        {

            this.ToolButton15Store.Enabled = true;
        }

        private void disableCurveButtons()
        {


            this.ToolButton15Store.Enabled = false;

        }

        
        //----------------------------------------------------------------------------------
        //chartfx- init
        //----------------------------------------------------------------------------------


 

        private void TBger_Click(object sender, EventArgs e)
        {
            maindeutsch();
            schwarze.deutsch();
            reuter.deutsch();
            fra.deutsch();
            flash.deutsch();
            wrc2.deutsch();
            pt2.deutsch();
            pt1.deutsch();
            nichol.deutsch();
            dfufk.deutsch();
            frmLO.deutsch();
            frmZpr.deutsch();
            fregress.deutsch();
            fanalogfilter.deutsch();
            fpidpq.deutsch();
            fcontrdes.deutsch();
            fa2d.deutsch();
            fscope.deutsch();
            frmxwcalc.deutsch();
            fdigfilt.deutsch();
            frmGPA.deutsch();
            frmStudContr.deutsch();
            frmadaptcon.deutsch();
            frmSimul.deutsch();
            frmRTFilt.deutsch();
            frmInit.deutsch();
            frmlsoff.deutsch();
            frmsavecurve.deutsch();
            frmFuzEdit.deutsch();
            frmDTRKran.deutsch();
        }

        void maindeutsch()
        {

            this.Text = "Toolsammlung fr Regelungstechnik   ..... Prof. Dr. Bayerlein";
            /* menue*/
            this.deutsch1.Text = "english text only at start";
            this.load1.Text = "Lade Graphik-file";
            this.deletelastfile1.Text = "Lsche letzte Kurve";
            this.deleteallfiles1.Text = "Lsche alle Kurven";
 
            this.quit1.Text = "Beenden";
            this.info1.Text = "Infobox";
            this.file1.Text = "Datei";
            this.options1.Text = "Aktionen";
            this.deletelastfile1.Text = "Lsche letzte Kurve";
            this.deleteallfiles1.Text = "Lsche alle Kurven";
            this.loadanlogfilterzk1.Text = "Definiere analoges Filter";
            this.loaddigitalfilterzk1.Text = "Definiere digitales Filter";
            this.InvertedxyPendulum1.Text = "Stehendes xy-Pendel";
            this.modifyanalogfilterufk1.Text = "Berechne UFK -. ZK ";
            this.identification1.Text = "Identifikation";
            this.bytimefunctionLS1.Text = "Regression ber f(t)";
            this.byoffLineLSFz1.Text = "Offline-LS-Verfahren -.F(z)";
            this.Realtimefunctions1.Text = "Echtzeit-Funktionen";
            this.dRTVersuch3PendelToolStripMenuItem.Text = "DRT- Versuch3 Pendel";
            this.Studentcontrol1.Text = "Studenten- Echtzeit-Regler";
            this.Flashdesign2PT11.Text = "Blitzreglerentwurf";
            this.FRA2PT1delay1.Text = "FKL-Verfahren 2PT1+ Totzeit";
            this.N2pointcontrollerident1.Text = "Zweipunktregleridentifikation";
            this.ControllerDesign2.Text = "Reglerentwurf";
            this.PT2Equations1.Text = "PT2-Gleichungen";
            this.PT1with2Points1.Text = "PT1 mit 2 Punkten";
            this.Flashdesign2PT11.Text = "Blitzregler PID+2PT1";
            this.FRA2PT1delay1.Text = "FKL PID+2PT1+Totzeit";
            this.Calculateqi1.Text = "Berechne qi PIDT1";
            this.freqCalculatorToolStripMenuItem.Text = "Bode-Frequenzrechner";
            this.ADCard1.Text = "AD-Karte";
            this.label2.Text = "C# Tool Sammlung fr Regelungstechnik";
            this.label3.Text = "Projektleiter Prof. Dr. Bayerlein";
            this.label4.Text = "Komplett berarbeitet in MS C#";
            this.label5.Text = "Grafische Darstellung verschiedener Diagramme, z. B. Bodediagramme";
            this.label6.Text = "Entwurf von analogen und digitalen Filtern, Entwurf digitaler Filter";
            this.label7.Text = "Diverse Identifikationsprogramme, Interfaces zu Scopes und GPA";
            this.label8.Text = "Echtzeitreglerfunktion mit AD-Karten Interface und,und, und ...";
            this.designofToolStripMenuItem.Text = "Entwurf digitaler PID- Reg.";
            this.someToolsToolStripMenuItem.Text = "Einige Tools";
            this.rCBlockToolStripMenuItem.Text = "2 RC- Tiefpass";
            this.schwarze2PT1IdentificationToolStripMenuItem.Text = "2PT1- Identifikation nach Schwarze";
            this.craneModelMUKToolStripMenuItem.Text = "Modell Kran";
            this.activeFilterToolStripMenuItem.Text = "Aktives Filter";
            this.nicholsEquationsToolStripMenuItem.Text = "Nichols- Gleichungen";
            this.noCardToolStripMenuItem.Text = "Keine Karte";
            // tooltips in deutsch
            ToolButton11LoadFile.ToolTipText = "Lade Datei mit graphischen Daten (z.B. *.dat)";
            ToolButton10AnalogF.ToolTipText = "Lade oder definiere analoges Filter fr Bodediagramm";


            ToolButton11LoadFile.ToolTipText = "Lade Datei mit graphischen Daten (z.B. *.dat)";
            //openFileDialog1.Title="Lade Datei mit graphischen Daten (z.B. *.dat)";
            ToolButton12DigF.ToolTipText = "Lade oder definiere digitales Filter fr Bodediagramm";
            TBClose.ToolTipText = "Schliee Anwendung";
            ToolButton21MagA.ToolTipText = "Zeichne die Betragskurve des analogen Filters";
            ToolButton23MagD.ToolTipText = "Zeichne die Betragskurve des digitalen Filters";
            ToolButton22PhiA.ToolTipText = "Zeichne die Phasenkurve des analogen Filters";
            ToolButton17PhiD.ToolTipText = "Zeichne die Phasenkurve des digitalen Filters";
            ToolButton18A2D.ToolTipText = "Berechne ein passendes digitales Filter ";
            ToolButton19SR.ToolTipText = "Berechne die Antwort des digitalen Filters";
            ToolButton24UFK.ToolTipText = "Lade Filter in UFK-Form und konvertiere in ZK-Form";
            ToolButton15Store.ToolTipText = "Speichere Diagramm-Werte als File (Export-Funktion)";
            ToolButton28GPA.ToolTipText = "Lese Daten von Gain Phase Analyzer in den PC";
            ToolButton26Scope.ToolTipText = "Lese Daten vom Scope PM38xx in den PC";
            ToolButton29MagGPA.ToolTipText = "Zeichne die letzte gemessene Betragskurve vom GPA";
            ToolButton31PhiGPA.ToolTipText = "Zeichne die letzte gemessene Phasenkurve vom GPA";
            ToolButton27ScopeF.ToolTipText = "Zeichne die letzte gemessene Kurve vom Scope";

            toolStripButtonPreview.ToolTipText = "Druckvorschau";
            toolStripButton42StoreTxt.ToolTipText = "Speichere Report als .txt- Datei";
            toolStripButton41Clear.ToolTipText = "Lsche Report";
            toolStripButton32SetUp.ToolTipText = "Druckerseiten einrichten";
            toolStripButton31Print.ToolTipText = "Drucke Report";
            TSBClearLast.ToolTipText= "Lsche letzte Kurve";
            tsbClearAll.ToolTipText="Lsche alle Kurven";
            errorConvert = "Error at Chart- conversion nb.: ";
            adaptiveAdvancedControllerToolStripMenuItem.Text = "Adaptive Regler";
            wrongDataFormat = "Falsches Zahlenformat";
            notmorethan10curves="Nicht mehr als 10 Kurven mglich";
            chart2D1.Germanlanguage = true;
            devicesToolStripMenuItem.Text = "Gerte";
            scopePhillipsToolStripMenuItem.Text = "Oszillograph Phillips";
            unitTRedLCDToolStripMenuItem.Text = "rotes LCD- Scope UNIT_T";
            gainPhaseAnalyzerToolStripMenuItem.Text = "Frequenzgangmessplatz";
        }

        //
        //---------------------------------------------------------------------------------------------------------------
        //  Printing Report        
        //---------------------------------------------------------------------------------------------------------------

        private void toolStripButton31_Click(object sender, EventArgs e)
        {
            printDialog1.AllowSomePages = true;
            if (printDialog1.ShowDialog() == DialogResult.OK)
            {
                printDocument1.DocumentName = "Dokument";
                // Startwerte abhngig vom zu druckenden Text initialisieren
                switch (printDialog1.PrinterSettings.PrintRange)
                {
                    case PrintRange.AllPages:
                        strPrintText = tBMainReport.Text;
                        startSeite = 1;
                        anzahlSeiten = printDialog1.PrinterSettings.MaximumPage;
                        break;
                    case PrintRange.SomePages:
                        strPrintText = tBMainReport.Text;
                        startSeite = printDialog1.PrinterSettings.FromPage;
                        anzahlSeiten = printDialog1.PrinterSettings.ToPage - startSeite + 1;
                        break;
                }
                // Drucken starten
                seitenNummer = 1;
                printDocument1.Print();
            }
        }

        private void printDocument1_PrintPage(object sender, PrintPageEventArgs e)
        {
            StringFormat stringFormat = new StringFormat();
            RectangleF rectFPapier, rectFText;
            int intChars, intLines;

            // Ermitteln des Rectangles, das den gesamten Druckbereich
            // beschreibt (inklusive Kopf- und Fusszeile)
            rectFPapier = e.MarginBounds;

            // Ermitteln des Rectangles, das den Bereich fr den
            // Text beschreibt (ausschlielich Kopf- und Fusszeile)
            rectFText = RectangleF.Inflate(rectFPapier, 0, -2 * tBMainReport.Font.GetHeight(e.Graphics));

            // eine gerade Anzahl von Druckzeilen ermitteln
            int anzahlZeilen = (int)Math.Floor(rectFText.Height / tBMainReport.Font.GetHeight(e.Graphics));

            // die Hhe die textbeinhaltenden Rechtecks festlegen, damit die
            // letzte Druckzeile nicht abgeschnitten wird
            rectFText.Height = anzahlZeilen * tBMainReport.Font.GetHeight(e.Graphics);

            // das StringFormat-Objekt festlegen, um den Text in einem Rechteck
            // anzuzeigen - Text bis zum nchstliegenden Wort verkrzen
            stringFormat.Trimming = StringTrimming.Word;

            //	legt die Druckstartseite fest, wenn es sich nicht um die
            // erste Dokumentenseite handelt
            while ((seitenNummer < startSeite) && (strPrintText.Length > 0))
            {
                e.Graphics.MeasureString(strPrintText, tBMainReport.Font, rectFText.Size, stringFormat, out intChars, out intLines);
                strPrintText = strPrintText.Substring(intChars);
                seitenNummer++;
            }

            // Druckjob beenden, wenn es keinen Text zum Drucken mehr gibt
            if (strPrintText.Length == 0)
            {
                e.Cancel = true;
                return;
            }

            // den Text an das Graphics-Objekt bergeben
            e.Graphics.DrawString(strPrintText, tBMainReport.Font, Brushes.Black, rectFText, stringFormat);

            // Text fr die nchste Seite
            // intChars - Anzahl der Zeichen in der Zeichenfolge
            // intLines - Anzahl der Zeilen in der Zeichenfolge
            e.Graphics.MeasureString(strPrintText, tBMainReport.Font, rectFText.Size, stringFormat, out intChars, out intLines);
            strPrintText = strPrintText.Substring(intChars);

            // StringFormat restaurieren
            stringFormat = new StringFormat();

            // Dateiname in der Kopfzeile anzeigen
            stringFormat.Alignment = StringAlignment.Center;
            e.Graphics.DrawString(this.strDateiName, tBMainReport.Font, Brushes.Black, rectFPapier, stringFormat);

            // Seitennummer in der Fusszeile anzeigen
            stringFormat.LineAlignment = StringAlignment.Far;
            e.Graphics.DrawString("Page " + seitenNummer, tBMainReport.Font, Brushes.Black, rectFPapier, stringFormat);

            // ermitteln, ob weitere Seiten zu drucken sind
            seitenNummer++;
            e.HasMorePages = (strPrintText.Length > 0) && (seitenNummer < startSeite + anzahlSeiten);

            // Neuinitialisierung
            if (!e.HasMorePages)
            {
                strPrintText = tBMainReport.Text;
                startSeite = 1;
                anzahlSeiten = printDialog1.PrinterSettings.MaximumPage;
                seitenNummer = 1;
            }

        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            printDialog1.AllowSomePages = true;
            strPrintText = tBMainReport.Text;
            startSeite = 1;
            anzahlSeiten = printDialog1.PrinterSettings.MaximumPage;
            seitenNummer = 1;
            printPreviewDialog1.ShowDialog();

        }

        private void toolStripButton42StoreTxt_Click(object sender, EventArgs e)
        {
            if (tBMainReport.Lines.Length > 0)
                if (saveFileDialogReport.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter myStream1 = new StreamWriter(saveFileDialogReport.OpenFile(), Encoding.Default);
                    myStream1.WriteLine(tBMainReport.Text);
                    myStream1.Close();
                }

        }
        //---------------------------------------------------------------------------------------------------------------
        //  Printing Report ENd       
        //---------------------------------------------------------------------------------------------------------------

//---------------------------------------------------------------------------------------------------------------
//  All modules to copy data between modules      
//---------------------------------------------------------------------------------------------------------------

        public void reuterOK()
        {// This function copies the result of reuter ident  into all controller design windows

            double help = 0;
            this.ConvertToDouble(reuter.textBox4.Text, ref help);
            flash.textBox2.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox5.Text, ref help);
            flash.textBox3.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox6.Text, ref help);
            flash.textBoxTz.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox4.Text, ref help);
            fra.textBox2.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox5.Text, ref help);
            fra.textBox3.Text = help.ToString("g5");
            this.ConvertToDouble(reuter.textBox6.Text, ref help);
            fra.textBox4.Text = help.ToString("g5");

        }

        public void schwarzeOK()
        {// This function copies the result of schwarze ident  into all controller design windows

            double help = 0;
            this.ConvertToDouble(schwarze.textBox4.Text, ref help);
            flash.textBox2.Text = help.ToString("g5"); //T1
            this.ConvertToDouble(schwarze.textBox5.Text, ref help);
            flash.textBox3.Text = help.ToString("g5");//T2
            this.ConvertToDouble(schwarze.textBox7.Text, ref help);
            flash.textBoxTz.Text = help.ToString("g5");//Tz
            this.ConvertToDouble(schwarze.textBox4.Text, ref help);
            fra.textBox2.Text = help.ToString("g5");
            this.ConvertToDouble(schwarze.textBox5.Text, ref help);
            fra.textBox3.Text = help.ToString("g5");
            this.ConvertToDouble(schwarze.textBox7.Text, ref help);
            fra.textBox4.Text = help.ToString("g5");

        }


 
        public void DFUFK_OK()
        {
            // copy Time Constants to analog Filter window
        }

        public void ZPROK()
        {
            // copy data to controller Design only 2PT1 possible
            double help = 0;
            this.ConvertToDouble(frmZpr.Edit8T1.Text, ref help);
            flash.textBox2.Text = help.ToString("g5");    //T1
            this.ConvertToDouble(frmZpr.Edit9T2.Text, ref help);
            flash.textBox3.Text = help.ToString("g5");    //T2
            this.ConvertToDouble(frmZpr.Edit10Tz.Text, ref help);
            flash.textBoxTz.Text = help.ToString("g5");  //Tz
            this.ConvertToDouble(frmZpr.Edit7K.Text, ref help);
            flash.textBox1.Text = help.ToString("g5");     //K

            this.ConvertToDouble(frmZpr.Edit8T1.Text, ref help);
            fra.textBox2.Text = help.ToString("g5");    //T1
            this.ConvertToDouble(frmZpr.Edit9T2.Text, ref help);
            fra.textBox3.Text = help.ToString("g5");    //T2
            this.ConvertToDouble(frmZpr.Edit10Tz.Text, ref help);
            fra.textBox4.Text = help.ToString("g5");  //Tz
            this.ConvertToDouble(frmZpr.Edit7K.Text, ref help);
            fra.textBox1.Text = help.ToString("g5"); //K 


            fcontrdes.rb2pt1.Checked = true;
            fcontrdes.rb2pt1_Click(null, null);
            fcontrdes.tBcomment.Text = "2PT1 from ZPR";
            this.ConvertToDouble(frmZpr.Edit7K.Text, ref help);
            fcontrdes.edk.Text = help.ToString("g5");
            this.ConvertToDouble(frmZpr.Edit8T1.Text, ref help);
            fcontrdes.Edt1.Text = help.ToString("g5");
            this.ConvertToDouble(frmZpr.Edit9T2.Text, ref help);
            fcontrdes.Edt2.Text = help.ToString("g5");
            this.ConvertToDouble(frmZpr.Edit10Tz.Text, ref help);
            fcontrdes.edtt.Text = help.ToString("g5");
        }

        public void regessionOK(string typ)
        {
            double help = 0;
            if (typ == "2PT1")
            {
                this.ConvertToDouble(fregress.par1.Text, ref help);
                flash.textBox1.Text = help.ToString("g5");// K
                this.ConvertToDouble(fregress.par2.Text, ref help);
                flash.textBox2.Text = help.ToString("g5");// T1
                this.ConvertToDouble(fregress.par3.Text, ref help);
                flash.textBox3.Text = help.ToString("g5");// T2
                this.ConvertToDouble(fregress.par5.Text, ref help);
                flash.textBoxTz.Text = help.ToString("g5");// Tz
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fra.textBox1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fra.textBox2.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par3.Text, ref help);
                fra.textBox3.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par5.Text, ref help);
                fra.textBox4.Text = help.ToString("g5");


                fcontrdes.rb2pt1.Checked = true;
                //fcontrdes.rb2pt1_Click(null, null);
                fcontrdes.tBcomment.Text = "2PT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par3.Text, ref help);
                fcontrdes.Edt2.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par5.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");

            }
            if (typ == "IT1")
            {
                fcontrdes.rbit1.Checked = true;
                //fcontrdes.rbit1(null, null);
                fcontrdes.tBcomment.Text = "IT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");

                this.ConvertToDouble(fregress.par5.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");

            }
            if (typ == "PT1")
            {
                fcontrdes.rbpt1.Checked = true;
                //fcontrdes.rbit1(null, null);
                fcontrdes.tBcomment.Text = "PT1 from regress";
                this.ConvertToDouble(fregress.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(fregress.par5.Text, ref help);
                fcontrdes.edtt.Text = help.ToString("g5");
           }
        }

        public void LSoffOK(string typ)
        {
            double help = 0;
            if (typ == "2PT1")
            {
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                flash.textBox1.Text = help.ToString("g5");// K
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                flash.textBox2.Text = help.ToString("g5");// T1
                this.ConvertToDouble(frmlsoff.par3.Text, ref help);
                flash.textBox3.Text = help.ToString("g5");// T2
                flash.textBoxTz.Text = frmlsoff.tzLS.ToString("g5");// Tz
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fra.textBox1.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fra.textBox2.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par3.Text, ref help);
                fra.textBox3.Text = help.ToString("g5");
                fra.textBox4.Text = frmlsoff.tzLS.ToString("g5");// Tz

                fcontrdes.rb2pt1.Checked = true;
                fcontrdes.tBcomment.Text = "2PT1 from LS Offline";
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par3.Text, ref help);
                fcontrdes.Edt2.Text = help.ToString("g5");
                fcontrdes.edtt.Text = frmlsoff.tzLS.ToString("g5");// Tz
            }
            if (typ == "IT1")
            {
                fcontrdes.rbit1.Checked = true;

                fcontrdes.tBcomment.Text = "IT1 from LS Offline";
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");

                fcontrdes.edtt.Text = frmlsoff.tzLS.ToString("g5");// Tz
            }
            if (typ == "PT1")
            {
                fcontrdes.rbpt1.Checked = true;

                fcontrdes.tBcomment.Text = "PT1 from LS Offline";
                this.ConvertToDouble(frmlsoff.par1.Text, ref help);
                fcontrdes.edk.Text = help.ToString("g5");
                this.ConvertToDouble(frmlsoff.par2.Text, ref help);
                fcontrdes.Edt1.Text = help.ToString("g5");

                fcontrdes.edtt.Text = frmlsoff.tzLS.ToString("g5");// Tz
            }


        }

        
        
        //---------------------------------------------------------------------------------------------------------------
        //  All modules to copy data between modules  end----------------------------       
//---------------------------------------------------------------------------------------------------------------
 
        
        private void FRA2PT1delay1_Click(object sender, EventArgs e)
        {
            fra.Show();
            if (fra.WindowState == FormWindowState.Minimized)
                fra.WindowState = FormWindowState.Normal;
            fra.BringToFront();
        }

        private void Flashdesign2PT11_Click(object sender, EventArgs e)
        {
            flash.Show();
            if (flash.WindowState == FormWindowState.Minimized)
                flash.WindowState = FormWindowState.Normal;
            flash.BringToFront();
        }

        private void TBClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void schwarze2PT1IdentificationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            schwarze.Show();
            if (schwarze.WindowState == FormWindowState.Minimized)
                schwarze.WindowState = FormWindowState.Normal;
            schwarze.BringToFront();
        }

        private void reuter2PT1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            reuter.Show();
            if (reuter.WindowState == FormWindowState.Minimized)
                reuter.WindowState = FormWindowState.Normal;
            reuter.BringToFront();
        }

        private void toolStripButton41_Click(object sender, EventArgs e)
        {
            tBMainReport.Clear();
        }

        private void PT1with2Points1_Click(object sender, EventArgs e)
        {
            pt1.Show();
            if (pt1.WindowState == FormWindowState.Minimized)
                pt1.WindowState = FormWindowState.Normal;
            pt1.BringToFront();
        }

        private void nicholsEquationsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            nichol.Show();
            if (nichol.WindowState == FormWindowState.Minimized)
                nichol.WindowState = FormWindowState.Normal;
            nichol.BringToFront();
        }

        private void PT2Equations1_Click(object sender, EventArgs e)
        {
            pt2.Show();
            if (pt2.WindowState == FormWindowState.Minimized)
                pt2.WindowState = FormWindowState.Normal;
            pt2.BringToFront();
        }

        private void rCBlockToolStripMenuItem_Click(object sender, EventArgs e)
        {
            wrc2.Show();
            if (wrc2.WindowState == FormWindowState.Minimized)
                wrc2.WindowState = FormWindowState.Normal;
            wrc2.BringToFront();
        }

        private void toolStripButton32_Click(object sender, EventArgs e)
        {
            pageSetupDialog1.ShowDialog();
       }

        private void ToolButton24UFK_Click(object sender, EventArgs e)
        {
            dfufk.Show();
            if (dfufk.WindowState == FormWindowState.Minimized)
                dfufk.WindowState = FormWindowState.Normal;
            dfufk.BringToFront();
        }

        private void info1_Click(object sender, EventArgs e)
        {
            StreamReader filestream = new StreamReader("history.txt", Encoding.Default);
            string line = "", crlf = "\r\n";
            tBMainReport.Visible = false;
            while (line != null)
            {
                line = filestream.ReadLine();
                if (line != null)
                {
                    tBMainReport.AppendText(line + crlf);
                }
            }
            tBMainReport.Visible = true;
            filestream.Close();
            tabControl1.SelectedTab = tabPage2;

        }

        private void N2pointcontrollerident1_Click(object sender, EventArgs e)
        {
            frmZpr.Show();
            if (frmZpr.WindowState == FormWindowState.Minimized)
                frmZpr.WindowState = FormWindowState.Normal;
            frmZpr.BringToFront();
        }

        private void designofToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fcontrdes.Show();
            if (fcontrdes.WindowState == FormWindowState.Minimized)
                fcontrdes.WindowState = FormWindowState.Normal;
            fcontrdes.BringToFront();
        }

        private void Calculateqi1_Click(object sender, EventArgs e)
        {
            fpidpq.Show();
            if (fpidpq.WindowState == FormWindowState.Minimized)
                fpidpq.WindowState = FormWindowState.Normal;
            fpidpq.BringToFront();
        }

        private void ToolButton10AnalogF_Click(object sender, EventArgs e)
        {
            if (fanalogfilter.WindowState == FormWindowState.Minimized)
                fanalogfilter.WindowState = FormWindowState.Normal;
            fanalogfilter.Show();
            fanalogfilter.BringToFront();
        }

        private void ToolButton18A2D_Click(object sender, EventArgs e)
        {
            if (fa2d.WindowState == FormWindowState.Minimized)
                fa2d.WindowState = FormWindowState.Normal;
            fa2d.Show();
            fa2d.BringToFront();

        }

        private void ToolButton12DigF_Click(object sender, EventArgs e)
        {
            if (fdigfilt.WindowState == FormWindowState.Minimized)
                fdigfilt.WindowState = FormWindowState.Normal;
            fdigfilt.labelADCCard.Text = selectedADC;
            fdigfilt.Show();
            fdigfilt.BringToFront();

        }

        private void curvePlotterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmcp.ShowDialog();
            // this drawing uses following global params: 
            // lastminmaxMain.maxpts: 
            // minmaxMain.maxpts actual Max points
            // minmaxMain.serie: Number of Curve starting with 0
            // xmax,xmin,ymax,ymin as MinMax- values of Curves

            if (frmcp.DialogResult == DialogResult.OK)
            {
                minmaxMain.serie++;
                if (minmaxMain.serie > 10)
                {
                    minmaxMain.serie = 10;
                    MessageBox.Show(notmorethan10curves);
                }
                int i, nb = (int)frmcp.numericUpDown1.Value;
                int lastmaxpts = minmaxMain.pts;
                if (nb > minmaxMain.pts) minmaxMain.pts = nb;
                chart2D1.Visible = true;
                enableCurveButtons();
                double x, y = 0;
                for (i = 0; i < nb; i++)
                {
                    x = frmcp.Xmax * i / (nb - 1);// x goes from 0 to xmax

                    y = frmcp.function(x);
                    chart2D1.setPoint(minmaxMain.serie - 1, x, y);
 
                    if (y > minmaxMain.ymax) minmaxMain.ymax = y;
                    if (y < minmaxMain.ymin) minmaxMain.ymin = y;
                    if (x > minmaxMain.xmax) minmaxMain.xmax = x;
                    if (x < minmaxMain.xmin) minmaxMain.xmin = x;
                }
                chart2D1.CurveNames[minmaxMain.serie-1] = frmcp.leg;

                chart2D1.autoScaling();
                chart2D1.startDrawing();
            }
        }

        private void ToolButton2SetUp_Click(object sender, EventArgs e)
        {

        }

        private void TBcolchange_Click(object sender, EventArgs e)
        {
            ////frmcs.axChartfx1 = axChartfx1;  // pointer verbiegen 
            //if (frmcs.WindowState == FormWindowState.Minimized)
            //    frmcs.WindowState = FormWindowState.Normal;
            //frmcs.Show();
            //frmcs.BringToFront();
        }

        private void ToolButton7Datashow_Click(object sender, EventArgs e)
        {

        }


        private void deleteAllPoints()
        {
            minmaxMain.init();
        }

        private void ToolButton11LoadFile_Click(object sender, EventArgs e)
        {
            //frmLO.ChartfxLoadOpt = axChartfx1;  // set pointer to destination Chart
            frmLO.ShowDialog();
            if ( frmLO.DialogResult== DialogResult.OK)
            {

                long strt, stp;
                strt = stopwatch.ElapsedTicks;
                int a = datatools.ConvertTB2ChartAdd(ref chart2D1, frmLO.textBox1, ref minmaxMain,frmLO.LO1);//ConvertTB2Chart(meinm;
                enableCurveButtons();
                stp = stopwatch.ElapsedTicks;
                toolStripStatusLabel4.Text = ((stp - strt) / (float)Stopwatch.Frequency * 1000).ToString() + " ms";
                if (a > 0) MessageBox.Show(errorConvert + a.ToString());
                else enableCurveButtons();
            }
         
        }

        private void ToolButton15Store_Click(object sender, EventArgs e)
        {
            frmsavecurve.RefToChart2D = chart2D1;
            if (frmsavecurve.WindowState == FormWindowState.Minimized)
                frmsavecurve.WindowState = FormWindowState.Normal;
            frmsavecurve.Show();
            frmsavecurve.BringToFront();
        }

        private void bytimefunctionLS1_Click(object sender, EventArgs e)
        {
            fregress.labelADCCard.Text = selectedADC;
            if (fregress.WindowState == FormWindowState.Minimized)
                fregress.WindowState = FormWindowState.Normal;
            fregress.Show();
            fregress.BringToFront();
        }

        private void ToolButton26Scope_Click(object sender, EventArgs e)
        {
            if (fscope.WindowState == FormWindowState.Minimized)
                fscope.WindowState = FormWindowState.Normal;
            fscope.Show();
            fscope.BringToFront();
        }

        private void ToolButton27ScopeF_Click(object sender, EventArgs e)
        {
           fscope.buttonDrawScope_Click(sender, e);
        }

        private void ToolButton21MagA_Click(object sender, EventArgs e)
        {
            fanalogfilter.drawMag();
        }

        private void ToolButton22PhiA_Click(object sender, EventArgs e)
        {
            fanalogfilter.drawPhi();
        }

        private void ToolButton23MagD_Click(object sender, EventArgs e)
        {
            fdigfilt.DrawMag();
        }

        private void ToolButton17PhiD_Click(object sender, EventArgs e)
        {
            fdigfilt.DrawPhi();
        }

        private void ToolButton28GPA_Click(object sender, EventArgs e)
        {
            if (frmGPA.WindowState == FormWindowState.Minimized)
                frmGPA.WindowState = FormWindowState.Normal;
            frmGPA.Show();
            frmGPA.BringToFront();
        }

        private void ToolButton29MagGPA_Click(object sender, EventArgs e)
        {
            frmGPA.buttonGPADrawF_Click(sender, e);
        }

        private void ToolButton31PhiGPA_Click(object sender, EventArgs e)
        {
            frmGPA.buttonGPADrawPhi_Click(sender, e);
        }

/// <summary>
///  Adc - Control section
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>

        private void uSBFHLOriginalToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void nationalInstrumentsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            adcmenuAllUnchecked();
            nationalInstrumentsToolStripMenuItem.Checked = true;
            selectedADC = "NI trad.";
            frmNI.Show();
            if (frmNI.WindowState == FormWindowState.Minimized)
                frmNI.WindowState = FormWindowState.Normal;
            frmNI.BringToFront();
        }

        public void ADCinput(short chan,ref double val)
        {
            if (nationalInstrumentsToolStripMenuItem.Checked)
                frmNI.InputNI(chan,ref val);
            
            if (meilhausME2600ToolStripMenuItem.Checked)
                frmMe2600.inputME(chan, ref val);
            if (hardwareSimulationToolStripMenuItem.Checked)
                frmSimul.inputSimul(chan, ref val);
            if (toolStripMenuItemNIDAQmx.Checked)
                frmDACmx.InputNImx(chan, ref val);
            if (uSBFHL10VToolStripMenuItem.Checked)
                frmusborl.inputOrl(chan, ref val);
            if (tsmcRIO.Checked)
                frmcRIO.inputcrio(chan, ref val);
            if (meilhausME4660ToolStripMenuItem.Checked)
                frmME4660.input(chan, ref val);
            if (uSBFHLOrlowski20ToolStripMenuItem.Checked)
                frmusborl20.inputOrl(chan, ref val);
        }


        public void DACoutput(short chan, double val)
        {
            if (nationalInstrumentsToolStripMenuItem.Checked)
                frmNI.OutputNI(chan, val);
            
            if (meilhausME2600ToolStripMenuItem.Checked)
                frmMe2600.outputMe(chan, val);
            if (hardwareSimulationToolStripMenuItem.Checked)
                frmSimul.outputSimul(chan, val);
            if (toolStripMenuItemNIDAQmx.Checked)
                frmDACmx.OutputNImx(chan, val);
            if (uSBFHL10VToolStripMenuItem.Checked)
                frmusborl.outputOrl(chan, val);
            if (tsmcRIO.Checked)
                frmcRIO.outputcrio(chan, val);
            if (meilhausME4660ToolStripMenuItem.Checked)
                frmME4660.output(chan, val);
            if (uSBFHLOrlowski20ToolStripMenuItem.Checked)
                frmusborl20.outputOrl(chan,  val);

        }

        private void meilhausME2600ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            adcmenuAllUnchecked();
            meilhausME2600ToolStripMenuItem.Checked = true;
            selectedADC = "Me2600";
            frmMe2600.Show();
            if (frmMe2600.WindowState == FormWindowState.Minimized)
                frmMe2600.WindowState = FormWindowState.Normal;
            frmMe2600.BringToFront();
        }

        private void noCardToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "no card";
            meilhausME2600ToolStripMenuItem.Checked = false;
            nationalInstrumentsToolStripMenuItem.Checked = false;
            hardwareSimulationToolStripMenuItem.Checked = false;
        }

        private void freqCalculatorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (frmxwcalc.WindowState == FormWindowState.Minimized)
                frmxwcalc.WindowState = FormWindowState.Normal;
            frmxwcalc.Show();
            frmxwcalc.BringToFront();
        }

        //private void axChartfx1_LButtonDblClk(object sender, AxChartfxLib._DChartfxEvents_LButtonDblClkEvent e)
        //{
        //    EventArgs weg =new EventArgs();
        //    short ser = e.nSerie;  // copy values to calc
        //    int poi = e.nPoint;
        //    axChartfx1.ThisSerie = ser;
        //    frmxwcalc.Elogw.Text = axChartfx1.get_XValue((short)poi).ToString();
        //    frmxwcalc.Elogw_Leave(sender, weg);
        //    frmxwcalc.textBoxDB.Text = axChartfx1.get_Value((short)poi).ToString();
        //    frmxwcalc.textBox1_Leave(sender, weg);

        //}

       private void craneModelMUKToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmCrane.label8.Text = "ADC: " + selectedADC;
            frmCrane.Show();
            if (frmCrane.WindowState == FormWindowState.Minimized)
                frmCrane.WindowState = FormWindowState.Normal;
            frmCrane.BringToFront();
           //chart2D1.
        }

        private void adcmenuAllUnchecked()
        {
            meilhausME2600ToolStripMenuItem.Checked = false;
            nationalInstrumentsToolStripMenuItem.Checked = false;
            hardwareSimulationToolStripMenuItem.Checked = false;
            noCardToolStripMenuItem.Checked = false;
            uSBFHL10VToolStripMenuItem.Checked = false;
            toolStripMenuItemNIDAQmx.Checked = false;
            tsmcRIO.Checked = false;
            meilhausME4660ToolStripMenuItem.Checked = false;
            uSBFHLOrlowski20ToolStripMenuItem.Checked = false;
        }

        
        private void hardwareSimulationToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "HW- Simul";
            adcmenuAllUnchecked();
            hardwareSimulationToolStripMenuItem.Checked = true;
            frmSimul.Show();
            if (frmSimul.WindowState == FormWindowState.Minimized)
                frmSimul.WindowState = FormWindowState.Normal;
            frmSimul.BringToFront();
        }

        private void toolStripMenuItemNIDAQmx_Click(object sender, EventArgs e)
        {
            selectedADC = "DAQmx";
            adcmenuAllUnchecked();
            toolStripMenuItemNIDAQmx.Checked = true;
            frmDACmx.Show();
            if (frmDACmx.WindowState == FormWindowState.Minimized)
                frmDACmx.WindowState = FormWindowState.Normal;
            frmDACmx.BringToFront();
        }

        private void Studentcontrol1_Click(object sender, EventArgs e)
        {
            frmStudContr.label18.Text = "ADC: " + selectedADC;
            frmStudContr.Show();
            if (frmStudContr.WindowState == FormWindowState.Minimized)
                frmStudContr.WindowState = FormWindowState.Normal;
            frmStudContr.BringToFront();
            controlBoxSelector = "stud";
            frmadaptcon.cbRealtimeDevice.Checked = false;
            frmadaptcon.Hide();
        }

        private void pIDMagToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmPID.Show();
            if (frmPID.WindowState == FormWindowState.Minimized)
                frmPID.WindowState = FormWindowState.Normal;
            frmPID.BringToFront();

        }

        private void tsmcRIO_Click(object sender, EventArgs e)
        {
            selectedADC = "NI cRIO";
            adcmenuAllUnchecked();
            tsmcRIO.Checked = true;
            frmcRIO.Show();
            if (frmcRIO.WindowState == FormWindowState.Minimized)
                frmcRIO.WindowState = FormWindowState.Normal;
            frmcRIO.BringToFront();
        }

        private void activeFilterToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmRTFilt.Show();
            if (frmRTFilt.WindowState == FormWindowState.Minimized)
                frmRTFilt.WindowState = FormWindowState.Normal;
            frmRTFilt.BringToFront();
        }
        private void sampleHoldToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmSH.labelADCCard.Text = selectedADC;
            frmSH.Show();
            if (frmSH.WindowState == FormWindowState.Minimized)
                frmSH.WindowState = FormWindowState.Normal;
            frmSH.BringToFront();
        }


        private void initStudControlToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmInit.Show();
        }

        private void uSBFHL10VToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "USB Orl";
            adcmenuAllUnchecked();
            uSBFHL10VToolStripMenuItem.Checked = true;
            frmusborl.Show();
            if (frmusborl.WindowState == FormWindowState.Minimized)
                frmusborl.WindowState = FormWindowState.Normal;
            frmusborl.BringToFront();
        }

        private void meilhausME4660ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "ME4660";
            adcmenuAllUnchecked();
            meilhausME4660ToolStripMenuItem.Checked = true;
            frmME4660.Show();
            if (frmME4660.WindowState == FormWindowState.Minimized)
                frmME4660.WindowState = FormWindowState.Normal;
            frmME4660.BringToFront();

        }
        private void uSBFHLOrlowski20ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            selectedADC = "USB Orl 2.0";
            adcmenuAllUnchecked();
            uSBFHLOrlowski20ToolStripMenuItem.Checked = true;
            frmusborl20.Show();
            if (frmusborl20.WindowState == FormWindowState.Minimized)
                frmusborl20.WindowState = FormWindowState.Normal;
            frmusborl20.BringToFront();

        }


        private void byoffLineLSFz1_Click(object sender, EventArgs e)
        {
            frmlsoff.Show();
            if (frmlsoff.WindowState == FormWindowState.Minimized)
                frmlsoff.WindowState = FormWindowState.Normal;
            frmlsoff.BringToFront();
        }

        private void adaptiveAdvancedControllerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmadaptcon.label18.Text = "ADC: " + selectedADC;
            frmadaptcon.Show();
            if (frmadaptcon.WindowState == FormWindowState.Minimized)
                frmadaptcon.WindowState = FormWindowState.Normal;
            frmadaptcon.BringToFront();
            controlBoxSelector = "adapt";
            frmStudContr.cbRealtimeDevice.Checked = false;
            frmStudContr.Hide();
        }

        private void dRTVersuch3PendelToolStripMenuItem_Click(object sender, EventArgs e)
        {

            frmDTRKran.label18.Text = "ADC: " + selectedADC;
            frmDTRKran.Show();
            if (frmDTRKran.WindowState == FormWindowState.Minimized)
                frmDTRKran.WindowState = FormWindowState.Normal;
            frmDTRKran.BringToFront();

        }

        private void commaInfoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmtestComma.Show();
        }

        private void ToolButton19SR_Click(object sender, EventArgs e)
        {
            fstepresp.Show();
            if (fstepresp.WindowState == FormWindowState.Minimized)
                fstepresp.WindowState = FormWindowState.Normal;
            fstepresp.BringToFront();

        }

 
        private void TSBClearLast_Click(object sender, EventArgs e)
        {
            if (minmaxMain.serie > 1)
            {
                chart2D1.clearLast();
                minmaxMain.serie--;
            }
            else
            {
                chart2D1.clearAll();
                minmaxMain.init();
            }

        }

        private void tsbClearAll_Click(object sender, EventArgs e)
        {
               chart2D1.clearAll();
                minmaxMain.init();

        }

        private void chart2D1_CoordClick(object sender, ChartTool.CoordClickEventArgs e)
        {
                EventArgs weg =new EventArgs();
                frmxwcalc.Elogw.Text = e.x.ToString();
                frmxwcalc.Elogw_Leave(sender, weg);
                frmxwcalc.textBoxDB.Text = e.y.ToString();
                frmxwcalc.textBox1_Leave(sender, weg);
        }

        private void dataLoggerDTToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmDT9062.Show();
        }

        private void fuzzyControllerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmFuzEdit.Show();
            if (frmFuzEdit.WindowState == FormWindowState.Minimized)
                frmFuzEdit.WindowState = FormWindowState.Normal;
            frmFuzEdit.BringToFront();

        }

        private void toolStripStatusLabel1_Click(object sender, EventArgs e)
        {
            info1_Click(null, null);  // show history
        }

        private void InvertedxyPendulum1_Click(object sender, EventArgs e)
        {
            frmXYPendel.Show();
            if (frmXYPendel.WindowState == FormWindowState.Minimized)
                frmXYPendel.WindowState = FormWindowState.Normal;
            frmXYPendel.BringToFront();

        }

        private void unitTRedLCDToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmUNI_T.Show();
            if (frmUNI_T.WindowState == FormWindowState.Minimized)
                frmUNI_T.WindowState = FormWindowState.Normal;
            frmUNI_T.BringToFront();
        }

 
 
 
 
      }
}