﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MPS;// Aus MultimediaTimer.dll
using System.Diagnostics;
using System.IO; // for stopwatch

namespace WINDF7CSharp.Hardwaretools
{
    public partial class FDigitalRTFilter : Form
    {
        FormMain meinMain;

        public FDigitalRTFilter(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            MMTimer1 = new TMultimediaTimer(null); // --> null means no callback invoking --> less overhead 
            //       --> less CPU load
            MMTimer1.Interval = 10;                 // --> 10ms interval
            MMTimer1.OnTimer = EventVomMMTimer;
            stopwatch.Start();

        }
        private void FormHardwareSimul_Load(object sender, EventArgs e)
        {
            butCalcFz_Click(null, null);
        }

        double dacVal0 = 0, dacVal1 = 0;

        double OutToAdc = 0;
        int _mgradcd;

        public const int max2n = 40;            //{ a,b of HF(z) }
        double[] tetacd = new double[max2n];
        double[] KT = new double[13];
        int processmodel = 0;
        double DeadZone = 0;
        string ThereisnoFilter = "There is no Filter";
        string processinput = "Process input ";
        string processoutput = "Process output ";
        string IsNonsense = "Filter together with Hardwaresimulation is nonsense";
        string SelectADC = "Please select first an ADC- card";
        TMultimediaTimer MMTimer1;

        // Digital realtime Filter  
        double sum = 0;
        double limit=10;
        const int maxgrad = 20;
        private double[] Dxein = new double[maxgrad];
        private double[] Dxout = new double[maxgrad];
        private double[] DF1 = new double[maxgrad];
        private double[] DF2 = new double[maxgrad];
        private double[] delay = new double[101];  // Array for delay shifting
        // 
        Stopwatch stopwatch = new Stopwatch();
        double stoptm, timeAvr = 0;

        double starttmMM, stoptmMM, timeAvrMM = 0, TimeMin = 0;
        int cntMM = 1,t1cnt=0;
        bool showOnce = false;



        //  Connection to control applications
        //  Manual:
        //  outputSimul() --> ProgressBar      Trackbar  --> inputSimul()
        //  Simulated process:
        //  outputSimul() --> Digital Filter  --> inputSimul()

        public void outputSimul(short chan, double val)//range -10 till +10 Volt
        {
            // The Values sent to a DACs are displayed in  progress Bars
            // these Values -val - are coming from controller
            if (chan == 0) dacVal0 = val;
            if (chan == 1) dacVal1 = val;

        }


        private void FormHardwareSimul_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            showOnce = false;
            this.Hide();
        }

        public void deutsch()
        {
            ThereisnoFilter = "Es gibt kein Filter";
            processinput = "Strecke Eingang ";
            processoutput = "Strecke Ausgang ";
            gBSimulProc.Text = "Digitales Filter, AD Eingang und DA (Ausgang) wählbar";
            groupBoxKT.Text = "Definiere K/T";
            groupBoxFz.Text = "Berechnetes F(z)";
            gBLimit.Text = "Begrenzung";
            cBLimit.Text = "Aktivieren";
            labelDuration.Text = "Mittlere Dauer: ";
            labelMinDur.Text = "kleinste Dauer:";
            toolTip1.SetToolTip(butWriteToProcess, "Aktiviere geänderte Daten");
            butWriteToProcess.Text = "Schreibe zur Strecke";
            butCopyFromDF.Text = "Hole aus Digitalen Filter";
            toolTip1.SetToolTip(Btofz,"Speichere F(z) in eine *.fz- Datei");
            toolTip1.SetToolTip(Bfztodf,"Lade *.fz- Datei und ggf errechne die K-T- Werte");
            butCalcFz.Text="Berechne Fz";
            IsNonsense = "Filter zusammen mit Hardwaresimulation ist doch wohl Blödsinn";
            SelectADC = "Bitte zuerst ADC- Karte wählen";
            label1.Text = "Gewählte Karte: ";
        }


 
        private void timer1_Tick(object sender, EventArgs e)
        {   // Display each 100ms
            t1cnt++;
            if (dacVal0 > 10) dacVal0 = 10;
            if (dacVal0 < -10) dacVal0 = -10;
            if (dacVal1 > 10) dacVal1 = 10;
            if (dacVal1 < -10) dacVal1 = -10;
            tSLab1.Text = processinput + dacVal0.ToString("F2") + processoutput + OutToAdc.ToString("F2")+ "  "+(t1cnt/10).ToString();
            if (cntMM > 0)
            {
                labelPeriod.Text = (timeAvrMM / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelDurationTime.Text = (timeAvr / cntMM / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                labelMinDurNb.Text = (TimeMin / (float)Stopwatch.Frequency * 1000.0).ToString("F4") + " msec";
                timeAvrMM = 0;
                timeAvr = 0;
                cntMM = 0;
                TimeMin = 1e10;
            }

        }

        private void FormHardwareSimul_VisibleChanged(object sender, EventArgs e)
        {
            timer1.Enabled = this.Visible; //only running if Form is visible
        }

       void tetatocell()
        {
            int i;
            dataGridView1.RowCount = 0;
            dataGridView1.Rows.Add("1", tetacd[_mgradcd + 1].ToString("G8")); /*b0*/
            dataGridView1.Rows[0].HeaderCell.Value = "0";
            for (i = 1; i <= _mgradcd; i++)
            {
                dataGridView1.Rows.Add(tetacd[i].ToString("G8"), tetacd[_mgradcd + 1 + i].ToString("G8")); /*bi*/
                dataGridView1.Rows[i].HeaderCell.Value = i.ToString();
            } /*for (*/


        }
        private void butCalcFz_Click(object sender, EventArgs e)
        {
            if (rB2PT1.Checked)
            {
                processmodel = 0;
                _mgradcd = 2;
                meinMain.ConvertToDouble(par3.Text,ref KT[2] );
            }
            if (rBIT1.Checked)
            {
                processmodel = 1;
                _mgradcd = 2;
                meinMain.ConvertToDouble(par3.Text,ref DeadZone );
                KT[2] = 0;
            }
            if (rBPT1.Checked)
            {
                processmodel = 2;
                KT[2] = 0;
                _mgradcd = 1;
            }
            if (rBPT2.Checked)
            {
                processmodel = 3;
                meinMain.ConvertToDouble(par3.Text,ref KT[2] );
                _mgradcd = 2;
            }
            if (!rBFz.Checked)
            {
                meinMain.ConvertToDouble(par1.Text,ref KT[0]);
                meinMain.ConvertToDouble(par2.Text,ref KT[1] );
                meinMain.ConvertToDouble(SpEdpT0.Text, ref KT[3]);
                KT[3] = KT[3] *1e-3;
                meinMain.datatools.kttoteta(processmodel, KT, ref tetacd);
                this.degreen.Value = _mgradcd;
                tetatocell();
                groupBoxKT.Visible = true;
                butCopyFromDF.Visible = false;
                degreen.Enabled = false;
            }
            ReadDataGridToFilter();

        }

        private void rB2PT1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "T2";
            lpar3.Visible = true;
            par3.Visible = true;
        }


        private void rBPT1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "";
            par3.Visible = false;
        }

        private void rBIT1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "T1";
            lpar3.Text = "DZ";  //Dead Zone
            par3.Visible = true;
        }

        private void rBPT2_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
            lpar2.Text = "d";
            lpar3.Text = "wo";
            par3.Visible = true;
        }

        private void rBFz_Click(object sender, EventArgs e)
        {
            groupBoxKT.Visible = false;
            butCopyFromDF.Visible = true;
            degreen.Enabled = true;
        }

        private void Bkup_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par1.Text, ref help);
            par1.Text = ( help* 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void Bkdown_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par1.Text, ref help);
            par1.Text = (help / 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnkminus_Click(object sender, EventArgs e)
        {
            double help=0;
            meinMain.ConvertToDouble(par1.Text, ref help);
            par1.Text = (-help).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt1up_Click(object sender, EventArgs e)
        {
             double help=0;
            meinMain.ConvertToDouble(par2.Text, ref help);
           par2.Text = (help * 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt1down_Click(object sender, EventArgs e)
        {
             double help=0;
            meinMain.ConvertToDouble(par2.Text, ref help);
            par2.Text = (help / 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt1minus_Click(object sender, EventArgs e)
        {
             double help=0;
            meinMain.ConvertToDouble(par2.Text, ref help);
            par2.Text = (-help).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt2up_Click(object sender, EventArgs e)
        {
             double help=0;
            meinMain.ConvertToDouble(par3.Text, ref help);
            par3.Text = (help * 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void BitBtnt2down_Click(object sender, EventArgs e)
        {
              double help=0;
            meinMain.ConvertToDouble(par3.Text, ref help);
           par3.Text = (help / 2.0).ToString("G8");
            butCalcFz_Click(sender, e);
        }

        private void SpEdpT0_ValueChanged(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
        }

        private void tabControl1_Click(object sender, EventArgs e)
        {
            butCalcFz_Click(sender, e);
        }

        private void butCopyFromDF_Click(object sender, EventArgs e)
        {
            if (meinMain.fdigfilt.Dmgrad == 0)
                MessageBox.Show(ThereisnoFilter);
            else
            {
                degreen.Value = meinMain.fdigfilt.Dmgrad;

                for (int i = 0; i <= degreen.Value; i++)
                { // copy datagrid
                    dataGridView1.Rows[i].Cells[0].Value = meinMain.fdigfilt.dataGridView1.Rows[i].Cells[1].Value;
                    dataGridView1.Rows[i].Cells[1].Value = meinMain.fdigfilt.dataGridView1.Rows[i].Cells[2].Value;
                }
            }
        }

        private void degreen_ValueChanged(object sender, EventArgs e)
        {
            dataGridView1.RowCount = (int)degreen.Value + 1;
            for (int i = 0; i <= degreen.Value; i++)
            {
                dataGridView1.Rows[i].HeaderCell.Value = (i).ToString();
            }
        }

        private void ReadDataGridToFilter()
        {
            meinMain.ConvertToDouble(dataGridView1.Rows[0].Cells[1].Value.ToString(),ref DF2[0] );//bo 
            for (int i = 1; i <= degreen.Value; i++)
            {
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[0].Value.ToString(),ref DF1[i] );//ai 
                meinMain.ConvertToDouble(dataGridView1.Rows[i].Cells[1].Value.ToString(),ref DF2[i] );//bi 
            }
            butWriteToProcess.Visible = false;
        }



        private void Filterstep()
        {
            int i = 0;
            int Dmgrad = (int)degreen.Value;
            double help = 0; ;

            // Now filter calculation
            for (i = Dmgrad + 1; i >= 2; i--)    /* shifting */
            {
                Dxout[i] = Dxout[i - 1];
                Dxein[i] = Dxein[i - 1];
            }
            Dxout[1] = sum; sum = 0;

            meinMain.ADCinput((short)nudChanAD.Value, ref help);  // Filter Input ADC
            Dxein[1] = help; // Filter Input from Output function
            if (Math.Abs(dacVal0) < DeadZone)
                Dxein[1] = 0;


            sum = DF2[0] * Dxein[1];      /* b0*xein(n) */
            for (i = 1; i <= Dmgrad; i++)
            {
                sum = sum - DF1[i] * Dxout[i];      /*-ai*old outputs */
                sum = sum + DF2[i] * Dxein[i + 1];    /*+bi*inputs */
            }

            // limitation   
            if (cBLimit.Checked)
            {
                if (sum > limit) sum = limit;
                if (sum < -limit) sum = -limit;
            }
            // Shifting for delay
            for (int id = delay.Length - 1; id > 0; id--)
                delay[id] = delay[id - 1];
            delay[0] = sum;
            int indexout = (int)nuDDelay.Value;
            meinMain.DACoutput((short)nudChanDA.Value, delay[indexout]);  // Signal out to DAC
        }
        

        void EventVomMMTimer(TMultimediaTimer sender)
        {
            double duration;
            starttmMM = stoptmMM;
            stoptmMM = stopwatch.ElapsedTicks;
            timeAvrMM += (stoptmMM - starttmMM);  // Period
            cntMM++;

            Filterstep();

            stoptm = stopwatch.ElapsedTicks;
            duration = stoptm - stoptmMM;// Duration
            timeAvr += duration;
            if (duration < TimeMin) TimeMin = duration; // look for minimal duration time
        }

        private void butStart_Click(object sender, EventArgs e)
        {

            MMTimer1.Interval = (uint)SpEdpT0.Value;
            butStart.Enabled = false;
            butStop.Enabled = true;

            ReadDataGridToFilter();
            // Clear Filter Array
            for (int i = 0; i < maxgrad; i++)
            {
                Dxein[i] = 0;
                Dxout[i] = 0;
            }
            for (int id = 0; id < delay.Length; id++) delay[id] = 0;
            MMTimer1.Enable();
        }

        private void butStop_Click(object sender, EventArgs e)
        {
            butStart.Enabled = true;
            butStop.Enabled = false;
            MMTimer1.Disable();
        }

        private void cBLimit_CheckedChanged(object sender, EventArgs e)
        {
            if (cBLimit.Checked)
            {
                tBLimit.Visible = true;
                labelLimit.Visible = true;
                meinMain.ConvertToDouble(tBLimit.Text,ref limit );
            }
            else
            {
                tBLimit.Visible = false;
                labelLimit.Visible = false;
            }
        }


 

        private void dataGridView1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
        {
            butWriteToProcess.Visible = true;
        }

        private void butWriteToProcess_Click(object sender, EventArgs e)
        {
            ReadDataGridToFilter();
            butWriteToProcess.Visible = false;
        }

        private void tBLimit_Leave(object sender, EventArgs e)
        {
           meinMain.ConvertToDouble(tBLimit.Text,ref  limit );
        }

        private void tBLimit_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar==0x0d) tBLimit_Leave( sender,  e);
        }

        private void Btofz_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add(tBcomment.Text);
                pList.Add(degreen.Value.ToString());

                for (int i = 1; i <= degreen.Value + 1; i++)
                {
                    pList.Add(dataGridView1.Rows[i - 1].Cells[0].Value + " "
                        + dataGridView1.Rows[i - 1].Cells[1].Value);
                }
                double tohelp = 0;
                meinMain.ConvertToDouble(SpEdpT0.Text, ref tohelp);
                pList.Add((tohelp / 1000.0).ToString());  // in edto in msec, in file in sec
                pList.Add("0");  // no integer delay n*T0
                pList.Add("0"); // no continuous delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }

        }

        private void Bfztodf_Click(object sender, EventArgs e)
        {
            // Load *fz file, fill datastringgrid and try to convert into Pt1, It1 or 2PT1
            List<String> pList = new List<String>();
            double t0=0;
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamReader filestream = new StreamReader(openFileDialog1.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    if (line != null)
                    {
                        pList.Add(line);
                    }
                }
                filestream.Close();
                //copyList2DigitalFilterForm(pList);   copy from DigitalFilter
                int i;
                int len = pList.Count;
                string[] outstr = new string[10];
                tBcomment.Text = pList[0];
                tBcomment.Visible = true;
                int Dmgrad = Convert.ToInt32(pList[1]);
                degreen.Value = Dmgrad;

                tetacd.Initialize();
                if ((Dmgrad + 4) > len) MessageBox.Show(meinMain.fdigfilt.wrongfileformat);
                else
                {
                    meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');  // a0, b0
                    dataGridView1.Rows[0].Cells[0].Value = outstr[0] ;  //a0
                    dataGridView1.Rows[0].Cells[1].Value = outstr[1] ;  //a0

                     meinMain.ConvertToDouble(outstr[1],ref tetacd[Dmgrad + 1]);  // b0

                    for (i = 3; i <= (Dmgrad + 2); i++)
                    {
                        meinMain.datatools.Str2NString(pList[i], ref outstr, ' ');
                        dataGridView1.Rows[i - 2].Cells[0].Value = outstr[0] ;
                        meinMain.ConvertToDouble(outstr[0],ref tetacd[i - 2] );  //ai
                        dataGridView1.Rows[i - 2].Cells[1].Value = outstr[1] ;
                        meinMain.ConvertToDouble(outstr[1],ref tetacd[i - 1 + Dmgrad] );  //bi
                    }
                     meinMain.ConvertToDouble(pList[i],ref t0 );
                    SpEdpT0.Text = (t0 * 1000).ToString("G16");  // in edt0 in msec, in File in sec
                    //if (len > i + 2)  // some files contains  continuous delay
                    //    if (pList[i + 2] != "") edtt.Text = pList[i + 2];
                }
                rBFz.Checked = true;  // switch to Fz
                double _K = 0, _T1 = 0, _T2 = 0;
                string Typ = "", error = "";
                meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0, tetacd, Dmgrad, ref Typ, ref error);
                labelType.Text = "Type=  " + Typ;
                par1.Text = _K.ToString("G8");
                par2.Text = _T1.ToString("G8");
                par3.Text = _T2.ToString("G8");

                if (Typ == "PT1")
                {
                    rBPT1.Checked = true;
                    rBPT1_Click(sender, e);
                }
                if (Typ == "2PT1")
                {
                    rB2PT1.Checked = true;
                    rB2PT1_Click(sender, e);
                }
                if (Typ == "IT1")
                {
                    rBIT1.Checked = true;
                    rBIT1_Click(sender, e);
                }
                if (Typ == "PT2")
                {
                    rBPT2.Checked = true;
                    rBPT2_Click(sender, e);
                }
            }

        }

        private void FDigitalRTFilter_Activated(object sender, EventArgs e)
        {
            label4.Text = meinMain.selectedADC;
            if ((meinMain.selectedADC == "HW- Simul") && (!showOnce))
            {
                showOnce = true;
                MessageBox.Show(IsNonsense);
            }
            if ((meinMain.selectedADC == "no card") && (!showOnce))
            {
                showOnce = true;
                MessageBox.Show(SelectADC);
            }
            label4.Text = meinMain.selectedADC;
        }

    }
}
