using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace USBOrlowskiDLL
{
    public partial class FormUSBOrl : Form
    {

        Stopwatch stw = new Stopwatch(); 

        public FormUSBOrl()
        {
            InitializeComponent();
            stw.Start();
        }  //[In, MarshalAs(UnmanagedType.LPStr)]
        [DllImport("Kernel32.dll",CharSet=CharSet.Auto, SetLastError=true)]
        internal extern static IntPtr LoadLibrary(string fn);

        [DllImport("USBCardFH2.dll", CallingConvention = CallingConvention.Cdecl)]
        public extern static bool _Init();

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal1Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal2Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal3Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal4Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal5Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal6Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal7Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetKanal8Bereich(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetAnalogOut1(ushort a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetAnalogOut2(ushort a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _SetMode(byte a);

        [DllImport("USBCardFH2.dll")]
        public extern static bool _RealtimeData(ref float x);
        
        float [] buf = new float [8];
        /*
         * Inhalt der DLL USBCardFH2.dll
        enum TMode {StartRealtime=2, Ready=3};
        enum TRange {off=0, bip1_4V=1, bip2_2V=2, unip1_4V=3, unip2_2V=4};
        enum TRangeINA {ch1_off=0, bip1_800mV=1, bip2_400mV=2, bip3_200mV=3, bip4_100mV=4, bip5_50mV=5, bip6_25mV=6,
                  unip1_800mV=7, unip2_400mV=8, unip3_200mV=9, unip4_100mV=10, unip5_50mV=11, unip6_25mV=12};
        enum TKanalwahl {Kanal1 = 1, Kanal2 = 2, Kanal3 = 3, Kanal4 = 4, Kanal5 = 5, Kanal6 = 6, Kanal7 = 7, Kanal8 = 8};


        extern "C"__declspec(dllexport) bool Init();
        extern "C"__declspec(dllexport) bool SetMode(TMode);
        extern "C"__declspec(dllexport) bool SetDigitalOut_Byte(unsigned char);
        extern "C"__declspec(dllexport) bool SetDigitalOut_Port(unsigned char, bool);
        extern "C"__declspec(dllexport) bool GetDigitalIn_Byte(unsigned char*);
        extern "C"__declspec(dllexport) bool GetDigitalIn_Port(unsigned char, bool*);
        extern "C"__declspec(dllexport) bool SetAnalogOut1(unsigned short);
        extern "C"__declspec(dllexport) bool SetAnalogOut2(unsigned short);
        extern "C"__declspec(dllexport) bool SetKanal1Bereich(TRangeINA);
        extern "C"__declspec(dllexport) bool SetKanal2Bereich(TRange);
        extern "C"__declspec(dllexport) bool SetKanal3Bereich(TRange);
        extern "C"__declspec(dllexport) bool SetKanal4Bereich(TRange);
        extern "C"__declspec(dllexport) bool SetKanal5Bereich(TRange);
        extern "C"__declspec(dllexport) bool SetKanal6Bereich(TRange);
        extern "C"__declspec(dllexport) bool SetKanal7Bereich(TRange);
        extern "C"__declspec(dllexport) bool SetKanal8Bereich(TRange);
        extern "C"__declspec(dllexport) bool RealtimeData(float Buffer[]);
         */

        bool OK = false;
        private void buttoninit_Click(object sender, EventArgs e)
        {
            OK = _Init();
            // Kanal 3-8:bip1_4V=1
            // Kanal 1+2 :bip1_800mV=1
            if (OK)
            {
                _SetKanal1Bereich(1);
                _SetKanal2Bereich(1);
                _SetKanal3Bereich(1);
                _SetKanal4Bereich(1);
                _SetKanal5Bereich(1);
                _SetKanal6Bereich(1);
                _SetKanal7Bereich(1);
                _SetKanal8Bereich(1);
                _SetMode(2);          //StartRealtime=2
                groupBoxTimeronoff.Enabled = true;
                buttoninit.Enabled = false;
                numericUpDown1.Enabled = true;
                numericUpDown2.Enabled=true;
                numericUpDown1_ValueChanged(null, null);
                numericUpDown2_ValueChanged(null, null);

            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            double fak;
            string form, Unit;
            if (rBOriginal.Checked)
            {
                fak = 1;
                form = "F0";
                Unit = " mV";
            }
            else
            {
                fak = 10.0 / 4096.0;
                form = "F3";
                Unit = " V";
            }
            long start = stw.ElapsedTicks;
            _RealtimeData(ref buf[0]);         // Abholen der Messwerte;
            long ende = stw.ElapsedTicks;
            tSSLabel1.Text = "ADC :"+((ende - start) / (float)Stopwatch.Frequency * 1000.0).ToString("f3") + " ms";
            label2.Text = "Ua= " + (buf[1] * fak).ToString(form) + Unit;
            label3.Text = "Ua= " + (buf[2] * fak).ToString(form) + Unit;
            label4.Text = "Ua= " + (buf[3] * fak).ToString(form) + Unit;
            label5.Text = "Ua= " + (buf[4] * fak).ToString(form) + Unit;
            label6.Text = "Ua= " + (buf[5] * fak).ToString(form) + Unit;
            label7.Text = "Ua= " + (buf[6] * fak).ToString(form) + Unit;
            start = stw.ElapsedTicks;
            _SetAnalogOut1(Ua1);   // Einstellen einer Spannung in mV am D/A-Ausgang 1

            ende = stw.ElapsedTicks;
            tSSLabel2.Text = "    DAC :" + ((ende - start) / (float)Stopwatch.Frequency * 1000.0).ToString("f3") + " ms";
            if (this.WindowState == FormWindowState.Minimized) rBTTOff.Checked = true;
            // Switch off if Minimized


        }
        ushort Ua1;

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            // nur gltig fr USB Karte mit anschlieenden OP Amp Treibern.
            // Original-ADC hat nur 0 bis 4095 mV

            double U = (double)numericUpDown1.Value,temp;  // U in Volt
            if (rBOriginal.Checked)
                temp = U;
            else
                temp = ((U + 10.0) * 4095.0 / 20.0);

            Ua1 = (ushort)Convert.ToUInt32(temp);
            _SetAnalogOut1(Ua1);   // Einstellen einer Spannung in mV am D/A-Ausgang 1
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            // nur gltig fr USB Karte mit anschlieenden OP Amp Treibern.
            // Original-ADC hat nur 0 bis 4095 mV

            double U = (double)numericUpDown2.Value,temp;  // U in Volt
            if (rBOriginal.Checked)
                temp = U;
            else
                temp = ((U + 10.0) * 4095.0 / 20.0);
            ushort Ua2 = (ushort)Convert.ToUInt32(temp);
            _SetAnalogOut2(Ua2);   // Einstellen einer Spannung in mV am D/A-Ausgang 1
        }

        private void rBOriginal_CheckedChanged(object sender, EventArgs e)
        {
            if (rBOriginal.Checked)
            {
                numericUpDown1.Maximum = 4096;
                numericUpDown1.Increment = 100;
                numericUpDown1.Minimum = 0;
                numericUpDown2.Maximum = 4096;
                numericUpDown2.Increment = 100;
                numericUpDown2.Minimum = 0;
                label1.Text = " mV";
                label8.Text = " mV";
            }
            else
            {
                numericUpDown1.Maximum = 10;
                numericUpDown1.Increment = 1;
                numericUpDown1.Minimum = -10;
                numericUpDown2.Maximum = 10;
                numericUpDown2.Increment = 1;
                numericUpDown2.Minimum = -10;
                label1.Text = " V";
                label8.Text = " V";
            }

        }

        private void FormUSBOrl_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            timer1.Enabled = false;
            rBTTOff.Checked = true;
        }

        public void inputOrl(short chan, ref double val)
        {
            double fak;
            if (OK)_RealtimeData(ref buf[0]);         // Abholen der Messwerte;
            if (rBOriginal.Checked)
            {
                fak = 1/1000.0;
            }
            else
            {
                fak = 10.0 / 4096.0;
            }

            if (chan == 0) val = buf[1] * fak;
            else val = buf[2] * fak;


        }

        public void outputOrl(short chan, double val)
        {
            double temp;
            if (rBOriginal.Checked)
            {
                if (val > 4.095) val = 4.095;
                if (val < 0) val = 0;
                temp = val * 1000;
            }
            else
            {
                if (val > 10) val = 10;
                if (val < -10) val = -10;
                temp = ((val + 10.0) * 4095.0 / 20.0);

            }
            ushort Ua2 = (ushort)Convert.ToUInt32(temp);
            if (OK)
                if (chan == 0)
                    _SetAnalogOut1(Ua2);   // Einstellen einer Spannung in mV am D/A-Ausgang 1
                else
                    _SetAnalogOut2(Ua2);   // Einstellen einer Spannung in mV am D/A-Ausgang 1

        }

        private void rBTTOff_CheckedChanged(object sender, EventArgs e)
        {
            if (rBTTOff.Checked) timer1.Enabled = false;
            else timer1.Enabled = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                LoadLibrary(openFileDialog1.FileName);
            }
        }

      

    }
}