﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO.Ports;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Threading;
using System.Collections;
using System.Windows.Forms;


namespace WINDF7CSharp
{
    public partial class UNIT_Interface_RS232 : Form
    {
        private FormMain meinMain;
        string points = "Points";
        private int cnt;
        private List<Byte> ReadBytes;
        private const double yfactordefault = 1;
        private string Values;
        string Connectionwillbecontinued = "Connection will be continued";
        string SeriaPortRS232isconnected="SeriaPort RS232 is connected";
        string Disconnect= " Disconnect ";
        string Connection="Connection";
        string NoConnection = "No Connection";
     
        public UNIT_Interface_RS232(FormMain formMain)
        {
            InitializeComponent();   // choose your SeriaPort, COM1,COM2, .....
            serialPort1.Parity = System.IO.Ports.Parity.None;
            serialPort1.StopBits = System.IO.Ports.StopBits.One;
            serialPort1.ReadBufferSize = 4096;   //4096
            serialPort1.WriteBufferSize = 2048;
            serialPort1.Encoding = Encoding.Default;
            progressBar1.Visible = false;
            cbPort.SelectedItem = cbPort.Items[0];
            cbBaudrate.SelectedItem = cbBaudrate.Items[2];
            this.meinMain = formMain;
        }

        public void deutsch()
        {


        }
        
        private void Form1_Load(object sender, EventArgs e)
        {
        }

  
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
            serialPort1.Close();
            open=false;
        }


        private void buttonCheckport_Click(object sender, EventArgs e)
        {
            cbPort.Items.Clear();
            foreach (string s in SerialPort.GetPortNames())
            {
                cbPort.Items.Add(s);
            }
            cbPort.SelectedItem = cbPort.Items.Count > 0 ? cbPort.Items[0] : " ";
        }

        bool open=false;

        private void btn_Connection_Click(object sender, EventArgs e)
        {

            if (comboBox3.Text == "RS232" && !open)
            {
                MessageBox.Show(Connectionwillbecontinued, "Message.....", MessageBoxButtons.OK);
                toolStripStatusLabel1.Text = SeriaPortRS232isconnected;
                btn_Connection.Text = Disconnect;
                serialPort1.PortName = cbPort.SelectedItem.ToString();
                serialPort1.BaudRate = Convert.ToInt32(cbBaudrate.SelectedItem);
                cbPort.Enabled = false;
                cbBaudrate.Enabled = false;
                serialPort1.Open();
                open=true;
            }
            else
            {
                btn_Connection.Text = Connection;
                MessageBox.Show("Please choose your device !", "Error ", MessageBoxButtons.OK);
                toolStripStatusLabel1.Text =  NoConnection;
                progressBar1.Enabled = false;
                timer2.Enabled = false;
                textBox1.Clear();
                textBox2.Clear();
                Button_Convert_Channel1.Text = "Convert Channel 1";
                Button_Convert_Channel2.Text = "Convert Channel 2";
                textBox3.Text = "   Voltage     mv/Div ";
                textBox4.Text = "   Time        ms/Div ";
                textBox5.Text = "   Voltage     mv/Div ";
                textBox6.Text = "   Time        ms/Div ";
                cbPort.Enabled = true;
                cbBaudrate.Enabled = true;
                serialPort1.Close();
                open=false;
            }
        }



        private void Get_Data_Click(object sender, EventArgs e)
        {
            ReadBytes = new List<byte>();
            progressBar1.Value = 0;
            progressBar1.Maximum = 2569;

            if (!serialPort1.IsOpen)
            {
                MessageBox.Show(" No data now , Please check your Connection ! ", "Message.....");
            }
            else
            {
                serialPort1.Write("\x06");//\x-Hexadezimale Escape-Zeichen
                cnt = 0;
                Get_Data.Enabled = false;

                if (timer2.Enabled)
                    timer2.Enabled = false;
                else
                    timer2.Enabled = true;
            }
        }


        private void Clear_Data_Click(object sender, EventArgs e)
        {
            ReadBytes.Clear();

            Get_Data.Enabled = true;
            timer2.Enabled = false;
            progressBar1.Visible = false;
            textBox1.Clear();
            textBox2.Clear();

            textBox3.Text = "   Voltage     mV/Div ";
            textBox4.Text = "   Time        ms/Div ";
            textBox5.Text = "   Voltage     mV/Div ";
            textBox6.Text = "   Time        ms/Div ";
        }



        private void timer2_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = DateTime.Now.ToString();//  to see that timer running.

            if ((serialPort1.IsOpen) && (serialPort1.BytesToRead > 0))
            {
                progressBar1.Visible = true;

                for (int i = 0; i < serialPort1.BytesToRead; i++)
                {
                    int c = serialPort1.ReadByte();
                    ReadBytes.Add((byte)c);
                    cnt++;
                }

                if (cnt > 2569)
                    this.progressBar1.Maximum = 5069;

                StatusLabel4.Text = "In progress";
                this.progressBar1.Value = cnt;
                toolStripStatusLabel3.Text = (cnt - 69).ToString();
            }
            else if ((serialPort1.IsOpen) && (serialPort1.BytesToRead <= 0))
            {
                StatusLabel4.Text = "Finish";

            }
        }


  // Convert------------------------------------------------------
        double yfactor = 0;
        double tfactor = 0;


        private void Button_Convert_Channel1_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabControl1.TabPages[0];
            Values = String.Empty;
            if (serialPort1.IsOpen == false)
            {
                MessageBox.Show(" No data now , Please check your Connection ! ", "Message.....");
            }
            else if ((Button_Convert_Channel1.Text == "Convert Channel 1") && (ReadBytes.Count > 20) &&((ReadBytes[3] == 0x01) || (ReadBytes[3] == 0x03)))
            {

                int nb = 2568;
                StatusLabel4.Text = "In progress";
                progressBar1.Enabled = true;
                this.progressBar1.Value = 0;
                progressBar1.Maximum = 2569 - 69;

                Scale_Calculating(ref tfactor, ref yfactor, ReadBytes[0x0A], ReadBytes[0x05], 1);

                //double xAnfang = -5 * tfactor;
                double xAnfang = 0 - (ReadBytes[8] - 11 + ((ReadBytes[7] - Trigger_Position(ReadBytes[8]))/250)); 
                for (int i = nb; i >= 69; i--)    //int i = 69; i < nb; i++
                {
                    double readBytesY = ((ReadBytes[i] - (255 - ReadBytes[6])) / 23.125);// Y Achse Umrechnung(*95% Differenz)
                    Values += xAnfang.ToString() + " " + readBytesY.ToString();
                    if (i > 69)
                        Values += "\x0d" + "\x0a";
 
                    //xAnfang = xAnfang + tfactor / 250;
                    xAnfang += (1 / 250d);
                    progressBar1.Value++;
                    StatusLabel4.Text = "In progress";
                }
                StatusLabel4.Text = "Finish";
                textBox1.Text = Values;
                
            }
        }


        private void button_Convert_Channel2_Click(object sender, EventArgs e)
        {
            tabControl1.SelectedTab = tabControl1.TabPages[1];
            int nb2;
            int firstindex;
            Values = String.Empty;

            if (serialPort1.IsOpen == false)
            {
                MessageBox.Show(" No data now , Please check your Connection ! ", "Message.....");
            }
            else if ((Button_Convert_Channel2.Text == "Convert Channel 2") && (ReadBytes.Count > 20) && ((ReadBytes[3] == 0x02) || (ReadBytes[3] == 0x03)))
            {
                nb2 = (ReadBytes[0x03] == 0x02) ? 2568 : 5068;
                firstindex = (ReadBytes[0x03] == 0x02) ? 69 : 2569;

                progressBar1.Enabled = true;
                progressBar1.Value = 0;
                progressBar1.Maximum = nb2 + 1 - firstindex;

                Scale_Calculating(ref tfactor, ref yfactor, ReadBytes[0x0A], ReadBytes[0x25], 2);

                //double xAnfang = -5 * tfactor;
                double xAnfang = 0 - (ReadBytes[8] - 11 + ((ReadBytes[7] - Trigger_Position(ReadBytes[8])) / 250));
                for (int i = nb2; i >= firstindex; i--)    //int i = 69; i < nb; i++
                {
                    double readBytesY = ((ReadBytes[i] - (255 - ReadBytes[38])) / 23.125);// Y Achse Umrechnung(*95% Differenz)   //ReadBytes[38]
                    Values += xAnfang.ToString() + " " + readBytesY.ToString();
                    if (i > firstindex)
                        Values += "\x0d" + "\x0a";
                    //xAnfang = xAnfang + tfactor / 250;
                    xAnfang += (1 / 250d);
                    progressBar1.Value++;
                }
                textBox2.Text = Values;
            }
        }



        private void btn_Save_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == false)
            {
                MessageBox.Show(" No data to save , Please check your Connection ! ", "Message.....");
            }
            else
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter myStream1 = new StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                    myStream1.WriteLine(textBox1.Text);
                    myStream1.Close();
                }
        }


        private void button_save2_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == false)
            {
                MessageBox.Show(" No data to save , Please check your Connection ! ", "Message.....");
            }
            else
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter myStream1 = new StreamWriter(saveFileDialog1.OpenFile(), Encoding.Default);
                    //myStream1.WriteLine(textBox1.Text);
                    myStream1.WriteLine(textBox2.Text);
                    myStream1.Close();
                }
        }

        private void Scale_Calculating(ref double tfactor, ref double vfactor, byte timevalue, byte ampvalue, int channel)
        {
            TextBox textboxTime;
            TextBox textboxAmplitude;

            if (channel == 1)
            {
                textboxTime = textBox4;
                textboxAmplitude = textBox3;
            }
            else
            {
                textboxTime = textBox6;
                textboxAmplitude = textBox5;
            }

            switch (ampvalue)
            {
                case 0x00: textboxTime.Text = "   2,00        mv/Div";
                    vfactor = 0.002;
                    break;
                case 0x01: textboxTime.Text = "   5,00        mv/Div";
                    vfactor = 0.005;
                    break;
                case 0x02: textboxTime.Text = "   10,0        mv/Div";
                    vfactor = 0.01;
                    break;
                case 0x03: textboxTime.Text = "   20,0        mv/Div";
                    vfactor = 0.02;
                    break;
                case 0x04: textboxTime.Text = "   50,0        mv/Div";
                    vfactor = 0.05;
                    break;
                case 0x05: textboxTime.Text = "   100,0       mv/Div";
                    vfactor = 0.1;
                    break;
                case 0x06: textboxTime.Text = "   200,0       mv/Div";
                    vfactor = 0.2;
                    break;
                case 0x07: textboxTime.Text = "   500,0       mv/Div";
                    vfactor = 0.5;
                    break;
                case 0x08: textboxTime.Text = "   1,00        v/Div";
                    vfactor = 1.0;
                    break;
                case 0x09: textboxTime.Text = "   2,00        v/Div";
                    vfactor = 2.0;
                    break;
                case 0x0A: textboxTime.Text = "   5,00        v/Div";
                    vfactor = 5.0;
                    break;
                default:
                    break;
            }

            switch (timevalue)
            {
                case 0x02: textboxAmplitude.Text = "   5           ns/Div";
                    tfactor = 5e-6; //ms
                    break;
                case 0x03: textboxAmplitude.Text = "   10          ns/Div";
                    tfactor = 10e-6;
                    break;
                case 0x04: textboxAmplitude.Text = "   20          ns/Div";
                    tfactor = 20e-6;
                    break;
                case 0x05: textboxAmplitude.Text = "   50          ns/Div";
                    tfactor = 50e-6;
                    break;
                case 0x06: textboxAmplitude.Text = "   100,0       ns/Div";
                    tfactor = 100e-6;
                    break;
                case 0x07: textboxAmplitude.Text = "   200,0       ns/Div";
                    tfactor = 200e-6;
                    break;
                case 0x08: textboxAmplitude.Text = "   500,0       ns/Div";
                    tfactor = 500e-6;
                    break;
                case 0x09: textboxAmplitude.Text = "   1,00        µs/Div";
                    tfactor = 1e-3;
                    break;
                case 0x0A: textboxAmplitude.Text = "   2,00        µs/Div";
                    tfactor = 2e-3;
                    break;
                case 0x0B: textboxAmplitude.Text = "   5,00        µs/Div";
                    tfactor = 5e-3;
                    break;
                case 0x0C: textboxAmplitude.Text = "   10,0        µs/Div";
                    tfactor = 10e-3;
                    break;
                case 0x0D: textboxAmplitude.Text = "   20,0        µs/Div";
                    tfactor = 20e-3;
                    break;
                case 0x0E: textboxAmplitude.Text = "   50,0        µs/Div";
                    tfactor = 50e-3;
                    break;
                case 0x0F: textboxAmplitude.Text = "   100,0       µs/Div";
                    tfactor = 100e-3;
                    break;
                case 0x10: textboxAmplitude.Text = "   200,0       µs/Div";
                    tfactor = 200e-3;
                    break;
                case 0x11: textboxAmplitude.Text = "   500,0       µs/Div";
                    tfactor = 500e-3;
                    break;
                case 0x12: textboxAmplitude.Text = "   1,0         ms/Div";
                    tfactor = 1.0;
                    break;
                case 0x13: textboxAmplitude.Text = "   2,0         ms/Div";
                    tfactor = 2.0;
                    break;
                case 0x14: textboxAmplitude.Text = "   5,0         ms/Div";
                    tfactor = 5.0;
                    break;
                case 0x15: textboxAmplitude.Text = "   10,0        ms/Div";
                    tfactor = 10.0;
                    break;
                case 0x16: textboxAmplitude.Text = "   20,0        ms/Div";
                    tfactor = 20.0;
                    break;
                case 0x17: textboxAmplitude.Text = "   50,0        ms/Div";
                    tfactor = 50.0;
                    break;
                case 0x18: textboxAmplitude.Text = "   100,0       ms/Div";
                    tfactor = 100.0;
                    break;
                case 0x19: textboxAmplitude.Text = "   200,0       ms/Div";
                    tfactor = 200.0;
                    break;
                case 0x1A: textboxAmplitude.Text = "   500,0       ms/Div";
                    tfactor = 500.0;
                    break;
                case 0x1B: textboxAmplitude.Text = "   1,00        s/Div";
                    tfactor = 1e3;
                    break;
                case 0x1C: textboxAmplitude.Text = "   2,00        s/Div";
                    tfactor = 2e3;
                    break;
                case 0x1D: textboxAmplitude.Text = "   5,00        s/Div";
                    tfactor = 5e3;
                    break;
                case 0x1E: textboxAmplitude.Text = "   10,0        s/Div";
                    tfactor = 10e3;
                    break;
                case 0x1F: textboxAmplitude.Text = "   20,0        s/Div";
                    tfactor = 20e3;
                    break;
                case 0x20: textboxAmplitude.Text = "   50,0        s/Div";
                    tfactor = 50e3;
                    break;
                default:
                    break;
            }
        }


        private double Trigger_Position(byte div_pos)
        {
            double time_begin = 0;
            switch (div_pos)
            {
                case 12 :
                    time_begin = 24;
                    break;
                case 13:
                    time_begin = 8;
                    break;
                case 14:
                    time_begin = 2;
                    break;
                case 15:
                    time_begin = 6;
                    break;
                case 16:
                    time_begin = 0;
                    break;
                case 17:
                    time_begin = 250;
                    break;
                case 18:
                    time_begin = 8;
                    break;
                case 19:
                    time_begin = 2;
                    break;
                case 20:
                    time_begin = 6;
                    break;
            }
            return time_begin;
        }

        private void button_draw_1_Click(object sender, EventArgs e)
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = false;
            LOa.toptitle = "Scope curve " + textBox1.Lines.Length.ToString() + "  " + points;
            //LOa.bottomtitle = "<------     w=10^x     ---->";
            LOa.legend = "Scope channel 1 Div/time";
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBox1, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton27ScopeF.Enabled = true;
                meinMain.BringToFront();
            }
        }

        private void button_draw_2_Click(object sender, EventArgs e)
        {
            LoadOpt LOa = new LoadOpt();
            LOa.init();
            LOa.XaxisLog = false;
            LOa.toptitle = "Scope curve  " + textBox2.Lines.Length.ToString() + "  " + points;
            //LOa.bottomtitle = "<------     w=10^x     ---->";
            LOa.legend = "Scope channel 2 Div/time";
            int a = meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, textBox2, ref meinMain.minmaxMain, LOa);
            meinMain.enableCurveButtons();
            if (a > 0) MessageBox.Show(meinMain.errorConvert + a.ToString());
            else
            {
                meinMain.enableCurveButtons();
                meinMain.ToolButton27ScopeF.Enabled = true;
                meinMain.BringToFront();
            }
        }       
    }

}
        

       
       

       

       
