﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Globalization;
using System.Drawing.Printing;
using HelpRegression;
using WINDF7CSharp;
using matinvert;
using MPS;                           //using multimediatimer
using System.Diagnostics;  // Stopwatch

namespace idregress
{
    public partial class F_Regress : Form
    {
        frmLoadOptions frmLO;
        FHelpRegression fhelp;
        matinvert1 matinve;
        TMultimediaTimer MMTimer1;
        Stopwatch stopwatch1 = new Stopwatch();

        SaveFileDialog sfd = new SaveFileDialog();

        FormMain meinMain;
        public double[] xa = new double[3000];    // process output val
        double stepAmplitude = 0;
        int iRtc = 0;  // Counter for SR Measurement

        public F_Regress(FormMain m)
        {
            InitializeComponent();
            meinMain = m;
            frmLO = new frmLoadOptions(m);
            fhelp = new FHelpRegression();
            matinve = new matinvert1();
            TabControl.SelectedIndex = 1;
            errorfile = "error in file reading : ";
            NoScopeData = "No Scope Data available";
            NoRTCData = "No RTC Data available";
            toolinear = "PT1-step response is too linear!!";
            noresult = "No result for initial values";
            simulateddata = "Simulated Data";
            identdata = "Curve of Ident Model";
            pts = "Points";
            Simulated = "Simulated";
            Strsteps = " steps";
            Identified = "Identified";
            Imported = "imported";
            Rnocurve = "no curve";
            readscopeData = "Read scope Data";
            MeasureSR = "Measure SR";
            progress = "Progress= ";
            cvs = "Curves"; conversionimpossible = "bode-conversion impossible";
            //flashimpossible="flash design impossible, because Tdel is not 0" ;  inunit flash
            SRLSOFF = "Simul Step Resp.";
            numPoints.Maximum = (decimal)xa.Length;
            MMTimer1 = new TMultimediaTimer(null);
            MMTimer1.OnTimer = EventVomMMTimer;
            stopwatch1.Start();
            stepAmplitude = (double)(nUDVas.Value - nUDVbs.Value);

            this.chart2D1.AutoScaleButton = true;
            this.chart2D1.BackColorButton = true;
            this.chart2D1.ButtonPanel = true;
            this.chart2D1.ColorBlackButton = true;
            this.chart2D1.EditorButton = true;
            this.chart2D1.InfoButton = true;
            this.chart2D1.LegendButton = true;
            this.chart2D1.LoadButton = true;
            this.chart2D1.PenScaleButton = true;
            this.chart2D1.PrintButton = true;
            this.chart2D1.SaveButton = true;
            this.chart2D1.ScallingButton = true;
            this.chart2D1.TitleButton = true;
            this.chart2D1.XGridButton = true;
            this.chart2D1.YGridButton = true;
            this.chart2D1.ZoomButton = true;


        }

        int itzahl = 0; 
        const int rcnvaluesmax=32767;

        const int maxpar = 20;  //aus matinv.h 400-1            
        const double deltapmax = 0.1;  // Max rel. Change
        string regrtyp, simtyp, simulateddata, pts, cvs, toolinear, noresult, identdata;
        string Rnocurve, conversionimpossible, Simulated, Strsteps,
               Identified, Imported, NoScopeData,NoRTCData, readscopeData;
        string SRLSOFF, MeasureSR, progress;

        public int anzparam=0, anzpunkte=0, itact=0;
        private int nbDisPar = 4;  // Number of displayed parameters ident

        public double xmaxR = 0, xminR = 0, ymaxR = 0, yminR = 0, sumproz = 0, sumR = 0, deltasum = 0;
        double[] parameter = new double[maxpar];  //Vector ident parameter
        double[] q = new double[maxpar];
        double[,] ata = new double[maxpar,maxpar]; 
        double [] tvalues=new double[rcnvaluesmax];

        //extern double kpt1,tpt1,kpt2,wopt2,dpt2,k2pt1,t12pt1,t22pt1,kit1,tit1,tzaf;
        String errorfile;
        
        

        CHMinMax minmaxRegr = new CHMinMax();

        LoadOpt LOregr = new LoadOpt();

        public void deutsch()
        {
            toolinear = "PT1-Sprungantwort ist zu linear";
            errorfile = "error in file reading : ";

            noresult = "Anfangswertbestimmung geht nicht";
            conversionimpossible = "Bode-Konversion nicht möglich";
            //flashimpossible="Blitzregler ist nicht möglich, da Tdel ist nicht 0" ;
            Simulated = "simuliert";
            Strsteps = " Schritte";
            Identified = "identifiziert";
            Imported = "importiert";
            Rnocurve = "Keine Kurve";
            readscopeData = "Scope Daten";
            tsButReadInternalVal.Text = readscopeData;

            this.Text = "Identifikation mittels Regression bei gegebener Zeitfunktion";
            ButtonOptimize.Text = "Optimierung";
            ButtonInitVal.Text = "Anfangswerte";
            OKbt1.ToolTipText = "Schließe Fenster und kopiere Werte falls sinnvoll in *.ZK-Array";
            Cancelbtn2.ToolTipText = "Schließe Fenster und ignoriere Ergebnisse";
            TB15Save.ToolTipText = "Speichere ASCII Daten als  *.SIM-Datei";
            TBLoad.ToolTipText = "Lade Datei mit Messwerten für Identifikation";
            saveFileDialog1.Title = "Speichere Resultat als *.SIM-Datei";
            tSBReport.ToolTipText = "Schreibe Ergebnisse in den Report";
            //openFileDialog1.Title = "Lade Datei mit Messwerten";
            ButtonOptimize.ToolTipText = "Starte die LS-Identifikation nach Gauss-Newton";
            ButtonInitVal.ToolTipText = "Anfangswertbestimmung mit Kennwertermittlungsmethoden \n\r (siehe Vorlesung)";
            TBDrawidentcurve.ToolTipText = "Zeichne eine Kurve mit den in Ident Parameter spezifizierten Werten";
            TSCurve.Text = "Kurve";
            // ident Parameter
            toolTip1.SetToolTip(tolEdit2, "Wenn Änderungen kleiner, dann breche Iteration ab");
            toolTip1.SetToolTip(BitBtnDrawIdentCurve, "Zeichne Kurve mit den Parametern rechts");
            toolTip1.SetToolTip(maxnbit, "Maximale Anzahl der Iterationen");
            toolTip1.SetToolTip(nbofpar, "Nur diese ersten Parameter werden optimiert");
            toolTip1.SetToolTip(lssum, "Prozentualer Fehler zwischen Messung und Modell");
            label2.Text = "Modellwahl Ident.";
            label1.Text = "Max. Iter.";
            label15.Text = "Kurvenparameter";
            label4.Text = "PID Param. Bode- Form";
            label16.Text = "PID Param. Bode- Form";

            Tolerance.Text = "Toleranz";
            label3.Text = "Zahl der optimierten Parameter";

            lresults.Text = "Ergebnisse der Identifikation";
            toolTip1.SetToolTip(rbpt1, "K: Gleichspannungsverstärkung, T1: Zeitkonstante,\n\r Uoffs: Offsetspannnung und Tdel: Totzeit");
            //rbit1.ToolTipText = rbpt1.Hint;
            toolTip1.SetToolTip(rbpt2, "K: Gleichspannungsverstärkung, d: Dämpfung,\n\r wo: Eigenkreisfrequenz, Uoffs: Offsetspannnung und Tdel: Totzeit");
            toolTip1.SetToolTip(rbdt2, "K: Verstärkung, d: Dämpfung,\n\r wo: Eigenkreisfrequenz, Uoffs: Offsetspannnung und Tdel: Totzeit");
            toolTip1.SetToolTip(rbpid, "Parallelformparameter K, Td, Ti, T1");
            toolTip1.SetToolTip(rb2pt1, "K: Gleichspannungsverstärkung, T1 und T2: Zeitkonstanten,\n\rUoffs: Offsetspannnung und Tdel: Totzeit");
            toolTip1.SetToolTip(rbpoly, "Maximal 7 Koeffizienten");
            toolTip1.SetToolTip(HelpBtn1, "Informationen zu den vorbereiteten Funktionen");
            ToolButton13help.ToolTipText = "Zeige Fenster mit den Funktionen";
            rbpt1.Text = "Sprungantwort PT1";
            rbit1.Text = "Sprungantwort IT1";
            rbpt2.Text = "Sprungantwort PT2";
            rb2pt1.Text = "Sprungantwort 2PT1";
            rbpoly.Text = "Polynom";
            rbexp.Text = "Exponentialfunktion";
            rbhyp1.Text = "Hyperbel 1";
            rbhyp2.Text = "Hyperbel 2";
            rbpid.Text = "Sprungantwort PIDT1";
            rbdt2.Text = "Sprungantwort DT2 d<1";

            // simulation Par
            toolTip1.SetToolTip(enoise, "Addiert ein Rauschsignal zur simulierten Kurve");
            noise.Text = "Rauschamplitude";
            label11.Text = "Schritte";
            label15.Text = "Parameter der Kurve";
            label21.Text = "Horizontale x/T-Achse";
            label22.Text = "von";
            label23.Text = "bis";
            label24.Text = "Punktzahl";
            label25.Text = "Optimierte Param. in Aquamarine";

            toolTip1.SetToolTip(RBSpt1, "K: Gleichspannungsverstärkung, T1: Zeitkonstante,\n\r Uoffs: Offsetspannnung und Tdel: Totzeit");
            //RBSit1.ToolTipText = rbpt1.Hint;
            toolTip1.SetToolTip(RBSpt2, "K: Gleichspannungsverstärkung, d: Dämpfung,\n\r wo: Eigenkreisfrequenz, Uoffs: Offsetspannnung und Tdel: Totzeit");
            toolTip1.SetToolTip(RBSpid, "Parallelformparameter K, Td, Ti, T1");
            toolTip1.SetToolTip(RBSDt2, "K: Verstärkung, d: Dämpfung,\n\r wo: Eigenkreisfrequenz, Uoffs: Offsetspannnung und Tdel: Totzeit");
            toolTip1.SetToolTip(RBS2pt1, "K: Gleichspannungsverstärkung, T1 und T2: Zeitkonstanten,\n\r Uoffs: Offsetspannnung und Tdel: Totzeit");
            toolTip1.SetToolTip(RBSpoly, "Maximal 7 Koeffizienten");
            toolTip1.SetToolTip(HelpBtn1, "Informationen zu den vorbereiteten Funktionen");
            label14.Text = "Modellwahl Simulation";
            RBSpt1.Text = "Sprungantwort PT1";
            RBSit1.Text = "Sprungantwort IT1";
            RBSpt2.Text = "Sprungantwort PT2 d<1";
            RBS2pt1.Text = "Sprungantwort 2PT1";
            RBSpoly.Text = "Polynom";
            RBSexp.Text = "Exponentialfunktion";
            RBShyp1.Text = "Hyperbel 1";
            RBShyp2.Text = "Hyperbel 2";
            RBSpid.Text = "Sprungantwort PIDT1";
            RBSDt2.Text = "Sprungantwort DT2 d<1";
            toolTip1.SetToolTip(BBpar2bode, "Berechne Bode-Parameter Kr,Tn,Tv,st");
            toolTip1.SetToolTip(BBbode2par, "Berechne Parallelform-Parameter K,Ti,Td,T1");
            toolTip1.SetToolTip(BBpar2bodeS, "Berechne Bode-Parameter Kr,Tn,Tv,st");
            toolTip1.SetToolTip(BBbode2parS, "Berechne Parallelform-Parameter K,Ti,Td,T1");

            fhelp.Text = "Identifizierbare Funktionen";
            fhelp.label1.Text = " Die folgenden Funktionen f(t) können mit linearer Regression identifiziert werden.";
            fhelp.label2.Text = " Sie brauchen wenigstens so viele Punkte wie Parameter. Die Anzahl der optimierten ";
            fhelp.label3.Text = " Parameter kann gewählt werden und zählt von oben. Im Fall Polynom meint die Anzahl 4";
            fhelp.label4.Text = " z. B., dass a bis d optimiert werden, e,f und g aber nicht. ";
            errorfile = "Fehler beim Lesen der Datei: ";
            NoScopeData = "Keine Scope-Daten verfügbar";
            NoRTCData = "Keine Regler Daten verfügbar";
            tsbReadRTC.Text = "Hole Regler-Messung";
            tsButReadInternalVal.Text = "Hole Skope-Daten";
            SRLSOFF = "Simul Sprungantw.";
            chart2D1.Germanlanguage = true;
            tSBMeasureSR.Text = "Messung der Sprungantwort";
            tPMeasureSR.Text = "Messung der Sprungantwort";
            labelADC.Text = "Gewählte AD- Karte: ";
            label27.Text = "Punkte";
            groupBox2.Text = "Definition Sprung";
            label31.Text = "DA- Ausgang";
            label32.Text = "AD- Eingang";
            MeasureSR = "Messkurve SA";
            progress = "Fortschritt= ";
            groupBox3.Text = "Echtzeitdaten";
            buttonStep.Text = "Start Sprung";
            groupBox4.Text = "Daten AD- Karte";
            labelVaS.Text = "Volt nach Sprung";
            labelVbS.Text = "Volt vor Sprung";
        }
  
        
        
        private void initgraph( )
        {

            minmaxRegr.init();
        }

 
        
        private void F_Regress_Load(object sender, EventArgs e)
        {
            itact=0;sumproz=0;
            initgraph();
            par3.Text=(0.1).ToString("G10");
            Edit6.Text=(1.5).ToString("G10");
            Edit7.Text=(0.4).ToString("G10");
            Edit2.Text=(1.5).ToString("G10");
            Edit3.Text=(0.4).ToString("G10");  
        }

        private void F_Regress_Activated(object sender, EventArgs e)
        {

        }

        private void funk_ableit(double t, double[] par, String typ, ref double f, double[] abl)
        {
            /* Here the values for (the functions dependent of parameters &&the
            relevant derivatives are calculated*/
        
            double a=0,b=0,c=0,g=0,h=0,si=0,co=0,denom=0,num=0;  /* temp TextBoxry*/
            double  Ki=0,_T1=0,_T2=0,Tt=0,Off=0,d=0,wo=0,ex=0,ex1=0,ex2=0,k1=0,k2=0,K=0,Ti=0,Td=0;

            if (typ=="IT1" )                     /* F(p)=Ki/p/(1+pT1) */
            {
                Ki=par[1];_T1=par[2];Off=par[3];Tt=par[4];
                if (t<Tt )  {
                    f=Off; abl[1]=0;abl[2]=0;abl[3]=1;abl[4]=0;
                }
                else {
                    if (_T1==0 )  _T1=1e-3;
                    a=(t-Tt)/_T1;
                    if (a>70 )  a=70;
                    if (a<-70 )  a=-70;
                    ex=Math.Exp(-a);
                    b=t-Tt-_T1*(1-ex);
                    f=Ki*b+Off;
                    abl[1]=b;
                    abl[2]=Ki*(-1+((t-Tt)/_T1+1)*ex);
                    abl[3]=1;
                    abl[4]=Ki*(-1+ex);
                } /*;else*/
            }   /*I_T1*/

            if (typ == "i2t1")                     // F(p)=Ki/p/p/(1+pT1),  2 Integr + 1 PT1 */
            {
                Ki = par[1]; _T1 = par[2]; Off = par[3]; Tt = par[4];
                if (t < Tt)
                {
                    f = Off; abl[1] = 0; abl[2] = 0; abl[3] = 1; abl[4] = 0;
                }
                else
                {
                    if (_T1 == 0) _T1 = 1e-3;
                    a = (t - Tt) / _T1;
                    if (a > 70) a = 70;
                    if (a < -70) a = -70;
                    ex = Math.Exp(-a);
                    b = _T1*_T1 -(t- Tt)*_T1 +0.5*(t-Tt)*(t-Tt)-_T1 *_T1* ex;
                    f = Ki * b + Off;
                    abl[1] = b;
                    abl[2] = Ki * (2*_T1-(t - Tt)-(2*_T1 +t-Tt) * ex);
                    abl[3] = 1;
                    abl[4] = Ki * (_T1-t+Tt-_T1*ex);
                } /*;else*/
            }   /*I_T1*/



            if (typ=="PT1" )                     /* F(p)=Ki/(1+pT1) */
            {
                Ki=par[1];_T1=par[2];Off=par[3];Tt=par[4];
                if (t<Tt )  {
                    f=Off; abl[1]=0;abl[2]=0;abl[3]=1;abl[4]=0;
                }
                else {
                    if (_T1==0 )  _T1=1e-3;
                    t=t-Tt;
                    a=t/_T1;
                    if (a>70 )  a=70;
                    if (a<-70 )  a=-70;
                    ex=Math.Exp(-a);
                    b=1-ex;
                     f=Ki*b+Off;
                    abl[1]=b;
                    abl[2]=-Ki*t/_T1/_T1*ex;
                    abl[3]=1;
                    abl[4]=-Ki*ex/_T1;
                } /*;else*/
            }   /*pt1*/

            if (typ=="2PT1" )                     /* F(p)=ki/(1+pT1)/(1+pT2)  */
            {
                 Ki=par[1];_T1=par[2];_T2=par[3];Off=par[4];Tt=par[5];
                if (t<Tt )  {
                    f=Off; abl[1]=0;abl[2]=0;abl[3]=0;abl[4]=1;abl[5]=0;
                }
                else {
                    if (_T1==0 )  _T1=1e-3;
                    if (_T1==_T2 )  _T2=_T2*(1+1e-4);
                    t=t-Tt;     /* **** new */
                    a=t/_T1;
                    if (a>70 )  a=70;
                    if (a<-70 )  a=-70;
                    ex1=Math.Exp(-a);
                    if (_T2==0 )  _T2=1e-4;
                    a=t/_T2;
                    if (a>70 )  a=70;
                    if (a<-70 )  a=-70;
                    ex2=Math.Exp(-a);
                    c=_T1/(_T1-_T2);g=_T2/(_T2-_T1);   
                    b=1-c*ex1-g*ex2;
                    f=Ki*b+Off;
                    abl[1]=b;
                    abl[2]=(-g-t/_T1)*Ki/(_T1-_T2)*ex1-g/(_T2-_T1)*Ki*ex2;
                    abl[3]=(-c-t/_T2)*Ki/(_T2-_T1)*ex2-c/(_T1-_T2)*Ki*ex1;
                    abl[4]=1;
                    abl[5]=Ki*(-c/_T1*ex1-g/_T2*ex2);  /* *** new*/
                } /*;else*/
            }  ;  /*2pt1*/

            if (typ=="poly" )
            {
                f=par[1]+(par[2]+(par[3]+(par[4]+(par[5]+(par[6]+par[7]*t)*t)*t)*t)*t)*t;
                abl[1]=1;abl[2]=t;abl[3]=t*t;abl[4]=t*t*t;
                abl[5]=t*t*t*t;abl[6]=abl[5]*t;abl[7]=abl[6]*t;
            }  /*poly*/

            if (typ=="pol2" )  /*(a + cx + dx^2)/(1 + bx)*/
            {
                num= par[1]+par[3]*t+par[4]*t*t; denom=1+par[2]*t;
                if (Math.Abs(denom)<1e-10 )  if (denom>0 )  denom=1e-10 ;else denom=-1e-10;
                f=num/denom;
                abl[1]=1/denom;abl[2]=-t*num/denom/denom;
                abl[3]=t/denom;abl[4]=t*abl[3];
            }  /*pol2*/

            if (typ=="pol3" )  /*(a + dx + ex^2)/(1 + bx + cx^2)*/
            {
                num= par[1]+par[4]*t+par[5]*t*t; denom=1+par[2]*t + par[3]*t*t;
                if (Math.Abs(denom)<1e-10 )  if (denom>0 )  denom=1e-10 ;else denom=-1e-10;
                f=num/denom;
                abl[1]=1/denom;abl[2]=-t*num/denom/denom;
                abl[3]=abl[2]*t;abl[4]=t/denom;abl[5]=abl[4]*t;
            }  /*pol3*/

            if (typ=="PT2" )              /*F(p)=ki/(1+2d/wo p +1/wowo p2*/
            {                       /*d limited ;i<=0<d<1*/
                Ki=par[1];d=par[2];wo=par[3];Off=par[4];Tt=par[5];
                if (t<Tt )  {
                    f=Off; abl[1]=0;abl[2]=0;abl[3]=0;abl[4]=1;abl[5]=0;
                }
                else {
                    if (d>=1 )  d=1-1e-3;
                    if (d<=0 )  d=1e-7;
                    a=Math.Sqrt(1-d*d);
                    t=t-Tt;
                    b=wo*a*t+Math.Atan(a/d);  
                    h=d*wo*t;
                    if (h>70  )  h=70;
                    if (h<-70 )  h=-70;
                    c=Math.Exp(-h);
                    si=Math.Sin(b);co=Math.Cos(b);
                    g=1-c/a*si;
                    f=Ki*g+Off;
                    abl[1]=g;
                    abl[2]=-Ki*c/a*((d/a/a-wo*t)*si-(1+wo*d*t)/a*co);
                    abl[3]=-Ki/a*(-d*t*c*si+c*a*t*co);
                    abl[4]=1;
                    abl[5]=Ki*c*wo*(-d/a*si+co);
                } /*;else*/
            }  /*pt2*/

            if (typ=="ex" )            /* f(t)=k1*Math.Exp(k2*t) +off */
            {
                k1=par[1];k2=par[2];Off=par[3];
                ex=Math.Exp(k2*t);
                abl[1]=ex;
                abl[2]=k1*ex*t;
                abl[3]=1;
                f=k1*ex+Off;
            }    ;  /*ex*/
            
            if (typ=="pid" )            /* f(t)=PID-SA +off */
            {
                K=par[1];Ti=par[2];Td=par[3];_T1=par[4];Off=par[5];Tt=par[6];
                if (t<Tt )
                {
                    f=Off; abl[1]=0;abl[2]=0;abl[3]=0;abl[4]=0;abl[5]=1;
                }
                else {
                    if (_T1==0 )  _T1=1e-3;
                    if (Ti==0 )  Ti=1e-3;
                    a=(t-Tt)/_T1;
                    if (a>70 )  a=70;
                    if (a<-70 )  a=-70;
                    ex=Math.Exp(-a);
                    abl[1]=(t-Tt-_T1)/Ti+1+(Td/_T1-1+_T1/Ti)*ex;
                    abl[2]=-K*(t-Tt-_T1+_T1*ex)/Ti/Ti;
                    abl[3]=K*ex/_T1;
                    abl[4]=K*(-1/Ti+ex*(-Td/_T1/_T1+1/Ti+(Td/_T1-1+_T1/Ti)*(t-Tt)/_T1/_T1));
                    abl[5]=1;
                    abl[6]=K*(-1/Ti+(Td/_T1-1+_T1/Ti)*ex/_T1);
                    f=K*abl[1]+Off;
                }
            }    ;  /*ex*/

            if (typ=="dt2" )              /*F(p)=ki p/(1+2d/wo p +1/wowo p2*/
            {                       /*d limited 0<d<1*/
                Ki=par[1];d=par[2];wo=par[3];Off=par[4];Tt=par[5];
                if (t<Tt )  {
                    f=Off; abl[1]=0;abl[2]=0;abl[3]=0;abl[4]=1;abl[5]=0;
                }
                else {
                    double sq1d=0,ext=0,wodw=0,we=0;                         
                    if (d>=1 )  d=1-1e-3;
                    if (d<=0 )  d=1e-7;
                    sq1d=Math.Sqrt(1-d*d);
                    t=t-Tt;
                    h=d*wo*t;
                    if (h>70  )  h=70;
                    if (h<-70 )  h=-70;
                    ext=Math.Exp(-h);
                    we=wo*sq1d;wodw=wo/sq1d;
                    si=Math.Sin(we*t);co=Math.Cos(we*t);
                    g=wodw*ext*si;
                    f=Ki*g+Off;
                    abl[1]=g;
                    abl[2]=Ki*ext*wodw*((1/(1-d*d)*d-wo*t)*si-co*t*d);
                    abl[3]=Ki*ext*((1/sq1d-wodw*d*t)*si+wodw*co*sq1d*t);
                    abl[4]=1;
                    abl[5]=Ki*wodw*ext*(d*wo*si-co*we);;
                } /*;else*/
            }  /*pt2*/
        }

        private void Cancelbtn2_Click_1(object sender, EventArgs e)
        {
            this.Close();
        }

        private void ToolButton13help_Click_1(object sender, EventArgs e)
        {
            fhelp.Show();
        }

        private void HelpBtn1_Click(object sender, EventArgs e)
        {
            fhelp.Show();
        }

        private void help_Click(object sender, EventArgs e)
        {
            fhelp.Show();
        }


 
 
        int simpoints;
        private void BitBtnStartSimulation_Click(object sender, EventArgs e)
        {
            int   i;
            double   dx=0,t=0,yi=0;
            double[] abl=new double[maxpar];
            double[] parsim=new double[maxpar];
            Random rnd = new Random();

            // readparamssimul ;

            if (RBSpt1.Checked )   {  simtyp="PT1";anzparam=4;}
            if (RBSit1.Checked )   {  simtyp="IT1";anzparam=4;}
            if (RBSpt2.Checked )   {  simtyp="PT2";anzparam=5;}
            if (RBS2pt1.Checked )  {  simtyp="2PT1";anzparam=5;}
            if (RBSpoly.Checked )  {  simtyp="poly";anzparam=7;}
            if (RBSexp.Checked )   {  simtyp="ex";anzparam=3;}
            if (RBShyp1.Checked )  {  simtyp="pol2";anzparam=4;}
            if (RBShyp2.Checked )  {  simtyp="pol3";anzparam=5;}
            if (RBSpid.Checked )   {  simtyp="pid";anzparam=5;}
            if (RBSDt2.Checked) { simtyp = "dt2"; anzparam = 5; }
            if (rBSI2T1.Checked) { simtyp = "i2t1"; anzparam = 4; }
            meinMain.ConvertToDouble(Spar1.Text,ref parsim[1]  );
            meinMain.ConvertToDouble(Spar2.Text,ref parsim[2]  );
            meinMain.ConvertToDouble(Spar3.Text,ref parsim[3]  );
            meinMain.ConvertToDouble(Spar4.Text,ref parsim[4]  );
            meinMain.ConvertToDouble(Spar5.Text,ref parsim[5]  );
            meinMain.ConvertToDouble(Spar6.Text,ref parsim[6]  );
            meinMain.ConvertToDouble(Spar7.Text,ref parsim[7]  );
            double simfrom=0,simto=10;
            simpoints=100;

            meinMain.ConvertToDouble(efrom.Text, ref simfrom);
            meinMain.ConvertToDouble(eto.Text, ref simto);
            if ((!int.TryParse(Epoints.Text, out simpoints))&&(simpoints<2))
            
            {
                simpoints = 100;
                Epoints.Text = "100";
            }
            double simnoise = 0;
            meinMain.ConvertToDouble(enoise.Text,ref simnoise);

            //  end readparamsimul
            chart2D1.Visible=true;
            chart2D1.clearAll();
            chart2D1.CurveNames[0] = Simulated;
            TabControl.SelectedIndex = 0;
            Memo1.Clear();
            t=simfrom;dx=(simto-simfrom)/(double)(simpoints-1);
            xmaxR=t;xminR=t;

            funk_ableit(t,parsim,simtyp,ref yi,abl);                 
            yminR=yi;ymaxR=yi;
            for (i=0 ;i<=simpoints-1;i++)
            {                               
                //axChartfx1.set_XValue((short)i,t); 
                funk_ableit(t,parsim,simtyp,ref yi,abl);             
                yi=yi+simnoise*2*(rnd.Next(10000)/10000.0-0.5);
                //axChartfx1.set_Value((short)i,yi);
                chart2D1.setPoint(0, t, yi);
                Memo1.AppendText((t).ToString(CultureInfo.InvariantCulture) + "  " + (yi).ToString(CultureInfo.InvariantCulture) + Environment.NewLine);
                if (t>xmaxR )  xmaxR=t;
                if (t<xminR )  xminR=t;
                if (yi>ymaxR )  ymaxR=yi;
                if (yi<yminR )  yminR=yi;
                t=t+dx;
            }  /*for (i= ....*/
            anzpunkte=simpoints;

            chart2D1.autoScaling();
            chart2D1.startDrawing();
            chart2D1.CurveColor0= Color.Blue;
            chart2D1.TopTitle=simulateddata
            +"   "+(DateTime.Now.ToString("F"))
            +"    "+(simpoints).ToString()+pts+"1"+cvs;
            chart2D1.BottomTitle="";

            ButtonInitVal.Enabled=true;
            ButtonOptimize.Enabled=true;
            butCopyToMain.Enabled = true;

            TBDrawidentcurve.Enabled = true;
            BitBtnDrawIdentCurve.Enabled = true;
            TSData.Text="ASCII Data "+Simulated;
            TB15Save.Enabled=true;

            /*  lastaccess="Simulation";
            idaok=false; */
        }


        private void rbpt1_Click(object sender, EventArgs e)
        {
            regrtyp = "PT1";
            lpar1.Text = "K"; lpar2.Text = "T1";
            lpar3.Text = "Uoffs"; lpar4.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = false; par5.Visible = false;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 4; nbofpar.Value = 3;
            Panelpid.Visible = false;
            nbDisPar = 4;
        }

        private void rbit1_Click(object sender, EventArgs e)
        {
            regrtyp = "IT1";
            lpar1.Text = "K"; lpar2.Text = "T1";
            lpar3.Text = "Uoffs"; lpar4.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = false; par5.Visible = false;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 4; nbofpar.Value = 3;
            Panelpid.Visible = false;
            nbDisPar = 4;
        }

        private void rbpt2_Click(object sender, EventArgs e)
        {
            regrtyp = "PT2";
            lpar1.Text = "K"; lpar2.Text = "d";
            lpar3.Text = "wo"; lpar4.Text = "Uoffs";
            lpar5.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = true; par5.Visible = true;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 5; nbofpar.Value = 4;
            Panelpid.Visible = false;
            nbDisPar = 5;
        }

        private void rb2pt1_Click(object sender, EventArgs e)
        {
            regrtyp = "2PT1";
            lpar1.Text = "K"; lpar2.Text = "T1";
            lpar3.Text = "T2"; lpar4.Text = "Uoffs";
            lpar5.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = true; par5.Visible = true;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 5; nbofpar.Value = 4;
            Panelpid.Visible = false;
            nbDisPar = 5;
        }

        private void rbpoly_Click(object sender, EventArgs e)
        {
            regrtyp = "poly";
            lpar1.Text = "a"; lpar2.Text = "b";
            lpar3.Text = "c"; lpar4.Text = "d";
            lpar5.Text = "e"; lpar6.Text = "f";
            lpar7.Text = "g";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = true; par5.Visible = true;
            lpar6.Visible = true; par6.Visible = true;
            lpar7.Visible = true; par7.Visible = true;
            nbofpar.Maximum = 7; nbofpar.Value = 7;
            Panelpid.Visible = false;
            nbDisPar = 7;
        }

        private void rbexp_Click(object sender, EventArgs e)
        {
            regrtyp = "exp";
            lpar1.Text = "K1"; lpar2.Text = "K2";
            lpar3.Text = "K3";
            lpar4.Visible = false; par4.Visible = false;
            lpar5.Visible = false; par5.Visible = false;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 3; nbofpar.Value = 3;
            Panelpid.Visible = false;
            nbDisPar = 3;
        }

        private void rbhyp1_Click(object sender, EventArgs e)
        {
            regrtyp = "pol2";
            lpar1.Text = "a"; lpar2.Text = "b";
            lpar3.Text = "c"; lpar4.Text = "d";
            lpar5.Text = "e"; lpar6.Text = "f";
            lpar7.Text = "g";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = false; par5.Visible = false;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 4; nbofpar.Value = 4;
            Panelpid.Visible = false;
            nbDisPar = 4;
        }

        private void rbhyp2_Click(object sender, EventArgs e)
        {
            regrtyp = "pol3";
            lpar1.Text = "a"; lpar2.Text = "b";
            lpar3.Text = "c"; lpar4.Text = "d";
            lpar5.Text = "e"; lpar6.Text = "f";
            lpar7.Text = "g";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = true; par5.Visible = true;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 5; nbofpar.Value = 5;
            Panelpid.Visible = false;
            nbDisPar = 5;
        }

        private void rbpid_Click(object sender, EventArgs e)
        {
            regrtyp = "pid";
            lpar1.Text = "K"; lpar2.Text = "Ti";
            lpar3.Text = "Td"; lpar4.Text = "T1";
            lpar5.Text = "Uoff"; lpar6.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = true; par5.Visible = true;
            lpar6.Visible = true; par6.Visible = true;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 6; nbofpar.Value = 5;
            Panelpid.Visible = true;
            nbDisPar = 6;
        }

        private void rbdt2_Click(object sender, EventArgs e)
        {
            regrtyp = "dt2";
            lpar1.Text = "K"; lpar2.Text = "d";
            lpar3.Text = "wo"; lpar4.Text = "Uoffs";
            lpar5.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = true; par5.Visible = true;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 5; nbofpar.Value = 4;
            Panelpid.Visible = false;
            nbDisPar = 5;
        }

        private void rBI2T1_CheckedChanged(object sender, EventArgs e)
        {
            regrtyp = "i2t1";
            lpar1.Text = "K"; lpar2.Text = "T1";
            lpar3.Text = "Uoffs"; lpar4.Text = "Tdel";
            lpar4.Visible = true; par4.Visible = true;
            lpar5.Visible = false; par5.Visible = false;
            lpar6.Visible = false; par6.Visible = false;
            lpar7.Visible = false; par7.Visible = false;
            nbofpar.Maximum = 4; nbofpar.Value = 3;
            Panelpid.Visible = false;
            nbDisPar = 4;

        }

// Simulation Radio Button


        private void RBSpt1_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "T1";
            LSpar3.Text = "Uoffs"; LSpar4.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = false; Spar5.Visible = false;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void RBSit1_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "T1";
            LSpar3.Text = "Uoffs"; LSpar4.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = false; Spar5.Visible = false;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void RBSpt2_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "d";
            LSpar3.Text = "wo"; LSpar4.Text = "Uoffs";
            LSpar5.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = true; Spar5.Visible = true;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void RBS2pt1_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "T1";
            LSpar3.Text = "T2"; LSpar4.Text = "Uoffs";
            LSpar5.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = true; Spar5.Visible = true;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void RBSpoly_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "a"; LSpar2.Text = "b";
            LSpar3.Text = "c"; LSpar4.Text = "d";
            LSpar5.Text = "e"; LSpar6.Text = "f";
            LSpar7.Text = "g";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = true; Spar5.Visible = true;
            LSpar6.Visible = true; Spar6.Visible = true;
            LSpar7.Visible = true; Spar7.Visible = true;
            PanelpidS.Visible = false;
        }

        private void RBSexp_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K1"; LSpar2.Text = "K2";
            LSpar3.Text = "K3";
            LSpar4.Visible = false; Spar4.Visible = false;
            LSpar5.Visible = false; Spar5.Visible = false;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;

        }

        private void RBShyp1_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "a"; LSpar2.Text = "b";
            LSpar3.Text = "c"; LSpar4.Text = "d";
            LSpar5.Text = "e"; LSpar6.Text = "f";
            LSpar7.Text = "g";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = false; Spar5.Visible = false;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void RBShyp2_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "a"; LSpar2.Text = "b";
            LSpar3.Text = "c"; LSpar4.Text = "d";
            LSpar5.Text = "e"; LSpar6.Text = "f";
            LSpar7.Text = "g";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = true; Spar5.Visible = true;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void RBSpid_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "Ti";
            LSpar3.Text = "Td"; LSpar4.Text = "T1";
            LSpar5.Text = "Uoff"; LSpar6.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = true; Spar5.Visible = true;
            LSpar6.Visible = true; Spar6.Visible = true;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = true;
        }

        private void RBSDt2_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "d";
            LSpar3.Text = "wo"; LSpar4.Text = "Uoffs";
            LSpar5.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = true; Spar5.Visible = true;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }

        private void rBSI2T1_Click(object sender, EventArgs e)
        {
            LSpar1.Text = "K"; LSpar2.Text = "T1";
            LSpar3.Text = "Uoff"; LSpar4.Text = "Tdel";
            LSpar5.Text = "Tdel";
            LSpar4.Visible = true; Spar4.Visible = true;
            LSpar5.Visible = false; Spar5.Visible = false;
            LSpar6.Visible = false; Spar6.Visible = false;
            LSpar7.Visible = false; Spar7.Visible = false;
            PanelpidS.Visible = false;
        }



        private void Epoints_Leave(object sender, EventArgs e)
        {
            int i=0;
            if (!int.TryParse(Epoints.Text, out i))
            {
                i = 100;
                Epoints.Text = "100";
            }
            if (i < 2) Epoints.Text = "2";
            if (i > rcnvaluesmax) Epoints.Text = (rcnvaluesmax).ToString();
        }

        private void readidentparam()
        {
            if (rbpt1.Checked) { regrtyp = "PT1"; anzparam = 4; }
            if (rbit1.Checked) { regrtyp = "IT1"; anzparam = 4; }
            if (rbpt2.Checked) { regrtyp = "PT2"; anzparam = 5; }
            if (rb2pt1.Checked) { regrtyp = "2PT1"; anzparam = 5; }
            if (rbpoly.Checked) { regrtyp = "poly"; anzparam = 7; }
            if (rbexp.Checked) { regrtyp = "ex"; anzparam = 3; }
            if (rbhyp1.Checked) { regrtyp = "pol2"; anzparam = 4; }
            if (rbhyp2.Checked) { regrtyp = "pol3"; anzparam = 5; }
            if (rbpid.Checked) { regrtyp = "pid"; anzparam = 5; }
            if (rBI2T1.Checked) { regrtyp = "i2t1"; anzparam = 5; }
            meinMain.ConvertToDouble(par1.Text,ref parameter[1] );
            meinMain.ConvertToDouble(par2.Text,ref  parameter[2]);
            meinMain.ConvertToDouble(par3.Text,ref  parameter[3]);
            meinMain.ConvertToDouble(par4.Text,ref  parameter[4]);
            meinMain.ConvertToDouble(par5.Text,ref  parameter[5]);
            meinMain.ConvertToDouble(par6.Text,ref  parameter[6]);
            meinMain.ConvertToDouble(par7.Text, ref  parameter[7]);
        }

        private void writeresulttoparbox()
        {
            par1.Text=(parameter[1]).ToString("G14");
            par2.Text=(parameter[2]).ToString("G14");
            par3.Text=(parameter[3]).ToString("G14");
            par4.Text=(parameter[4]).ToString("G14");
            par5.Text=(parameter[5]).ToString("G14");
            par6.Text=(parameter[6]).ToString("G14");
            par7.Text=(parameter[7]).ToString("G14");
            /* calculate the average value of all points */
            lssum.Text=(sumproz).ToString("G14");
            steps.Text=(itact).ToString();
          /*  FRegression.StatusBar1.Panels.Items[2].Text="s= "+(sumproz).ToString("G14")
            +"   "+(itact).ToString()+Strsteps; */
            toolStripSL1.Text=("s= "+(sumproz).ToString("G14")
            +"   "+(itact).ToString()+Strsteps);
        }

        private void berechne_y_a_sum(int anzpar, int anzpunkte,bool withdraw)
        {
            double    t=0,deltayi=0,yi=0;
            int       i=0,j=0,k=0;
            double[] abl = new double[maxpar];
            double[] poi; 

            double sumext=0,ymittel=0;
            /* filling of ffunk[].f2 modell function &&derivative
            matrix ata, calculation of sum*/

            sumext=0;ymittel=0;
            for (i=1 ;i<=anzpar;i++)
            {
                for (j=1 ;j<=anzpar;j++)  ata[i-1,j-1]=0;
                q[i]=0;
            } /*clear ata,q*/
            if (withdraw) if (chart2D1.Counter == 1) chart2D1.clearLast();

            for (k=0 ;k<anzpunkte;k++)
            {
                poi = chart2D1.getPoint(0, k);//korr start 0
                t=poi[0];
                funk_ableit(t,parameter,regrtyp,ref yi,abl);
                if (withdraw) chart2D1.setPoint(1,t,yi);
                deltayi=poi[1]-yi;
                sumext=sumext+deltayi*deltayi;
                ymittel=ymittel+yi;
                for (i=1 ;i<=anzpar;i++)
                {
                    for (j=i ;j<=anzpar;j++)
                    {           /* calculate  AT*A */
                        ata[i-1,j-1]=ata[i-1,j-1]+abl[i]*abl[j];
                        ata[j-1,i-1]=ata[i-1,j-1];   /*ata is symmetrical mat*/
                    } /* for (j*/
                    q[i]=q[i]+abl[i]*deltayi; /* Calculate AT*Deltay */
                }/* for (i...*/
            }  /*for (k= ....*/
            sumR=sumext;ymittel=ymittel/anzpunkte;
            if (withdraw)
            {

                chart2D1.startDrawing();
            }
            if (ymittel==0 )  ymittel=1e-10;
            sumproz=100.0*Math.Sqrt(sumR/anzpunkte)/ymittel;
        }

        private void BitBtnDrawIdentCurve_Click(object sender, EventArgs e)
        {
            int i = 0;
            double t = 0, yi = 0;
            double[] abl = new double[maxpar];
            string str;
            double[] poi;

            // read parameter of ident model ;
            readidentparam();

            //  end read param of ident model

            Memo1.Clear();
            if (chart2D1.Counter == 1) chart2D1.clearLast();
            chart2D1.CurveNames[1] = identdata;
            for (i = 0; i <= anzpunkte - 1; i++)
            {

                poi = chart2D1.getPoint(0, i);//korr start 0
                t = poi[0];
                funk_ableit(t, parameter, regrtyp, ref yi, abl);
                chart2D1.setPoint(1, t, yi); ;
                Memo1.AppendText((t).ToString(CultureInfo.InvariantCulture) + "  " + (yi).ToString(CultureInfo.InvariantCulture) + Environment.NewLine);
                if (t > xmaxR) xmaxR = t;
                if (t < xminR) xminR = t;
                if (yi > ymaxR) ymaxR = yi;
                if (yi < yminR) yminR = yi;

            }  /*for (i= ....*/
            chart2D1.autoScaling();
            chart2D1.startDrawing();
            chart2D1.TopTitle = identdata
            + "   " + (DateTime.Now.ToString("F"))
            + "    " + (anzpunkte).ToString() + pts + "2" + cvs;
            str = lpar1.Text + "=" + par1.Text + ", " + lpar2.Text + "="
                + par2.Text + ", " + lpar3.Text + "=" + par3.Text;
            if (nbDisPar >= 4) str = str + ", " + lpar4.Text + "=" + par4.Text;
            if (nbDisPar >= 5) str = str + ", " + lpar5.Text + "=" + par5.Text;
            if (nbDisPar >= 6) str = str + ", " + lpar6.Text + "=" + par6.Text;
            if (nbDisPar >= 7) str = str + ", " + lpar7.Text + "=" + par7.Text;
            chart2D1.BottomTitle = str;

            berechne_y_a_sum(anzparam, anzpunkte,false);
            lssum.Text = (sumproz).ToString("G14");

            TSData.Text = "ASCII Data " + Identified;
            TB15Save.Enabled = true;
            TabControl.SelectedIndex = 0;
            butCopyToMain.Enabled = true;
        }

        private void ButtonInitVal_Click(object sender, EventArgs e)     //---------------------------------
        {
            int i=0;
            double ymin=0,ymax=0,tmax=0,yend=0,ue=0,lnue=0,wg=0,d=0;
            double t1=0,t2=0,y1=0,y2=0,dy=0,quot=0,hilf=0,dt=0,ki=0,dydt=0,tzneu=0;
            double anstiegmax=0,twt=0,ywt=0,x=0,tu=0,tg=0,t80=0,y80=0;
            double[] poi1, poi2;

            readidentparam();
            anzpunkte=chart2D1.CurvePoints[0];
            if (chart2D1.Counter==1) // 0 : 1 Kurve 1: 2 Kurven
                chart2D1.clearLast();
            toolStripSL1.Text = "Punkte der Kurve= "+ anzpunkte.ToString();
            if (anzpunkte > 3)
            {
                if (regrtyp == "PT1")
                {
                    poi2 = chart2D1.getPoint(0, anzpunkte - 1);  // last value//korr start 0
                    poi1 = chart2D1.getPoint(0, 0);   // first val //korr start 0
                    t2 = poi2[0];
                    ymin = poi1[1]; ymax = poi2[1];
                    /*t1=t2/2, also for (data without equidistant sampling intervalls*/
                    y2 = ymax - ymin; i = 1;
                    do
                    {   // look for Val with t2/2
                        poi1 = chart2D1.getPoint(0, i);//korr start 0
                        i = i + 1;
                    }
                    while (poi1[0] <= t2 / 2);
                    t1 = poi1[0]; y1 = poi1[1] - ymin;
                    quot = y2 / y1;
                    if (Math.Abs(quot - 2) < 1e-2)
                    {
                        MessageBox.Show(toolinear, "Info", MessageBoxButtons.OK);
                        parameter[1] = 100.0 * (ymax - ymin);
                        parameter[2] = 100.0 * t2;
                    }
                    else
                    {
                        parameter[1] = y1 / (2.0 - quot);    /*k*/
                        parameter[2] = -t2 / Math.Log(1.0 - y2 / parameter[1]);
                    }
                    parameter[3] = ymin;

                } /* if (pt1...*/

                if (regrtyp == "IT1")
                {
                    poi2 = chart2D1.getPoint(0, anzpunkte - 1);  // last value//korr start 0
                    tmax = poi2[0]; ymax = poi2[1];
                    poi1 = chart2D1.getPoint(0, 0);   // first val//korr start 0
                    ymin = poi1[1];


                    y1 = ymin + (ymax - ymin) / 2.0;  /* half of last value */
                    /* Look of time t1 at which y=y1  */
                    i = 1;
                    if (ymax > ymin)
                        do
                        {
                            poi1 = chart2D1.getPoint(0, i);//korr start 0
                            i = i + 1;
                        }
                        while (poi1[1] <= y1);
                    else
                        do
                        {
                            poi1 = chart2D1.getPoint(0, i);//korr start 0
                            i = i + 1;
                        }
                        while (poi1[1] >= y1);
                    t1 = poi1[0];
                    if (t1 >= tmax) MessageBox.Show(noresult, "Info", MessageBoxButtons.OK); /* IT1- initial value method don't work*/
                    else
                    {
                        ki = (ymax - y1) / (tmax - t1);  /* gradient */
                        parameter[2] = tmax - (ymax - ymin) / ki;
                        parameter[1] = ki;
                        parameter[3] = ymin;
                        parameter[4] = 0;
                    }  /*;else*/ ;
                }   /* IT1 */

                if (regrtyp == "i2t1")
                {
                    poi2 = chart2D1.getPoint(0, anzpunkte - 1);  // last value//korr start 0
                    tmax = poi2[0]; ymax = poi2[1];
                    poi1 = chart2D1.getPoint(0, 0);   // first val//korr start 0
                    ymin = poi1[1];


                    ki = (ymax - ymin) * 2 / tmax / tmax;  /* last val of parable */
                    parameter[2] = 1;
                    parameter[1] = ki;
                    parameter[3] = ymin;
                    parameter[4] = 0;

                }   /* IT1 */

                if (regrtyp == "PT2")
                {
                    /* calculate  ymax,tmax,xend */
                    ymax = -1e27; tmax = 0;
                    poi1 = chart2D1.getPoint(0, 0);   // first val//korr start 0
                    ymin = poi1[1];

                    for (i = 0; i <= anzpunkte - 1; i++)
                    {
                        poi2 = chart2D1.getPoint(0, i);//korr start 0
                        if (ymax < poi2[1])
                        {
                            ymax = poi2[1];
                            tmax = poi2[0];
                        }  /*for*/
                    }
                    ymax = ymax - ymin;
                    poi2 = chart2D1.getPoint(0, anzpunkte - 1);//korr start 0
                    yend = poi2[1] - ymin;
                    /*calculate the starting point with a gradient extrapolation
                    from the max-point thru the 80%-final-value-point*/
                    y80 = yend * 0.8;
                    i = 1;
                    do
                    {
                        poi2 = chart2D1.getPoint(0, i);//korr start 0
                        i = i + 1;
                    }
                    while ((poi2[1] - ymin) <= y80);
                    t80 = poi2[0];
                    tzneu = t80 - (y80) / (ymax - y80) * (tmax - t80);
                    if (Math.Abs((ymax - yend) / ymax) > 1e-2)
                    {
                        /*clculate d and wo*/
                        ue = ymax / yend - 1.0;
                        if (ue > 1e-10) lnue = Math.Log(ue);
                        else MessageBox.Show(noresult, "Info", MessageBoxButtons.OK);
                        d = -lnue / Math.Sqrt(Math.PI * Math.PI + lnue * lnue);
                        wg = Math.PI / (tmax - tzneu);
                        parameter[1] = yend;
                        parameter[2] = d;               /*d */
                        parameter[3] = wg / Math.Sqrt(1 - d * d);  /*wo*/
                        parameter[4] = ymin;
                        parameter[5] = tzneu;
                    };/*if Math.Abs(ymax...*/
                }; /*if typ.pt2....*/

                if (regrtyp == "2PT1")
                {
                    poi2 = chart2D1.getPoint(0, anzpunkte - 1);  // last value//korr start 0
                    tmax = poi2[0]; ymax = poi2[1];
                    poi1 = chart2D1.getPoint(0, 0);   // first val //korr start 0 
                    ymin = poi1[1];
                    ki = ymax - ymin;
                    /* Calculate maximal gradient */
                    if (ki > 0) anstiegmax = -1e27; else anstiegmax = +1e27;
                    for (i = 1; i <= anzpunkte - 2; i++)
                    {
                        poi1 = chart2D1.getPoint(0, i);//korr start 0
                        poi2 = chart2D1.getPoint(0, i - 1);//korr start 0
                        dy = poi1[1] - poi2[1];
                        dt = poi1[0] - poi2[0];
                        if (dt != 0) dydt = dy / dt; else dydt = 0;
                        if (ki > 0)
                        {  /* look for (maximal gradient */
                            if (dydt > anstiegmax)
                            {
                                anstiegmax = dydt;
                                twt = poi2[0];
                                ywt = poi2[1];
                            }  /*if ) ...*/
                        }
                        else        /* look for (minimal gradient*/
                            if (dydt < anstiegmax)
                            {
                                anstiegmax = dydt;
                                twt = poi2[0];
                                ywt = poi2[1];
                            }   /*if ) ...*/
                    };/* for (i... */
                    tg = ki / anstiegmax;
                    tu = twt - (ywt - ymin) / anstiegmax;
                    x = tu / tg; tzneu = 0;
                    if (tu <= 0) MessageBox.Show(noresult, "Info", MessageBoxButtons.OK);
                    else if (x < 0.016)
                    {
                        t1 = tg; t2 = tu; tzneu = 1e-10;
                    }
                    else if (x > 0.1)
                    {
                        t1 = 0.4753 * tg; t2 = 0.2696 * tg;
                        tzneu = tu - 0.1 * tg;
                    }
                    else
                    {    /* switch (0.016<x<0.1*/

                        hilf = 360860.0 * x - 67431.0;
                        hilf = hilf * x + 4947.39;
                        hilf = hilf * x - 134.565;
                        hilf = hilf * x + 6.3816;
                        hilf = hilf * x + 0.99851;
                        t1 = tg / hilf;

                        hilf = 254327.0 * x - 46758.1;
                        hilf = hilf * x + 3257.62;
                        hilf = hilf * x - 74.0624;
                        hilf = hilf * x + 1.82806;
                        hilf = hilf * x - 1.3794e-4;
                        t2 = t1 * hilf;
                        tzneu = 1e-5;
                    }
                    parameter[1] = ki;
                    parameter[2] = t1;
                    parameter[3] = t2;
                    parameter[4] = ymin;
                    parameter[5] = tzneu;

                }; /*if typ.2pt1....*/

                if (regrtyp == "pid")
                {
                    double u1 = 0, u2 = 0, u3 = 0, u4 = 0, a = 0, b = 0, c = 0, tx = 0, Ti = 0, Td = 0, T1 = 0, K = 0, t4 = 0, tdel = 0, u10ampl = 0, uoff = 0; //d
                    int x0 = 0, xt3 = 0, xtmin = 0, xt4 = 0;
                    poi2 = chart2D1.getPoint(0, anzpunkte - 1);  // last value//korr start 0
                    u2 = poi2[1];
                    poi1 = chart2D1.getPoint(0, 0);   // first val//korr start 0
                    uoff = poi1[1];

                    // look for time t=tdel at  of step;
                    u10ampl = (u2 - uoff) / 10.0;   // step is detected, where u larger 10 % ampl
                    i = 0;
                    do
                    {
                        poi1 = chart2D1.getPoint(0, i);//korr start 0
                        i++;
                    }
                    while (Math.Abs(poi1[1] - uoff) < u10ampl);
                    tdel = poi1[0];
                    tmax = poi2[0] - tdel;
                    x0 = i; // +1 because Regdelph starts with Value 0/0.
                    poi1 = chart2D1.getPoint(0, x0);//korr start 0
                    u1 = poi1[1];  // u1 is U(0) peak at start
                    xt3 = Convert.ToInt32(x0 + (anzpunkte - 1 - x0) * 0.6);
                    poi1 = chart2D1.getPoint(0, xt3);//korr start 0
                    u3 = poi1[1];
                    // look for minimum u
                    ymin = u2;
                    for (i = x0; i < anzpunkte; i++)
                    {
                        poi1 = chart2D1.getPoint(0, i);//korr start 0
                        if (poi1[1] < ymin)
                        {
                            ymin = poi1[1];
                            xtmin = i;
                        }
                    }
                    xt4 = x0 + (xtmin - x0) / 3;
                    poi1 = chart2D1.getPoint(0, xt4);//korr start 0
                    t4 = poi1[0] - tdel;
                    u4 = poi1[1];

                    a = (u2 - u3) / 0.4 / tmax;
                    b = (-0.6 * u2 + u3) * 2.5;
                    tx = -b / a;
                    c = (u4 - u1) / t4;
                    T1 = (u1 - b) / (a - c);
                    K = a * T1 + b;
                    Ti = T1 - tx;
                    Td = u1 * T1 / K;
                    parameter[1] = K;
                    parameter[2] = Ti;
                    parameter[3] = Td;
                    parameter[4] = T1;
                    parameter[5] = uoff;
                    parameter[6] = tdel;

                }

                if (regrtyp == "dt2")
                {
                    /* calculate  ymax,tmax,xend */
                    ymax = -1e200; tmax = 0; ymin = 1e200;
                    poi1 = chart2D1.getPoint(0, 0);   // first val//korr start 0
                    double offset = poi1[1];

                    for (i = 0; i <= anzpunkte - 1; i++)
                    {
                        poi2 = chart2D1.getPoint(0, i);//korr start 0
                        double xact = poi2[1];
                        if (ymax < xact)
                        {
                            ymax = xact;
                            tmax = poi2[0];
                        }  /*if*/
                        if (ymin > xact)
                        {
                            ymin = xact;
                        }  /*if*/
                    }  // for
                    if (Math.Abs(ymin - offset) > 1e-10)
                    {
                        /*clculate d and wo*/
                        ue = (ymax - offset) / (-ymin + offset);
                        if (ue > 1e-10) lnue = Math.Log(ue);
                        else MessageBox.Show(noresult, "Info", MessageBoxButtons.OK);
                        d = lnue / Math.Sqrt(Math.PI * Math.PI + lnue * lnue);
                        wg = 1 / tmax / Math.Sqrt(1 - d * d) * Math.Atan(Math.Sqrt(1 - d * d) / d);
                        parameter[1] = (ymax - offset) / wg / Math.Exp(-d * wg * tmax);
                        parameter[2] = d;               /*d */
                        parameter[3] = wg;  /*wo*/
                        parameter[4] = offset;
                        parameter[5] = 0.0;
                    };/*if Math.Abs(ymax...*/
                }; /*if typ.pt2....*/

                /* clear old values */
            }
            else
                MessageBox.Show(Rnocurve);
            for (i=(int)nbofpar.Maximum+1 ;i<maxpar;i++)  parameter[i]=0;    //<---------------------------
            /*    ableit_test(anzparam,parameter,regrtyp);  */
            /*    call only this  ^  void at new functions */

            writeresulttoparbox();
            BitBtnDrawIdentCurve_Click(sender, e);
            TB15Save.Enabled=true;

        }

        private void TB15Save_Click(object sender, EventArgs e)
        {
            meinMain.frmsavecurve.RefToChart2D = chart2D1;
            if (meinMain.frmsavecurve.WindowState == FormWindowState.Minimized)
                meinMain.frmsavecurve.WindowState = FormWindowState.Normal;
            meinMain.frmsavecurve.Show();
            meinMain.frmsavecurve.BringToFront();
        }

        private void ButtonOptimize_Click(object sender, EventArgs e)
        {
            int i = 0, j = 0, error = 0;//, k = 0
            double det = 0, kond = 0, s_0 = 0, gr = 0, sumintern = 0, schritt = 0, test_d = 0;
            double[] paralt = new double[maxpar];
            double[] lambda = new double[maxpar];
            double[] begrenz = new double[maxpar];
            double[] deltaa = new double[maxpar];
            double[] g = new double[maxpar];
            bool stop;
            tsBStop.Visible = true;
            /* preparationn*/

            readidentparam();
            anzpunkte = chart2D1.CurvePoints[0];

            anzparam = (int)nbofpar.Value;

            for (i = 1; i <= anzparam; i++) begrenz[i] = 0;

            if (regrtyp == "PT1")               /* standard-limitation in deltapmax*/
            {                   /* relates ;i<=a +-decade */
                begrenz[1] = deltapmax;       /*ki*/
                begrenz[2] = deltapmax;       /*t1*/
                begrenz[4] = deltapmax;       /*Tt*/
            }
            if (regrtyp == "IT1")
            {
                begrenz[1] = deltapmax;       /*ki*/
                begrenz[2] = deltapmax;       /*t1*/
                begrenz[4] = deltapmax;       /*Tt*/
            }
            if (regrtyp == "2PT1")
            {
                begrenz[1] = deltapmax;       /*ki*/
                begrenz[2] = deltapmax;       /*t1*/
                begrenz[3] = deltapmax;       /*t2*/
            }
            //if (regrtyp == "poly") ;  // no action if poly
            if (regrtyp == "PT2")
            {
                begrenz[1] = deltapmax;       /*ki*/
                begrenz[2] = 0.9;             /*d*/    /*+-10%}
                begrenz[3]=deltapmax;       /*wo*/
                begrenz[5] = deltapmax;       /*Tt*/
            }
            if (regrtyp == "ex")
            {
                begrenz[1] = deltapmax;        /*k1*/
                begrenz[2] = deltapmax;        /*k2*/
            }

            /* Begrenzung der Änderungen*/

            meinMain.ConvertToDouble(tolEdit2.Text,ref deltasum );
            itzahl = (int)maxnbit.Value;
            toolStripProgressBar1.Visible = true;
            toolStripProgressBar1.Maximum = itzahl+1;

            berechne_y_a_sum(anzparam, anzpunkte,false);
            itact = 0;
            if (Math.Abs(sumproz) > deltasum)
                do
                {
                    sumintern = sumR;
                    //Calculate new parameter with Gauss Newton method
                    error = matinve.matinv(ref ata, anzparam, ref det, ref kond);
                    if (error == 0)
                    {
                        /* Calculate ATA(-1) * (AT*deltay) */
                        for (i = 1; i <= anzparam; i++)
                        {
                            deltaa[i] = 0;
                            for (j = 1; j <= anzparam; j++)
                            {
                                deltaa[i] = deltaa[i] + ata[j - 1, i - 1] * q[j];
                                g[j] = -2 * q[j];   /*Gradient vektor*/
                            } /*for (j...*/
                        } /*for (i...*/
                    }   /*if*/
                    else
                    {
                        /* Inversion does't work, .  Steepest Descent*/
                        for (i = 1; i <= anzparam; i++)
                        {
                            g[i] = -2.0 * q[i];
                            deltaa[i] = g[i];
                        }  /*for (i...*/
                    }  /*;else*/


                    /* Here some correction steps follow at bad convergence
                    first check if search in negative gradient direction is OK*/

                    /* Calculate derivative s'(0) = g*deltaa , this must be negativ,
                    if sum should be decreased. If s'>0, forget ata and go on
                    withh gradient vektor g */
                    s_0 = 0;
                    for (i = 1; i <= anzparam; i++)
                        s_0 = s_0 + g[i] * deltaa[i];
                    if (s_0 > 0) for (i = 1; i <= anzparam; i++) deltaa[i] = g[i];

                    /* second correction:
                    Limitation of parameter change to 100*begrenz[]% up to
                    100*1/begrenz[]%. This is defined in procedure begrenzung
                    in vector begrenz[i]. Value 0: no limitation,
                    <>0: limitation. The limits can be found in lambda[i]*/
                    for (i = 1; i <= anzparam; i++)
                    {
                        gr = begrenz[i];
                        lambda[i] = 1.0;
                        if ((parameter[i] != 0) && (gr != 0))
                        {
                            if (deltaa[i] / parameter[i] < (gr - 1.0))
                                lambda[i] = parameter[i] / deltaa[i] * (gr - 1.0);
                            if (deltaa[i] / parameter[i] > (1 / gr - 1.0))
                                lambda[i] = parameter[i] / deltaa[i] * (1 / gr - 1.0);
                        }
                    }

                    /* limitation to that step that no parameter crosses its limit.*/
                    schritt = 1;
                    for (i = 1; i <= anzparam; i++) if (lambda[i] < schritt) schritt = lambda[i];

                    /* save old parameter set  */
                    for (i = 1; i <= anzparam; i++) paralt[i] = parameter[i];

                    do  /* halve the step while s decreases and
                        in Pt2-block d<1 */
                    {
                        /* calculate new parameter */
                        for (i = 1; i <= anzparam; i++) parameter[i] = paralt[i] + schritt * deltaa[i];

                        /* Calculate new function values */
                        berechne_y_a_sum(anzparam, anzpunkte,false);
                       
                        

                        schritt = schritt / 2.0;
                        if (regrtyp == "PT2") test_d = parameter[2]; else test_d = 0;
                        stop = (Math.Abs(sumR - sumintern) / sumintern < deltasum) || ((sumR < sumintern)
                                && (test_d < 1)) || (schritt <= 1e-10);// true if loop should stop
                    }
                    while (!stop);
                    berechne_y_a_sum(anzparam, anzpunkte, true);
                    /* }  of step Width control*/
                    itact = itact + 1;
                    toolStripProgressBar1.Value = itact;
                    Application.DoEvents();
                }
                while (!((itact > itzahl) || (Math.Abs(sumintern - sumR) / sumintern < deltasum)
                            || (Math.Abs(sumproz) < deltasum)));
            /* }  of Gauss-Newton-method */
            toolStripProgressBar1.Visible = false;
            tsBStop.Visible = false;
            writeresulttoparbox();
            BitBtnDrawIdentCurve_Click(sender, e);
            TB15Save.Enabled = true;

        }
// Einlesen der Daten uebernommen aus Windf C#-Version
//----------------------------------------------------------------------------------
        private void TBLoad_Click_1(object sender, EventArgs e)
        {
            frmLO.ShowDialog();
            if (frmLO.DialogResult == DialogResult.OK)
            {
                minmaxRegr.init();
                LOregr=frmLO.LO1;
                string fn=System.IO.Path.GetFileName(frmLO.openFileDialog1.FileName);
                LOregr.bottomtitle = "input file " + fn;
                LOregr.legend = fn;
                chart2D1.clearAll();
                int a = meinMain.datatools.ConvertTB2Chart(ref chart2D1, frmLO.textBox1,  LOregr);//ConvertTB2Chart(meinm;
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                    ButtonInitVal.Enabled = true;
                    ButtonOptimize.Enabled = true;
                    TBDrawidentcurve.Enabled = true;
                    BitBtnDrawIdentCurve.Enabled = true;
                    TSData.Text = "ASCII Data " + Imported;
                    TB15Save.Enabled = true;
                    TabControl.SelectedIndex = 0;
                    anzpunkte = LOregr.nbofpointslastcurve;
                }
            }
        }

//--------------------------------------------------------------------------------

        private void nbofpar_ValueChanged(object sender, EventArgs e)
        {
            anzparam = (int)nbofpar.Value;
            // make all changed parameters Dark blue, the other black
            lpar3.ForeColor = Color.Black; par3.BackColor = Color.White;
            lpar4.ForeColor = Color.Black; par4.BackColor = Color.White;
            lpar5.ForeColor = Color.Black; par5.BackColor = Color.White;
            lpar6.ForeColor = Color.Black; par6.BackColor = Color.White;
            lpar7.ForeColor = Color.Black; par7.BackColor = Color.White;
            if (anzparam >= 3) { lpar3.ForeColor = Color.DarkBlue; par3.BackColor = Color.Aquamarine; }
            if (anzparam >= 4) { lpar4.ForeColor = Color.DarkBlue; par4.BackColor = Color.Aquamarine; }
            if (anzparam >= 5) { lpar5.ForeColor = Color.DarkBlue; par5.BackColor = Color.Aquamarine; }
            if (anzparam >= 6) { lpar6.ForeColor = Color.DarkBlue; par6.BackColor = Color.Aquamarine; }
            if (anzparam >= 7) { lpar7.ForeColor = Color.DarkBlue; par7.BackColor = Color.Aquamarine; }
        }

 
        private void BBbode2par_Click(object sender, EventArgs e)
        {
            double Kr=0,Tn=0,Tv=0,st=0,K=0,Ti=0,Td=0,T1=0;
            meinMain.ConvertToDouble(Edit1.Text,ref Kr );
            meinMain.ConvertToDouble(Edit2.Text,ref Tn );
            meinMain.ConvertToDouble(Edit3.Text,ref Tv );
            meinMain.ConvertToDouble(Edit4.Text,ref st );
            K=Kr*(Tn+Tv)/Tn;
            Ti=Tn+Tv;
            Td=Tn*Tv/(Tn+Tv);
            T1=Tv/st;
            par1.Text=(K).ToString("G10");
            par2.Text=(Ti).ToString("G10");
            par3.Text=(Td).ToString("G10");
            par4.Text=(T1).ToString("G10");
        }

        private void BBbode2parS_Click(object sender, EventArgs e)
        {
            double Kr=0,Tn=0,Tv=0,st=0,K=0,Ti=0,Td=0,T1=0;
            meinMain.ConvertToDouble(Edit5.Text,ref Kr);
            meinMain.ConvertToDouble(Edit6.Text,ref Tn );
            meinMain.ConvertToDouble(Edit7.Text,ref Tv );
            meinMain.ConvertToDouble(Edit8.Text,ref st );
            K=Kr*(Tn+Tv)/Tn;
            Ti=Tn+Tv;
            Td=Tn*Tv/(Tn+Tv);
            T1=Tv/st;
            Spar1.Text=(K).ToString("G10");
            Spar2.Text=(Ti).ToString("G10");
            Spar3.Text=(Td).ToString("G10");
            Spar4.Text=(T1).ToString("G10");
        }

        private void BBpar2bode_Click(object sender, EventArgs e)
        {
            double Kr=0,Tn=0,Tv=0,K=0,Ti=0,Td=0,T1=0,a=0;
            meinMain.ConvertToDouble(par1.Text,ref K );
            meinMain.ConvertToDouble(par2.Text,ref Ti );
            meinMain.ConvertToDouble(par3.Text,ref Td );
            meinMain.ConvertToDouble(par4.Text,ref T1 );
            if (Ti==0) Ti=1e-10;
            a=1-4*Td/Ti;
            if (a < 0) MessageBox.Show(conversionimpossible, "Info", MessageBoxButtons.OK);
                else
                {
                   a=Math.Sqrt(a);
                   Kr=0.5*K*(1+a);
                   Tn=0.5*Ti*(1+a);
                   Tv=0.5*Ti*(1-a);
                }
            Edit1.Text=(Kr).ToString("G10");
            Edit2.Text=(Tn).ToString("G10");
            Edit3.Text=(Tv).ToString("G10");
            Edit4.Text=(Tv/T1).ToString("G10");
        }

        private void BBpar2bodeS_Click(object sender, EventArgs e)
        {
            double Kr=0,Tn=0,Tv=0,K=0,Ti=0,Td=0,T1=0,a=0;
            meinMain.ConvertToDouble(Spar1.Text,ref K );
            meinMain.ConvertToDouble(Spar2.Text,ref Ti );
            meinMain.ConvertToDouble(Spar3.Text,ref Td );
            meinMain.ConvertToDouble(Spar4.Text,ref T1 );
            if (Ti==0) Ti=1e-10;
            a=1-4*Td/Ti;
            if (a < 0) MessageBox.Show(conversionimpossible, "Info", MessageBoxButtons.OK);
                else
                {
                   a=Math.Sqrt(a);
                   Kr=0.5*K*(1+a);
                   Tn=0.5*Ti*(1+a);
                   Tv=0.5*Ti*(1-a);
                }
            Edit5.Text=(Kr).ToString("G10");
            Edit6.Text=(Tn).ToString("G10");
            Edit7.Text=(Tv).ToString("G10");
            Edit8.Text=(Tv/T1).ToString("G10");
        }

 

        private void OKbt1_Click(object sender, EventArgs e)
        {
            Hide();
            if ((regrtyp == "2PT1")||(regrtyp == "IT1")||(regrtyp == "PT1"))
                meinMain.regessionOK(regrtyp);
                           // Copy params into controller design tools
           
        }

        private void F_Regress_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            Visible = false;
            if (MMTimer1.Enabled == true)
            {
                MMTimer1.Disable();
            }


        }

        private void tsButReadInternalVal_Click(object sender, EventArgs e)
        {
            if (meinMain.fscope.textBox2.Lines.Length > 10)
            {
                minmaxRegr.init();
                LOregr.init();
                LOregr.legend="Scope";      
                int a = meinMain.datatools.ConvertTB2Chart(ref chart2D1, meinMain.fscope.textBox2, LOregr);
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                    ButtonInitVal.Enabled = true;
                    ButtonOptimize.Enabled = true;
                    TBDrawidentcurve.Enabled = true;
                    BitBtnDrawIdentCurve.Enabled = true;
                    TSData.Text = "Scope Data " + Imported;
                    TB15Save.Enabled = true;
                    TabControl.SelectedIndex = 0;
                    anzpunkte = meinMain.fscope.textBox2.Lines.Length;
                    chart2D1.CurveColor0=Color.Blue;

                }
            }
            else MessageBox.Show(NoScopeData);
        }


        private void tsbReadRTC_Click(object sender, EventArgs e)
        {
            TextBox tbpointer=null;
            if (meinMain.controlBoxSelector == "stud")
                tbpointer = meinMain.frmStudContr.tbLastValuesX;
            else if (meinMain.controlBoxSelector == "adapt")
                tbpointer = meinMain.frmadaptcon.tbLastValuesX;
            else MessageBox.Show(NoRTCData);  

            if ((tbpointer!=null)&& (tbpointer.Lines.Length > 10))
            {
                minmaxRegr.init();
                LOregr.init();
                LOregr.legend = "RTC";  
                int a = meinMain.datatools.ConvertTB2Chart(ref chart2D1, tbpointer, LOregr);
                if (a > 0) MessageBox.Show(errorfile + a.ToString());
                else
                {
                    ButtonInitVal.Enabled = true;
                    ButtonOptimize.Enabled = true;
                    TBDrawidentcurve.Enabled = true;
                    BitBtnDrawIdentCurve.Enabled = true;
                    TSData.Text = "RTC Data " + Imported;
                    TB15Save.Enabled = true;
                    TabControl.SelectedIndex = 0;
                    anzpunkte = tbpointer.Lines.Length-1;
                    chart2D1.CurveColor0 = Color.Blue;

                }
            }
            else MessageBox.Show(NoRTCData);

        }


        private void tSBReport_Click(object sender, EventArgs e)
        {
            string a = "      ";
            meinMain.tBMainReport.AppendText(a + "________________________________________________________\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
                meinMain.tBMainReport.AppendText(a + this.Text + "\r\n");
                meinMain.tBMainReport.AppendText("\r\n");

            meinMain.tBMainReport.AppendText(a + lresults.Text + "\r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(a + label3.Text + " = " + nbofpar.Value.ToString() + " \r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(a + label2.Text + " = " + regrtyp + " \r\n");
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(a + lpar1.Text + " = " + par1.Text + " \r\n");
            meinMain.tBMainReport.AppendText(a + lpar2.Text + " = " + par2.Text + " \r\n");
            meinMain.tBMainReport.AppendText(a + lpar3.Text + " = " + par3.Text + " \r\n");
            if (nbDisPar >= 4) meinMain.tBMainReport.AppendText(a + lpar4.Text + "=" + par4.Text + " \r\n");
            if (nbDisPar >= 5) meinMain.tBMainReport.AppendText(a + lpar5.Text + "=" + par5.Text + " \r\n");
            if (nbDisPar >= 6) meinMain.tBMainReport.AppendText(a + lpar6.Text + "=" + par6.Text + " \r\n");
            if (nbDisPar >= 7) meinMain.tBMainReport.AppendText(a + lpar7.Text + "=" + par7.Text + " \r\n");
            if (regrtyp=="pid")
            {
                meinMain.tBMainReport.AppendText("\r\n");
                meinMain.tBMainReport.AppendText(a + label4.Text + "\r\n");
                meinMain.tBMainReport.AppendText("\r\n");
                meinMain.tBMainReport.AppendText(a + label5.Text + " = " + Edit1.Text + "\r\n");
                meinMain.tBMainReport.AppendText(a + label6.Text + " = " + Edit2.Text + "s\r\n");
                meinMain.tBMainReport.AppendText(a + label7.Text + " = " + Edit3.Text + "s\r\n");
                meinMain.tBMainReport.AppendText(a + label8.Text + " = " + Edit4.Text + "\r\n");
            }
            meinMain.tBMainReport.AppendText("\r\n");
            meinMain.tBMainReport.AppendText(a + "________________________________________________________\r\n");


        }

        private void butCopyToMain_Click(object sender, EventArgs e)
        {
            // Copy Content Memo1 to Chart in Main Window
            meinMain.LOMain.init();
            meinMain.LOMain.XaxisLog = false;
            meinMain.LOMain.toptitle = SRLSOFF + "  " + Epoints.Text + "  " + simpoints;
            //meinMain.LOMain.bottomtitle = bottomtitle;
            meinMain.LOMain.legend = SRLSOFF;
            meinMain.BringToFront();
            meinMain.datatools.ConvertTB2ChartAdd(ref meinMain.chart2D1, Memo1, ref meinMain.minmaxMain, meinMain.LOMain);
        }


        private void maxnbit_ValueChanged(object sender, EventArgs e)
        {
            itzahl = (int)maxnbit.Value;
        }

        private void tsBStop_Click(object sender, EventArgs e)
        {
            itact = (int)maxnbit.Value;
        }

        private void tSBMeasureSR_Click(object sender, EventArgs e)
        {
            TabControl.SelectedTab = tPMeasureSR;
            rb2pt1.Checked = true;
            rb2pt1_Click(null, null);
            iRtc = 0; 
            MMTimer1.Interval = (uint)numTimeInterval.Value;
            MMTimer1.Enabled = true;
            timerDisplaySRMeasure.Enabled = true;
        }

        double val = 0;
        
        void EventVomMMTimer(TMultimediaTimer sender)
        {

            // time measurement
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            double deltaT0 = t0start - t0end;
            t0avr = t0avr + (deltaT0);  //calculating t0
            dtstart = stopwatch1.ElapsedTicks;
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);
            // end time measurement
            if ((iRtc < (int)numPoints.Value)&&(!buttonStep.Enabled))
            {
                xa[iRtc] = val;
                iRtc++;
            }
            // time measurement
            double dtend = stopwatch1.ElapsedTicks;
            double dt = (dtend - dtstart);
            if (dt > dtmax) dtmax = dt;
            dtavr = dtavr + dt;
            cntT0++;
            // end time measurement


        }

        private void buttonStep_Click(object sender, EventArgs e)
        {
            buttonStep.Enabled = false;
            iRtc = 0;
            t0avr = 0; dtavr = 0; dtmax = 0; 
            meinMain.DACoutput((short)nudChanDA.Value, (double)nUDVas.Value);
 
        }

        private void nUDVbs_ValueChanged(object sender, EventArgs e)
        {
            meinMain.DACoutput((short)nudChanDA.Value, (double)nUDVbs.Value);
            nUDVas.Value = (decimal)((double)nUDVbs.Value + stepAmplitude);
        }

        private void nUDVas_ValueChanged(object sender, EventArgs e)
        {
            stepAmplitude = (double)(nUDVas.Value - nUDVbs.Value);
        }

        int cntT0 = 0 ;
        double t0avr = 0, dtavr = 0, dtmax = 0, t0end = 0, t0start = 0, dtstart = 0;
        
        private void timerDisplaySRMeasure_Tick(object sender, EventArgs e)
        {
            labelX.Text = "x= "+ val.ToString("f3");
            labelProgI.Text = progress+ iRtc.ToString();
            if (cntT0 > 0)
            {
                double t0avr1 = t0avr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labelT0.Text = t0avr1.ToString("f6");
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labeldT.Text = dtavr1.ToString("f6");
                dtmax = 0; t0avr = 0; dtavr = 0; cntT0 = 0;
            }

            if (iRtc >= (int)numPoints.Value)   // If ready
            {
                MMTimer1.Disable();
                buttonStep.Enabled = true;
                meinMain.DACoutput(0, (double)nUDVbs.Value);
                timerDisplaySRMeasure.Enabled=false;
                chart2D1.clearAll();
                TabControl.SelectedTab = TSCurve;
                for (int i = 0; i < (int)numPoints.Value; i++)
                    chart2D1.setPoint(0, i * 0.001 * (int)numTimeInterval.Value, xa[i]);
                chart2D1.CurveNames[0] = MeasureSR;
                chart2D1.updateNames();
                chart2D1.autoScaling();
                chart2D1.startDrawing();
            }
        }

        private void TabControl_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (TabControl.SelectedTab == tPMeasureSR)
            {
                meinMain.DACoutput((short)nudChanDA.Value, (double)nUDVbs.Value);
                tSBMeasureSR_Click(null, null);
            }
        }

        private void numTimeInterval_ValueChanged(object sender, EventArgs e)
        {
            MMTimer1.Disable();
            MMTimer1.Interval = (uint)numTimeInterval.Value;
            MMTimer1.Enable();
        }
    }
}
