﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using MPS;                           //using multimediatimer
using WINDF7CSharp;
using System.Runtime.InteropServices;
using AConInfo;


// Init Program for student use 
// stud_algorithm() is cleaned


namespace AdaptControl
{
    public partial class FormAdaptControl : Form
    {
        const int maxpoints = 3001;
        const int maxnp2 = 13;  //max degree of DB / Orientation is 10

        TMultimediaTimer MMTimer1;
        double xoff = 0, uoff = 0, amp = 0, xroff = 0; //initialization of voltage
        public double w = 0;                         //public variable w ,the expected output, to be called by other objects
        public double val;                           //public variable val, the voltage input from motor, to be called by other objects

        FormMain meinMain;
        Boolean onRecord = false;  //indication of button RunRSR being pressed or not
        public bool RunOn = false; //public indication of whether motor being running

        short irtc = 0, nb = 0;       //curve point indication i, curve points numbers nb
        int indexRec = 0;            //pulse number

        public double q0p, q0n, q1n, q0d, p1n, q1d, q0i, q1i, q2i, p1i, p1f, p2f, q0f, q1f, q2f, q0fPD, q1fPD, q2fPD; //{PID-params,}
        //p=P //n=PI  //i=PID  // d=PD // f= PIDT1 free // fPD for Antiwindup
        double q0ac, q0ic, q1ic;//cascaded
        double TwoPointUp, TwoPointDown;
        int mgradCon=0,mgradIdent=0;
        double limitation = 0, limit_low = 0;
        double z1 = 0, z2 = 0;
        double t0start = 0, t0end = 0; double dtstart = 0, dtend = 0; double dtmax = 0; double dt = 0; //variables related to standard timer  for displaying dT to and dTMAX
        int cntT0 = 0;
        double t0avr = 0, dtavr = 0;
        int Ncon = 0;  //Ncon stands for selected controller for button RSR
        int InitialType = 3;//InitialType stands for initial controller for button RUN
        string ConType = "P";
        int pulse = 0;
        bool recOn = false; bool stepOn = true;

        bool procSR = false; double procInputBeforePSR = 0, firstVal = 0;
        const int filtnb = 10;  // Digital Filter to get the Process input average before process step response
        private double[] xrBeforeStep = new double[filtnb];

        string[] pars = new string[4];
        int thisdrawnum = 1;

        FromAControlInfo acinfo = new FromAControlInfo();
        Stopwatch stopwatch1 = new Stopwatch();

        double yout = 0; double yold = 0, yold2 = 0; double xdold1 = 0; double xdold2 = 0;
        double youtDisplay = 0, youtdisplayfiltered = 0;
        int idisplay = 0;
        double yoldI, xdn1casI, youtI, x1casI;  // Cascaded controller before RSR
        double q0Init, q1Init, xd1Init = 0;
        double ncas, xdn1cas, xdncas, wncas, x1cas;  // cascaded controller

        public double t0rtc;

        string maxpts = "Max Points= ";
        double[,] ayval = new double[maxpoints, 2]; //storage for double value of points on curves
        double[,] awval = new double[maxpoints, 2];
        double[,] axrval = new double[maxpoints, 2];
        string OneCurvenecessary = "One Curve is necessary";
        int lastNbOfPoints = 0;

        public double[] xd = new double[maxnp2];    // control error
        public double[] xa = new double[maxnp2];    // process output val
        public double[] xr = new double[maxnp2];    // controller output

        string FilterName = "RTC- Data";
        string points = "Points";
        LoadOpt LOrtc = new LoadOpt();
        string CRLF = "\r\n";


        double DZcompensation = 0, NoiseAtZ1 = 0;
        Random NoiseZ1 = new Random();

        /*Regelungstechnische PFC Variablen*/

        double fYr=0;
        double[] fXd = new double[3] { 0, 0, 0 };                 //Regeldiffenenz "Schieberegister"              
        double[] fXm = new double[3] { 0, 0, 0 };                 //Modellausgang "Schieberegister"
        double[] fXg = new double[3] { 0, 0, 0 };                 //Strecke gemessen "Schieberegister"

        /*PFC spezifische Variablen*/
        double fA, fAh, fB, fBh, fC, fCh, fKm, fT1, fT2, fLh, fTr, fT0;             //fKm=Modellverstärkung, fT1=Zeitkonstante Modell, fT0=Abtastzeit
        double fa1, fa2, fb1, fb2,valold=0,fax,fYrold=0,xmodpredold=0,fYrold2=0;
        int iH;       //iH=Prädiktionshorrizont

        // for adaptive controllers
         double[] pv = new double[maxnp2 + 1];    // DB (v) Standard
         double[] qv = new double[maxnp2 + 1];
         double[] p1v = new double[maxnp2 + 1];   // DB(v+1)
         double[] q1v = new double[maxnp2 + 1];
         double[] p2v = new double[maxnp2 + 1];   // Orienteering controller
         double[] q2v = new double[maxnp2 + 1];
         double f3or;  // Orientering Contr
         double[] tetaIdent_b0 = new double[maxnp2];

        CHMinMax minmax;

        public FormAdaptControl(FormMain m)
        {
            InitializeComponent();
            Control.CheckForIllegalCrossThreadCalls = false;
            meinMain = m;
            MMTimer1 = new TMultimediaTimer(null);

            MMTimer1.OnTimer = EventVomMMTimer;
            dataGridViewControllerPar.Rows.Add("0", "0");       //add three new rows in datagridviewControllerPar,waiting for incoming control parameters
            dataGridViewControllerPar.Rows.Add("0", "0");
            dataGridViewControllerPar.Rows.Add("0", "0");
            minmax = new CHMinMax();
            stopwatch1.Start();

            // Init Values Breathing System
            q0p = 4.23; q0d = 31.608; q1d = -23.706;
            q0n = 1.94487; q1n = -1.9148; q0i = 15.528; q1i = -26.704; q2i = 11.294; p1n = 1; p1i = 1;
            // Cascades controller for Breathing system
            q0ac = 30.0; q0ic = 0.201; q1ic = -0.17;
            TwoPointDown = -10.0;
            TwoPointUp = 10.0;
            t0rtc = 0.01;
            labelMaxPoints.Text = maxpts + (maxpoints-1).ToString();
            numPoints.Maximum = maxpoints-1;
            toolStripButton12_Click(null, null);
            LOrtc.init();
            tBiniQ0_Leave(null, null);
            chart2D1.CurveColor0 = Color.Blue;
            chart2D1.AllClearButton = false;
            chart2D1.LastClearButton = false;


        }

        private void FormStudControl_Load(object sender, EventArgs e)
        {
            rbPcon_CheckedChanged(sender, e);
            pq2DataGrid();
            Tabs.SelectedIndex = 4;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[4] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[4] ab.
            Tabs.SelectedIndex = 3;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[3] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[3] ab.
            Tabs.SelectedIndex = 5;  // Hier liegt ein Fehler im Compiler. Wenn Tabs[5] nicht vor einem Beschreiben
            Application.DoEvents();// einer Kurve in Tabs[0] mal kurz aufgemacht wird, stürzt Programm beim Öffnen von Tabs[5] ab.
            Tabs.SelectedIndex = 0;
            numericUpDown4.Value=2;
        }

        public void deutsch()
        {
            OneCurvenecessary = "Mindestens eine Kurve ist nötig";
            maxpts = "Max. Punkte";
            FilterName = "Echtzeitkurve";
            points = "Punkte";
            this.Text = "Echtzeitregler";
            buttonRSR.Text = "Start FSA";
            toolTip1.SetToolTip(buttonRSR, "Starte Führungs- oder Störsprungantwort");
            butProcStepResp.Text = "Start SSA";
            toolTip1.SetToolTip(butProcStepResp, "Starte Streckensprungantwort");
            rsbHelp.ToolTipText = "Öffne Signalflussplan";
            tsbSetCol.ToolTipText = "Öffne Farbwählfenster";
            tsbWriteReport.ToolTipText = "Erzeuge Report von allen Kurven in Letzte - X- Tab";
            tsbGreenOK.ToolTipText = "Schließe Fenster und aktiviere Identifikation";
            tsbClose.ToolTipText = "Schließe Fenster und ignoriere Ergebnisse";
            tsbClearX.ToolTipText = "Text löschen";
            tsbClearW.ToolTipText = "Text löschen";
            tsbClearXr.ToolTipText = "Text löschen";
            tsbsaveW.ToolTipText = "Speicher W-Werte als .Sim- Datei";
            tsbSaveX_.ToolTipText = "Speicher X-Werte als .Sim- Datei";
            tsbSaveXr.ToolTipText = "Speicher Xr-Werte als .Sim- Datei";
            tsbReportX_.ToolTipText = "Erzeuge Report der letzten X- Werte";
            tsbReportW.ToolTipText = "Erzeuge Report der letzten W- Werte";
            tsbReportXr.ToolTipText = "Erzeuge Report der letzten Xr- Werte";
            toolTip1.SetToolTip(buttonPQenter, "Übernehme Änderungen der p-q-Werte");
            toolTip1.SetToolTip(cBUnitSR, "Wenn geklickt, konvertiere in Einheitssprungantwort");
            toolTip1.SetToolTip(tbComp, "Kompensation der toten Zone");
            toolTip1.SetToolTip(butProcStepResp,"Messe Streckensprungantwort");
            butProcStepResp.Text = "Start PSA";
            groupBox12.Text = "Echtzeitwerte";
            cbRealtimeDevice.Text = "Echtzeitkurve";
            groupBox2.Text = "Reglertyp";
            rbCascadedcon.Text = "Kaskade";
            toolTip1.SetToolTip(butFreeContr, "Freier PID");
            butFreeContr.Text = "Freier PID";
            rbFreecon.Text = "Freier PID";
            groupBox4.Text = "Ablauf Funktion";
            rbStepAutostop.Text = "Sprung, autostop";
            rbRectContinous.Text = "kont. Rechteck";
            rbInputAtADC.Text = "w vom AD";
            rbImpulsAutostop.Text = "Impuls, autostop";
            groupBox7.Text = "Anfangswerte nach RUN";
            groupBox5.Text = "Signal AMP an";
            groupBox6.Text = "Xr nach Autostop";
            cbNoiseZ1.Text = "Rauschen an Z1";
            toolTip1.SetToolTip(cbNoiseZ1, "Kann zur LS- Offline-Identifikation genutzt werden");
            rbInitialUoffByP.Text = "Uoff geregelt mit PI";
            rbInitialUoffByPI.Text = "Uoff geregelt mit Kask. Reg.";
            rbInitialXByCon.Text = "Uoff geregelt mit gewähltem Reg";
            groupBox10.Text = "Regler Parameter";
            groupBoxLimit.Text = "Begrenzung Xr";
            cbLimitation.Text = "Aktiviert +-";
            label29.Text = "Totzonen-Komp.";
            groupBox8.Text = "Streckenparameter";
            label21.Text = "Signal X an Kanal";
            toolTip1.SetToolTip(butFreeContr, "Freier PID");
            toolTip1.SetToolTip(buttonStop, "Stoppt Echtzeitmodus");
            toolTip1.SetToolTip(buttonRUN, "Startet Echtzeitmodus");
            labelMaxPoints.Text = maxpts + maxpoints.ToString();
            tabPage1.Text = "Kurven";
            tabPagePar.Text = "Parameter";
            tabPage3AdvPar.Text = "mehr Parameter";
            tabPage5x.Text = "Letzte X- werte";
            tabPage4LastXr.Text = "Letzte Xr- Werte";
            tabPage7LastW.Text = "Letzte W- Werte";
            tabPage6ConPar.Text = "Alle p-q-Reglerparameter";
            label7.Text = "p-q- Liste aller Regler";
            toolTip1.SetToolTip(butLoadContr, "Lade kompletten Set aller Regler");
            toolTip1.SetToolTip(butSaveContr, "Speichere kompletten Set aller Regler");
            toolTip1.SetToolTip(butAktivatepqChange, "Aktiviert Änderungen anden p-q- Werten");
            butAktivatepqChange.Text = "Aktiviere Änderungen";
            groupBox9.Text = "Identifizierte Streckenparameter";
            cbAdaptionActive.Text = "Adaptive Regler aktiv";
            cbIdentificationActive.Text = "Online-Identifikation aktiv";
            TSBClearLast.ToolTipText = "Lösche letzte Kurve";
            tsbClearAll.ToolTipText = "Lösche alle Kurven";
            chart2D1.Germanlanguage = true;
            toolTip1.SetToolTip(butdrawAgain, "Zeichne nochmal");
        }

 
        // your student parameters should start with _
        // double _newPar;

        public void stud_algorithm()
        {
            double xd0 = 0;
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);
            meinMain.DACoutput((short)nudChanDA.Value, yout);
            youtDisplay = yout;
            xd0 = w - val;   // control difference

            switch (Ncon)
            {
                case 0: yout = 0; break;//P controller
                case 1: yout = 0; break;//PDT1 controller
                case 2: yout = 0; break;//PI controller
                case 3: yout = 0; break; //PIDT1 controller 
                case 6: yout = 0; break; // Dead beat controller
                case 5: yout = 0; break; // Pidt1 with Anti Wind Up
                default: yout = 10 * xd0;
                    break;
            }

            yout = yout + z1;

            if (yout > 0) yout = yout + DZcompensation; else yout = yout - DZcompensation; //Dead Zone compensation

            if (cbLimitation.Checked)
            {
                if (yout > limitation) yout = limitation;
                if (yout < -limit_low) yout = -limit_low;
            }
        }



        void EventVomMMTimer(TMultimediaTimer sender)
        {
            double xd0;
            t0end = t0start;
            t0start = stopwatch1.ElapsedTicks;
            t0avr = t0avr + (t0start - t0end);  //calculating t0
            dtstart = stopwatch1.ElapsedTicks;
            if (cbDA1impulse.Checked) meinMain.DACoutput((short)nudChanImpulse.Value , 1); // 1 Volt - Impuls auf 2. DA - Kanal 
            if (onRecord == true)
            {   // after pressing RSR- or PSR button

                if (irtc < (int)numPoints.Value)
                {
                    //calculation loop starts
                    idisplay = irtc;
                    minmax.progress = irtc;
                    ayval[irtc, 0] = irtc * t0rtc;
                    awval[irtc, 0] = irtc * t0rtc;
                    axrval[irtc, 0] = irtc * t0rtc;
                    if ((rbImpulsAutostop.Checked) && (irtc > pulse)) w = uoff;
                    if (procSR)  // process step response autostop
                    {
                        meinMain.DACoutput((short)nudChanDA.Value , youtdisplayfiltered + w);   // Starting Value + w
                        youtDisplay = youtdisplayfiltered + w;
                        meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible
                        if (irtc == 0) { firstVal = val; axrval[0, 1] = 0; }

                        if (!cBUnitSR.Checked)
                        {
                            ayval[irtc, 1] = val;
                            axrval[irtc, 1] = w + youtdisplayfiltered;
                        }
                        else
                        {
                            ayval[irtc, 1] = (val - firstVal) / w; // remove offset and Unit step response
                            axrval[irtc, 1] = w;
                        }
                        // in w is the process input

                    }
                    else
                    {   //reference step respose autostop
                        if (irtc == 0)
                        {    // to correct the starting value if not zero
                            yout = youtdisplayfiltered;  
                            yold = yout; yold2 = yout;
                            for (int hzp = 1; hzp <= mgradIdent + 2; hzp++)
                            { 
                                xr[hzp] = yout; xa[hzp] = val; 
                            }
                            for (int hzp = 0; hzp < fXg.Length; hzp++)
                            {
                                fXg[hzp] = yout; fXm[hzp] = yout;
                            }
                        }
                        if (rBStud.Checked)
                        {
                            stud_algorithm();
                        }
                        else
                        {
                            ProfAlgorithm();
                        }
                        ayval[irtc, 1] = val;
                        awval[irtc, 1] = w;   // in w is the process input
                        if (rbReal.Checked)
                        {
                            axrval[irtc + 1, 1] = yout;
                            if (irtc == 0) axrval[0, 1] = 0; 
                        }
                        else axrval[irtc, 1] = yout;// ideal
                    }
                    irtc++;
                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(w, val, cbDisplayW.Checked, t0rtc);

                    //toolStripStatusLabel1.Text = "i= " + i.ToString();
                    //Application.DoEvents();
                    //calculation loop ends
                }
                else
                {   // now autostop 
                    //after control loop,stops timers, drawing graphic
                    onRecord = false;
                    MMTimer1.Enabled = false;
                    System.Threading.Thread.Sleep(100);//waiting for last dT calculation
                    timer2.Enabled = false;
                    lastNbOfPoints = irtc;

                    if (rbXrAfterStepZero.Checked)
                        meinMain.DACoutput((short)nudChanDA.Value, 0);
                    //tbLastValuesX.Clear();
                    //tBLastValuesXr.Clear();
                    //tBLastValuesW.Clear();
                    tsbReportX__Click_1(sender, null);
                    tsbReportXr_Click(sender, null);
                    tsbReportW_Click(sender, null);

                    nb = irtc;
                    irtc = 0;

                    buttonStop.Enabled = false;
                    buttonRSR.Enabled = false;
                    butProcStepResp.Enabled = false;
                    tStripProgressBar1.Visible = false;
                    RunOn = false;
                    EventArgs weg = new EventArgs();

                    Tabs.SelectedTab = tabPage1;
                    timerDraw.Enabled = true;
                    //tabPage1.Show();
                }
            }
            else
            {
                // continuous initial phase
                // before control loop ,in button RUN 
                if (stepOn)
                {

                    switch (InitialType)
                    {
                        case 0: youtI = 0; meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            meinMain.ADCinput((short)nudSignalIn.Value, ref val); // to see process output
                            break;
                        case 1: youtI = xroff; meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            meinMain.ADCinput((short)nudSignalIn.Value, ref val);// to see process output
                            break;
                        case 2:
                            {
                                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                                xd0 = w - val;
                                youtI = yoldI + q0Init * xd0 + q1Init * xd1Init;
                                yoldI = youtI; xd1Init = xd0;
                                if (cbLimitation.Checked)
                                {
                                    if (youtI > limitation) youtI = limitation;
                                    if (youtI < -limit_low) youtI = -limit_low;
                                }
                                meinMain.DACoutput((short)nudChanDA.Value, youtI);

                            } break;
                        case 3:
                            {   // Cascaded controller  q0ak=30;q0ik=0.201;q1ik=-0.17; /
                                meinMain.ADCinput((short)nudSignalIn.Value, ref val);
                                xd0 = w - val;
                                ncas = (val - x1casI) / t0rtc;  // speed by differentiating 
                                wncas = 30.0 * xd0;    // outer P-controller  
                                xdncas = wncas - ncas;
                                youtI = yoldI + 0.201 * xdncas - 0.17 * xdn1casI;   // PI-controller inner loop 
                                x1casI = val; xdn1casI = xdncas;
                                if ((youtI > limitation) || (youtI < -limit_low)) youtI = youtI + (0.17 - 0.201) * xdncas;//AWU
                                yoldI = youtI;
                                if (cbLimitation.Checked)
                                {
                                    if (youtI > limitation) youtI = limitation;
                                    if (youtI < -limit_low) youtI = -limit_low;
                                }
                                meinMain.DACoutput((short)nudChanDA.Value, youtI);
                            } break;
                        case 4: ProfAlgorithm(); youtI = yout; break;
                        default:
                            break;
                    }
                    youtDisplay = youtI;
                    youtdisplayfiltered = procInputBeforePSR;
                    xrBeforeStep[filtnb - 1] = youtI;
                    procInputBeforePSR = youtI;
                    for (int i = 0; i < (filtnb - 1); i++)
                    {
                        procInputBeforePSR = procInputBeforePSR + xrBeforeStep[i];
                        xrBeforeStep[i] = xrBeforeStep[i + 1]; //Shifter
                    }
                    procInputBeforePSR = procInputBeforePSR / filtnb;

                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(w, val, cbDisplayW.Checked, t0rtc);
                    Application.DoEvents();

                }
                if (recOn)  // here continuous mode, stop only after Stop button
                {
                    buttonRSR.Enabled = false;
                    butProcStepResp.Enabled = false;
                    if (indexRec < pulse)
                    {
                        if (rbSignalAtW.Checked) { w = uoff + amp; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ1.Checked) { w = uoff; z1 = amp; z2 = 0; }
                        if (rbSignalAtZ2.Checked) { w = uoff; z1 = 0; z2 = amp; }
                    }
                    else
                    {
                        if (rbSignalAtW.Checked) { w = uoff; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ1.Checked) { w = uoff; z1 = 0; z2 = 0; }
                        if (rbSignalAtZ2.Checked) { w = uoff; z1 = 0; z2 = 0; }
                    }
                    ProfAlgorithm();
                    indexRec++;
                    if (indexRec > (int)numPoints.Value)
                    {
                        indexRec = 0;
                    }
                    if (cbRealtimeDevice.Checked) meinMain.frmRTdevice.DrawRT(w, val, cbDisplayW.Checked, t0rtc);
                    Application.DoEvents();

                }
            }
            if (cbDA1impulse.Checked) meinMain.DACoutput((short)nudChanImpulse.Value, 1); // 1 Volt - Impuls auf 2. DA - Kanal hier zuende 

            dtend = stopwatch1.ElapsedTicks;
            dt = (dtend - dtstart);
            if (dt > dtmax) dtmax = dt;

            dtavr = dtavr + dt;
            cntT0++;
        }


        private void FormAdaptiveControl_FormClosing_1(object sender, FormClosingEventArgs e)
        {
            if (MMTimer1.Enabled == true)
            {
                MMTimer1.Disable();
            }
            e.Cancel = true;
            this.Visible = false;
            cbRealtimeDevice.Checked = false; // RT - curve stop
        }

        //timer 1 displays X ,Xr and W values
        private void timer1_Tick(object sender, EventArgs e)
        {
            labelX.Text = val.ToString("f3");
            labelXr.Text = youtDisplay.ToString("f3");
            labelW.Text = w.ToString("f3");
            labXFiltered.Text = "xr before Step= "+youtdisplayfiltered.ToString("f3");
            toolStripStatusLabel1.Text = "i= " + minmax.progress.ToString();
            if (numPoints.Value > minmax.pts)
                tStripProgressBar1.Maximum = (int)numPoints.Value;
            else
                tStripProgressBar1.Maximum = minmax.pts;
            tStripProgressBar1.Value = minmax.progress;
            if (cbIdentificationActive.Checked)
            {
                teta2DisplayIdent(tetaIdent_b0);
                tetaidtocell(tetaIdent_b0);
            }
            if (cbAdaptionActive.Checked)
            {
                KT2PFC();
                calcPFC_Parameters();
                pq2DataGrid();
            }
        }

        //timer 2 displays t0,dT and dTMAX values
        private void timer2_Tick(object sender, EventArgs e)
        {
            if (cntT0 > 0)
            {
                double t0avr1 = t0avr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labelT0.Text = t0avr1.ToString("f6");
                double dtavr1 = dtavr / cntT0 / (double)Stopwatch.Frequency * 1000;
                labeldT.Text = dtavr1.ToString("f6");
                double dtmax1 = dtmax / (double)Stopwatch.Frequency * 1000;
                labeldTMAX.Text = dtmax1.ToString("f6");
                dtmax = 0; t0avr = 0; dtavr = 0; cntT0 = 0;
            }
        }

        private void initController()
        {
            z1 = 0; z2 = 0;
            yold = 0; yout = 0; xdold2 = 0; xdold1 = 0; yold2 = 0;
            yoldI = 0; xdn1casI = 0; youtI = 0; x1casI = 0;
            xdn1cas = 0; yout = 0; x1cas = 0;

            for (int i = 0; i < maxnp2; i++)
            { xd[i] = 0; xr[i] = 0; xa[i] = 0; }

            for (int i = 0; i < filtnb; i++) xrBeforeStep[i] = 0;
            procInputBeforePSR = 0;

            for (int i = 0; i < fXd.Length; i++)
            {
                fXd[i] = 0;  // Init PFC- Controller
                fXg[i] = 0;
                fXm[i] = 0;
            }
            valold = 0; fYr = 0; fYrold = 0; xmodpredold = 0; fYrold2 = 0;
            meinMain.ConvertToDouble(tbLimitation.Text,ref limitation  );
            meinMain.ConvertToDouble(tBLowLimit.Text,ref limit_low );
            cntT0 = 0; t0avr = 0; dtavr = 0;
            meinMain.ConvertToDouble(tbXroff.Text,ref xroff );
            meinMain.ConvertToDouble(tBAlpha.Text,ref alpha );
            meinMain.ConvertToDouble(tBVFident.Text,ref wichtung );
        }

        
        
        void readpv_valuesfromconrdes()
        {
            // read controller from meinMain.fcontrdes.
            q0p = meinMain.fcontrdes.q0p;
            q0n = meinMain.fcontrdes.q0n;
            q1n = meinMain.fcontrdes.q1n;
            q0d = meinMain.fcontrdes.q0d;
            q1d = meinMain.fcontrdes.q1d;
            q0i = meinMain.fcontrdes.q0i;
            q1i = meinMain.fcontrdes.q1i;
            q2i = meinMain.fcontrdes.q2i;
            for (int i = 0; i < pv.Length; i++)
            {
                pv[i] = meinMain.fcontrdes.pv[i];
                qv[i] = meinMain.fcontrdes.qv[i];
                p1v[i] = meinMain.fcontrdes.p1v[i];
                q1v[i] = meinMain.fcontrdes.q1v[i];
                p2v[i] = meinMain.fcontrdes.p2v[i];
                q2v[i] = meinMain.fcontrdes.q2v[i];
                f3or = meinMain.fcontrdes.f3or;
            }
            for (int i = 0; i < tetaIdent_b0.Length; i++)
                tetaIdent_b0[i] = meinMain.fcontrdes.tetacd[i];
            mgradIdent = meinMain.fcontrdes._mgradcd;
        }
        
        private void buttonRUN_Click(object sender, EventArgs e)
        {
            int Tinterval = (int)numTimeInterval.Value;
            MMTimer1.Interval = (uint)numTimeInterval.Value;
            MMTimer1.Enabled = true;
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp );
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation );
            meinMain.ConvertToDouble(tbNoiseZ1.Text,ref NoiseAtZ1  );

            if (recOn)
            {
                Int32.TryParse(tbPulse.Text,out pulse);
            }
            onRecord = false;
            initController();
            meinMain.DACoutput((short)nudChanDA.Value, 0);

            rBPFCcon_CheckedChanged(sender, e);

            meinMain.ConvertToDouble(tbLimitation.Text,ref limitation  );
            meinMain.ConvertToDouble(tBLowLimit.Text,ref limit_low );
            buttonStop.Enabled = true;
            butProcStepResp.Enabled = true;
            buttonRSR.Enabled = true;
            timer1.Enabled = true;
            timer2.Enabled = true;
            cbDisplayW.Visible = true;
            cbDisplayW.Enabled = true;

            meinMain.ConvertToDouble(tbXroff.Text,ref xroff );
            if (rbInitialXroff.Checked)
            {
                w = xroff;
            }
            else
            {
                w = uoff;
            }
            RunOn = true;
            meinMain.ConvertToDouble(tBAlpha.Text,ref alpha );
            initident(alpha, mgradIdent, 0); //Initialisierung der Identifikation
            meinMain.ConvertToDouble(tBVFident.Text,ref wichtung  );
            readpv_valuesfromconrdes();
            calcPFC_Parameters();
        }

        private void buttonRSR_Click(object sender, EventArgs e)
        {
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff  );
            meinMain.ConvertToDouble(tbXroff.Text,ref xoff  );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp  );
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation );
            if (rbSignalAtW.Checked)
            {
                w = uoff + amp;
                z1 = 0;
                z2 = 0;
            }
            if (rbSignalAtZ1.Checked)
            {
                w = uoff;
                z1 = amp;
                z2 = 0;
            }
            if (rbSignalAtZ2.Checked)
            {
                w = uoff;
                z2 = amp;
                z1 = 0;
            }


            thisdrawnum = 0;
            if (cbDisplayW.Checked) thisdrawnum++;
            if (cbDisplayX.Checked) thisdrawnum++;
            if (cbDisplayXr.Checked) thisdrawnum++;
            if (thisdrawnum == 0)
            {
                cbDisplayX.Checked = true;  // at least one curve
                MessageBox.Show(OneCurvenecessary);
                thisdrawnum = 1;
            }
            LOrtc.toptitle = FilterName + "  " + numPoints.Value.ToString() + "  " + points;

            //axChartfx1.Visible = true;
            //axChartfx1.OpenDataEx(def.COD_VALUES, trail + thisdrawnum, (int)numPoints.Value);
            //axChartfx1.OpenDataEx(def.COD_XVALUES, trail + thisdrawnum, (int)numPoints.Value);

            cbDisplayW.Enabled = true;
            tStripProgressBar1.Maximum = minmax.pts;//(int)numPoints.Value;
            tStripProgressBar1.Visible = true;
            onRecord = true;
            procSR = false;
        }

        private void butProcStepResp_Click(object sender, EventArgs e)
        {  // Measure the process step response
            meinMain.ConvertToDouble(tbUoff.Text,ref uoff );
            meinMain.ConvertToDouble(tbXroff.Text,ref xoff );
            meinMain.ConvertToDouble(tbAmp.Text,ref amp );
            meinMain.ConvertToDouble(tbComp.Text,ref DZcompensation);

            w = amp;   // Only Amplitude is given to process input without offset
            z1 = 0;
            z2 = 0;
            cbDisplayW.Visible = false;
            thisdrawnum = 0;
            cbDisplayW.Checked = false;  // is senseless here
            if (cbDisplayX.Checked) thisdrawnum++;
            if (cbDisplayXr.Checked) thisdrawnum++;
            if (thisdrawnum == 0)
            {
                cbDisplayX.Checked = true;  // at least one curve
                MessageBox.Show(OneCurvenecessary);
                thisdrawnum = 1;
            }
            LOrtc.toptitle = FilterName + "  " + numPoints.Value.ToString() + "  " + points;
            //axChartfx1.Visible = true;
            //axChartfx1.OpenDataEx(def.COD_VALUES, trail + thisdrawnum, (int)numPoints.Value);
            //axChartfx1.OpenDataEx(def.COD_XVALUES, trail + thisdrawnum, (int)numPoints.Value);

            onRecord = true;
            procSR = true;


        }


        private void buttonStop_Click(object sender, EventArgs e)
        {
            meinMain.DACoutput((short)nudChanDA.Value, 0);
            MMTimer1.Disable();
            timer1.Enabled = false;
            timer2.Enabled = false;
            RunOn = false;
            buttonStop.Enabled = false;
            butProcStepResp.Enabled = false;
            buttonRSR.Enabled = false;
            irtc = 0; indexRec = 0;
        }


        // Writing report to text box
        private void tsbWriteReport_Click(object sender, EventArgs e)
        {
        //    tbLastValuesX.Text = "";
        //    int cvs = minmax.serie;

        //    for (int i = 0; i < nb; i++)
        //    {
        //        for (int ii = 0; ii < cvs; ii++)
        //        {
        //            if (ii == 0)
        //            {
        //                axChartfx1.ThisSerie = 0;
        //                double x = axChartfx1.get_XValue((short)i);
        //                double y = axChartfx1.get_Value((short)i);
        //                str1 = x.ToString() + " " + y.ToString();

        //            }
        //            else
        //            {
        //                axChartfx1.ThisSerie = (short)ii;
        //                double y = axChartfx1.get_Value((short)i);
        //                str1 = str1 + " " + y.ToString();
        //            }
        //        }
        //        if (i < nb - 1) str1 = str1 + CRLF;
        //        tbLastValuesX.AppendText(str1);
        //        str1 = "";
        //    }
        //    written = true;
        }



        private void buttonPQenter_Click(object sender, EventArgs e)
        {
            switch (Ncon)
            {
                case 0://P
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0p );
                    } break;
                case 1://PD
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0d );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1d );
                    } break;
                case 2:
                case 4://PI
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0n );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1n );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1n );
                    } break;
                case 3:
                case 5://PID
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[0].Value.ToString(),ref q2i );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1i );
                    } break;
                case 6://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.qv[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.pv[i] );
                        }
                    } break;
                case 7://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.q1v[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.p1v[i] );
                        }
                    } break;
                case 8://DB(v)
                    {
                        for (int i = 0; i < mgradCon; i++)
                        {
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[0].Value.ToString(),ref meinMain.fcontrdes.q2v[i] );
                            meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[i].Cells[1].Value.ToString(),ref meinMain.fcontrdes.p2v[i] );
                        }
                    } break;

                case 9://cascaded
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0ac );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q0ic );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref q1ic );
                    } break;
                case 10://Twopoint Controller
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref TwoPointUp );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[1].Value.ToString(),ref TwoPointDown );
                    } break;

                case 11://PID free
                    {
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[0].Cells[0].Value.ToString(),ref q0f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[0].Value.ToString(),ref q1f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[0].Value.ToString(),ref q2f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[1].Cells[1].Value.ToString(),ref p1f );
                        meinMain.ConvertToDouble(dataGridViewControllerPar.Rows[2].Cells[1].Value.ToString(),ref p2f );
                    } break;

            }
        }

        private void cbLimitation_CheckedChanged(object sender, EventArgs e)
        {
            if (cbLimitation.Checked)
            {
                label32.Visible = true;
                label37.Visible = true;
                tbLimitation.Visible = true;
                tBLowLimit.Visible = true;
            }
            else
            {
                label32.Visible = false;
                label37.Visible = false;
                tbLimitation.Visible = false;
                tBLowLimit.Visible = false;
            }
        }

        private void rsbHelp_Click(object sender, EventArgs e)
        {
            acinfo.Show();
        }

        private void rbPcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPcon.Checked)
            {
                Ncon = 0;
                ConType = "P";
                mgradCon = 1;
                pq2DataGrid();
            }
        }


        private void rbPDT1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPDT1con.Checked)
            {
                Ncon = 1;
                ConType = "PDT1";
                mgradCon = 2;
                pq2DataGrid();
            }
        }

        private void rbPIcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPIcon.Checked)
            {
                Ncon = 2;
                ConType = "PI";
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rbPIDT1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbPIDT1con.Checked)
            {
                Ncon = 3;
                ConType = "PIDT1";
                mgradCon = 3;
                pq2DataGrid();

            }
        }

        private void rbAWU1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAWU1con.Checked)
            {
                Ncon = 4;
                ConType = "PI AWU";
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rbAWU2con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbAWU2con.Checked)
            {
                Ncon = 5;
                ConType = "PID AWU";
                mgradCon = 3;
                pq2DataGrid();

            }
        }

        private void rbDBVcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbDBVcon.Checked)
            {
                Ncon = 6;
                ConType = "DB(V)";
                mgradCon = meinMain.fcontrdes._mgradcd + 1;
                pq2DataGrid();

            }
        }

        private void rbDBV1con_CheckedChanged(object sender, EventArgs e)
        {
            if (rbDBV1con.Checked)
            {
                Ncon = 7;
                ConType = "DB(V+1)";
                mgradCon = meinMain.fcontrdes._mgradcd + 2;
                pq2DataGrid();

            }
        }


        private void rbORcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbORcon.Checked)
            {
                ConType = "OR ";
                Ncon = 8;
                mgradCon = meinMain.fcontrdes._mgradcd + 1;
                pq2DataGrid();
            }
        }


        private void rbCascadedcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbCascadedcon.Checked)
            {
                ConType = "Casc ";
                Ncon = 9;
                mgradCon = 2;
                pq2DataGrid();

            }
        }

        private void rb2Pcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rb2Pcon.Checked)
            {
                ConType = "2P ";
                Ncon = 10;
                mgradCon = 1;
                pq2DataGrid();

            }
        }

        private void rbFreecon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbFreecon.Checked)
            {
                ConType = "Free ";
                Ncon = 11;
                mgradCon = 3;
                pq2DataGrid();
            }
        }

        void pq2DataGrid()
        {
            int aktgrad;
            if (Ncon == 6) aktgrad = mgradIdent+1;
            if (Ncon == 7) aktgrad = mgradIdent + 2;
            if (Ncon == 8) aktgrad = mgradIdent+2;
                
            else aktgrad = mgradCon;
            dataGridViewControllerPar.RowCount = aktgrad;
            for (int i = 0; i < aktgrad; i++)
            {
                dataGridViewControllerPar.Rows[i].Cells[0].Value = "0";
                dataGridViewControllerPar.Rows[i].Cells[1].Value = "0";
                dataGridViewControllerPar.Rows[i].HeaderCell.Value = i.ToString();
            }
            switch (Ncon)
            {
                case 0://P
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0p.ToString("g8");
                    } break;
                case 1://PD
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0d.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1d.ToString("g8");
                    } break;
                case 2:
                case 4://PI
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0n.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1n.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1n.ToString("g8");
                    } break;
                case 3:
                case 5://PID
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0i.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1i.ToString("g8");
                        dataGridViewControllerPar.Rows[2].Cells[0].Value = q2i.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1i.ToString("g8");
                    } break;
                case 6://DB(v)
                    {
                        for (int i = 0; i < aktgrad; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = qv[i].ToString("g8");
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = pv[i].ToString("g8");
                        }
                    } break;
                case 7://DB(v+1)
                    {
                        for (int i = 0; i < aktgrad; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = q1v[i].ToString("g8");
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = p1v[i].ToString("g8");
                        }
                    } break;
                case 8://OR)
                    {
                        for (int i = 0; i < aktgrad; i++)
                        {
                            dataGridViewControllerPar.Rows[i].Cells[0].Value = q2v[i].ToString("g8");
                            dataGridViewControllerPar.Rows[i].Cells[1].Value = p2v[i].ToString("g8");
                        }
                    } break;

                case 9://cascaded
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0ac.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q0ic.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = q1ic.ToString("g8");
                    } break;
                case 10://Twopoint Controller
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = TwoPointUp.ToString("g8");
                        dataGridViewControllerPar.Rows[0].Cells[1].Value = TwoPointDown.ToString("g8");
                    } break;

                case 11://PID free
                    {
                        dataGridViewControllerPar.Rows[0].Cells[0].Value = q0f.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[0].Value = q1f.ToString("g8");
                        dataGridViewControllerPar.Rows[2].Cells[0].Value = q2f.ToString("g8");
                        dataGridViewControllerPar.Rows[1].Cells[1].Value = p1f.ToString("g8");
                        dataGridViewControllerPar.Rows[2].Cells[1].Value = p2f.ToString("g8");
                    } break;

            }

        }


        private void rbInitialXr0_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXr0.Checked)
            {
                InitialType = 0;
            }
        }

        private void rbInitialXroff_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXroff.Checked)
            {
                InitialType = 1;
                label17.Show();
                tbXroff.Show();
            }
            else
            {
                label17.Visible = false;
                tbXroff.Visible = false;
            }
        }

        private void rbInitialUoffByP_CheckedChanged(object sender, EventArgs e)
        {  // selectable PI
            if (rbInitialUoffByP.Checked)
            {
                InitialType = 2;
                grBoxInitPI.Visible = true;
            }
            else
                grBoxInitPI.Visible = false;
        }

        private void rbInitialUoffByPI_CheckedChanged(object sender, EventArgs e)
        {   // Cascaded Controller for Breathing system
            if (rbInitialUoffByPI.Checked)
            {
                InitialType = 3;
            }
        }

        private void rbInitialXByCon_CheckedChanged(object sender, EventArgs e)
        {
            if (rbInitialXByCon.Checked)
            {
                InitialType = 4;
            }
        }

        private void cbRealtimeDevice_CheckedChanged(object sender, EventArgs e)
        {
            if (cbRealtimeDevice.Checked)
            {
                meinMain.frmRTdevice.Show();
            }
            else
            {
                meinMain.frmRTdevice.Visible = false;
            }
        }

        //clear the last curve
        private void tsbClearLastCurve_Click(object sender, EventArgs e)
        {
         }


        //changing the uoff using button Run time
        private void tbUoff_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                buttonRUN.PerformClick();
            }
        }

        private void rbRectContinous_CheckedChanged(object sender, EventArgs e)
        {
            if (rbRectContinous.Checked)
            {
                label8.Visible = true;
                tbPulse.Visible = true;
                recOn = true;
            }
            else
            {
                label8.Visible = false;
                tbPulse.Visible = false;
                recOn = false;
            }
        }

        private void rbStepAutostop_CheckedChanged(object sender, EventArgs e)
        {
            if (rbStepAutostop.Checked)
            {
                stepOn = true;
            }
            else
            {
                stepOn = false;
            }
        }

        private void toolStripButton12_Click(object sender, EventArgs e)
        {
        }

        private void rBStud_CheckedChanged(object sender, EventArgs e)
        {
            if (rBStud.Checked)
            {
                rb2Pcon.Visible = false;
                rbAWU1con.Visible = false;
                rbAWU2con.Visible = true;
                rbCascadedcon.Visible = false;
                rbDBV1con.Visible = false;
                rbDBVcon.Visible = true;
                rbFreecon.Visible = false;
                rbORcon.Visible = false;
                rBPFCcon.Visible = false;
                butFreeContr.Visible = false;
            }
            else
            {
                rb2Pcon.Visible = true;
                rbAWU1con.Visible = true;
                rbAWU2con.Visible = true;
                rbCascadedcon.Visible = true;
                rbDBV1con.Visible = true;
                rbDBVcon.Visible = true;
                rbFreecon.Visible = true;
                rbORcon.Visible = true;
                butFreeContr.Visible = true;
                rBPFCcon.Visible = true;
            }
        }

        private void butFreeContr_Click(object sender, EventArgs e)
        {
            meinMain.fpidpq.Show();
            meinMain.fpidpq.BringToFront();
        }

        private void numTimeInterval_ValueChanged(object sender, EventArgs e)
        {
            t0rtc = (double)numTimeInterval.Value * 0.001;  // sampling time in sec
            if (meinMain.frmSimul.cBSync.Checked) meinMain.frmSimul.SpEdpT0.Value = numTimeInterval.Value;
        }


        void xr_db(ref double xrr, double[] p, double[] q, double[] xr, double[] xd, int m)
        {
            double hv;
            int i;
            /*Dead-Beat-controller standard*/
            /*automatically adapting ideal/real mode*/
            hv = 0;
            if (rbReal.Checked) for (i = 1; i <= m; i++) hv = hv + p[i] * xr[i + 1] + q[i] * xd[i];
            else for (i = 1; i <= m; i++) hv = hv + p[i] * xr[i] + q[i] * xd[i];
            xrr = hv + q[0] * xd[0];
        }


        void xr_db1(ref double xrr, double[] p, double[] q, double[] xr, double[] xd, int m)
        /*Dead-Beat-controller with 1. impulse=2. impulse, needs 1 step more */
        {  /*automatically adapting ideal/real mode*/
            double hv;
            int i;
            hv = 0;
            if (rbReal.Checked) for (i = 1; i <= (m + 1); i++) hv = hv + p[i] * xr[i + 1] + q[i] * xd[i];
            else for (i = 1; i <= (m + 1); i++) hv = hv + p[i] * xr[i] + q[i] * xd[i];
            xrr = hv + q[0] * xd[0];
        }


        void xr_or(ref double xrr, double[] p, double[] q, double[] xr, int m, double[] teta, double wil, double f3l, double xl)
        /*Orientierungsregler  only for real mode*/
        {
            double c, hv, hv2, xprae;
            int i;
            xa[0] = xl;
            hv = 0; hv2 = 0;
            for (i = 1; i <= m; i++) hv = hv + teta[i + m + 1];
            for (i = 1; i <= m; i++) hv2 = hv2 + teta[i] * xa[i] - teta[i + m + 1] * xr[i + 1];
            if (hv == 0) c = 10 * limitation; else c = (xl + hv2) / hv;
            if (c > 10 * limitation) c = 10 * limitation;
            if (c < -10 * limit_low) c = -10 * limit_low;
            xprae = 0;
            for (i = 1; i <= m; i++) xprae = xprae + teta[i + m + 1] * (xr[i] - c) - teta[i] * xa[i - 1];
            hv = q[1] * xprae;
            for (i = 2; i <= m; i++) hv = hv - p[i] * (xr[i - 1] - c) + q[i] * xa[i - 2];
            xrr = f3l * wil - c + hv;
            for (i = m; i > 0; i--) xa[i] = xa[i - 1];

        }

        private void toolStripButton18_Click(object sender, EventArgs e)
        {   // copy datat and close
            if (tbLastValuesX.Lines.Length > 10)
                meinMain.fregress.tsbReadRTC.Enabled = true;
            if ((tbLastValuesX.Lines.Length > 10) && (tBLastValuesXr.Lines.Length > 10))
                meinMain.frmlsoff.rtcDataOK = true;
            Hide();
        }

        private void toolStripButton19_Click(object sender, EventArgs e)
        {  // no copy
            Hide();
        }



        private void tsbClearX__Click_1(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
        }

        private void tsbSaveX__Click_1(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tbLastValuesX.Text);
                myStream1.Close();
            }
        }

        private void tsbReportX__Click_1(object sender, EventArgs e)
        {
            tbLastValuesX.Clear();
            tbLastValuesX.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(ayval[index, 0].ToString() + " " + ayval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(ayval[index, 0].ToString() + " " + ayval[index, 1].ToString());
            tbLastValuesX.AppendText(str);
            tbLastValuesX.Visible = true;
        }

        private void tsbClearXr_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
        }

        private void tsbSaveXr_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBLastValuesXr.Text);
                myStream1.Close();
            }
        }

        private void tsbReportXr_Click(object sender, EventArgs e)
        {
            tBLastValuesXr.Clear();
            tBLastValuesXr.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(axrval[index, 0].ToString() + " " + axrval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(axrval[index, 0].ToString() + " " + axrval[index, 1].ToString());
            // Last point without CRLF
            tBLastValuesXr.AppendText(str);
            tBLastValuesXr.Visible = true;
        }

        private void tsbClearW_Click(object sender, EventArgs e)
        {
            tBLastValuesW.Clear();
        }

        private void tsbsaveW_Click(object sender, EventArgs e)
        {
            if (saveFileDialogSim.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveFileDialogSim.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tBLastValuesW.Text);
                myStream1.Close();
            }
        }

        private void tsbReportW_Click(object sender, EventArgs e)
        {
            tBLastValuesW.Clear();
            tBLastValuesW.Visible = false;
            int index;
            string str = "";
            for (index = 0; index < lastNbOfPoints - 1; index++)
            {
                str+=(awval[index, 0].ToString() + " " + awval[index, 1].ToString() + CRLF);
                minmax.progress = index;
            }
            str+=(awval[index, 0].ToString() + " " + awval[index, 1].ToString());
            tBLastValuesW.AppendText(str);
            tBLastValuesW.Visible = true;
        }

        private void toolStripButton10_Click(object sender, EventArgs e)
        {
            ////frmcs.axChartfx1 = axChartfx1;  // pointer verbiegen 
            //if (frmcs.WindowState == FormWindowState.Minimized)
            //    frmcs.WindowState = FormWindowState.Normal;
            //frmcs.Show();
            //frmcs.BringToFront();

        }

        private void tabPage5x_Enter(object sender, EventArgs e)
        {
            tbLastValuesX.Visible = true;

        }

        private void rbImpulsAutostop_Click(object sender, EventArgs e)
        {
            if (rbImpulsAutostop.Checked)
            {
                label8.Visible = true;
                tbPulse.Visible = true;
            }
            else
            {
                label8.Visible = false;
                tbPulse.Visible = false;
            }
        }


        private void butSaveContr_Click(object sender, EventArgs e)
        {
            if (saveDialogCon.ShowDialog() == DialogResult.OK)
            {
                StreamWriter myStream1 = new StreamWriter(saveDialogCon.OpenFile(), Encoding.Default);
                myStream1.WriteLine(tbBeforePQenter.Text);
                myStream1.Close();
            }

        }

        private void butLoadContr_Click(object sender, EventArgs e)
        {
            // Load *con file, copy to p-q values

            if (openFileDialogCon.ShowDialog() == DialogResult.OK)
            {
                tbBeforePQenter.Clear();
                StreamReader filestream = new StreamReader(openFileDialogCon.FileName, Encoding.Default);
                string line = "";
                while (line != null)
                {
                    line = filestream.ReadLine();
                    tbBeforePQenter.AppendText(line + CRLF);
                }
                filestream.Close();
                butAktivatepqChange_Click(sender, e);
            }
        }



        void ProfAlgorithm()
        {
            double xd0;
            if (rbReal.Checked)
            {
                meinMain.DACoutput((short)nudChanDA.Value, yout);
                youtDisplay = yout;
            }
            meinMain.ADCinput((short)nudSignalIn.Value, ref val);  // //so in Process Simul bo is possible
 
            xd0 = w - val - z2;
            xd[0] = xd0; fax = val;
            fXd[0] = xd0; // PFC

            if (cbIdentificationActive.Checked)
            {
                schaetzvec(val, ref tetaid, mgradIdent, gamma);
                teta2tetab0();
            }
            if (cbAdaptionActive.Checked)
            { calccontroller(); }

            switch (Ncon)
            {
                case 0: yout = q0p * xd0; break;  //P controller
                case 1: yout = q0d * xd0 + q1d * xdold1; break; //PDT1 controller
                case 2: yout = p1n * yold + q0n * xd0 + q1n * xdold1; break; //PI controller
                case 3: yout = p1i * yold + q0i * xd0 + q1i * xdold1 + q2i * xdold2; break;  //PIDT1 controller
                case 4:
                    {  // PI AWU 
                        yout = p1n * yold + q0n * xd0 + q1n * xdold1; ;  // PI
                        if (cbLimitation.Checked)
                            if ((yout < -limit_low) || (yout > limitation))
                            {
                                yout = yout - (q0n + q1n) * xd0;  // Subtract I- part
                            }
                    } break;
                case 5:
                    {  // PID AWU   
                        yout = p1i * yold + q0i * xd0 + q1i * xdold1 + q2i * xdold2;
                        if (cbLimitation.Checked)
                            if ((yout < -limit_low) || (yout > limitation))
                            {
                                yout = yout - (q0i + q1i + q2i) * xd0;  // Subtract I- part
                            }
                    } break;
                case 6: xr_db(ref yout, pv, qv, xr, xd, mgradIdent); break; // DeadBeat v 
                case 7: xr_db1(ref yout, p1v, q1v, xr, xd, mgradIdent); break; // Dead beat v+1
                case 8: xr_or(ref yout, p2v, q2v, xr,mgradIdent, tetaIdent_b0, w, f3or, val); break; // predictive orienteering controller
                case 9:
                    {   // Cascaded controller  q0ak=30;q0ik=0.201;q1ik=-0.17; /
                        ncas = (val - x1cas) / t0rtc;  // speed by differentiating 
                        wncas = q0ac * xd0;    // outer P-controller  
                        xdncas = wncas - ncas;
                        yout = yold + q0ic * xdncas + q1ic * xdn1cas;   // PI-controller inner loop 
                        x1cas = val; xdn1cas = xdncas;
                        if (cbLimitation.Checked)
                        {
                            if (yout > limitation) yout = limitation;
                            if (yout < -limit_low) yout = -limit_low;
                        }

                    } break;
                case 10: if (xd0 > 0.0) yout = TwoPointUp; else yout = TwoPointDown; break; /* ZPR 2-point contr.*/
                case 11:
                    {  // PID AWU  free   
                        yout = p1f * yold + p2f * yold2 + q0f * xd0 + q1f * xdold1 + q2f * xdold2;
                        if ((cbLimitation.Checked) && (meinMain.fpidpq.cBAntiwindup.Checked))
                            if ((yout < -limit_low) || (yout > limitation))
                            {
                                yout = p1f * yold + p2f * yold2 + q0fPD * xd0 + q1fPD * xdold1 + q2fPD * xdold2;// PD- Alg
                            }
                    } break;

                case 12:                                   //PFC-Algorithmus
                    {
                        if (rbPT1.Checked)
                        {
                            fXm[0] = fXm[1] * fA + (1 - fA) * fKm * fYr;           //Berechneter Modelausgang (Jetzt)
                            fYr = (fXd[0] * fLh + fXm[0] * fBh) / (fKm * fBh);
                            yout = fYr;       //Stellwertberechnung
                        }
                        if (rBPT1Bay.Checked)
                        {  //My special version
                            if (rbIdeal.Checked)
                                fYr = (w - fA * val) / fBh / fKm; //ideal
                            else
                            {
                                double xmodPred = fA * val + fBh * fKm * fYr; //real, one delay To, 
                                fYr = (w - fA * xmodPred) / fBh / fKm;
                            }
                            yout = fYr;       //controller output
                        }

                        if (rb2PT1.Checked)
                        {   // Change of fXg (measured) is used
                            fXm[0] = fYr * fA + fXm[1] * fB + ((fXm[1] - fXm[2]) / fT0) * fC;
                            fYr = (fXd[0] * fLh - /*((fXm[0] - fXm[1]) / fT0) * fCh*/ ((fXg[0] - fXg[1]) / fT0) * fCh + fXm[0] * (1 - fBh)) / (fAh);
                            //fYr = (fXd[0] * fLh - ((fXm[0] - fXm[1]) / fT0) * fCh* ((fXg[0] - fXg[1]) / fT0) * fCh + fXm[0] * (1 - fBh)) / (fAh);
                            yout = fYr;       //Stellwertberechnung
                        }
                        if (rB2PT1_2.Checked)
                        {   // Change of fXm (model) is used
                            fXm[0] = fYr * fA + fXm[1] * fB + ((fXm[1] - fXm[2]) / fT0) * fC;
                            //fYr = (fXd[0] * fLh - /*((fXm[0] - fXm[1]) / fT0) * fCh*/ ((fXg[0] - fXg[1]) / fT0) * fCh + fXm[0] * (1 - fBh)) / (fAh);
                            fYr = (fXd[0] * fLh - ((fXm[0] - fXm[1]) / fT0) * fCh /* ((fXg[0] - fXg[1]) / fT0) * fCh*/ + fXm[0] * (1 - fBh)) / (fAh);
                            yout = fYr;       //Stellwertberechnung
                        }
                        if (rB2PT1_3.Checked)
                        {   // meine spezialversion
                            double wnew = fax + (w - fax) / iH;
                            double xmodPred=0;
                            if (rbIdeal.Checked)
                                fYr = (wnew + fa1 * fax + fa2 * valold - fb2 * fYr) / fb1; // ideal alg
                            else
                            {  // real, eine Totzeit
                                xmodPred = -fa1 * fax - fa2 * valold + fb1 * fYrold + fb2 * fYrold2;
                                wnew = xmodPred + (w - xmodPred) / iH;
                                fYr = (wnew + fa1 * xmodPred + fa2 * xmodpredold - fb2 * fYr) / fb1; // ideal alg
                            }
                            valold = fax; yout = fYr; xmodpredold = xmodPred;
                        }
                        if (cBModelLimited.Checked)
                        {
                            if (fYr > limitation) fYr = limitation;
                            if (fYr < -limit_low) fYr = -limit_low;
                        }
                        fYrold2 = fYrold; fYrold = fYr;
                    } break;

                default: yout = q0p * xd0; break;  //P controller

            }
            yold2 = yold; yold = yout; xdold2 = xdold1; xdold1 = xd0;
            int hzp;
            for (hzp = mgradIdent + 2; hzp > 1; hzp--)
            {
                xr[hzp] = xr[hzp - 1];
                xd[hzp] = xd[hzp - 1];
            } /* shifter */
            xr[1] = yout; xd[1] = xd[0];

            // shifter für PFC

            for (hzp = 2; hzp >= 1; hzp--)
            {
                fXd[hzp] = fXd[hzp - 1];
                fXm[hzp] = fXm[hzp - 1];
            }
            fXg[1] = fXg[0];
            fXg[0] = val;


            yout = yout + z1;   // Disturbance in front of process
            if (cbNoiseZ1.Checked)
            {
                //Next : Random number 0-999
                yout = yout + NoiseAtZ1 * NoiseZ1.Next(1000) / 1000.0;
            }

            if (yout > 0) yout = yout + DZcompensation; else yout = yout - DZcompensation; //Dead Zone compensation

            if (cbLimitation.Checked)
            {
                if (yout > limitation) yout = limitation;
                if (yout < -limit_low) yout = -limit_low;
            }

            if (cbIdentificationActive.Checked)
            {
                korrekvec(yout, val, mgradIdent, kovmat, ref gamma, wichtung);
                kovmatrix(mgradIdent, ref kovmat, gamma, wichtung);
            }

            if (rbIdeal.Checked)
            {
                meinMain.DACoutput((short)nudChanDA.Value, yout);
                youtDisplay = yout;
            }
        }


        private void butAktivatepqChange_Click(object sender, EventArgs e)
        {
            int nb = tbBeforePQenter.Lines.Length;
            string[] pList = new string[nb]; // temporary array to accelerate
            int i;
            pList = tbBeforePQenter.Lines;  // pointer pList to Textbox
            string[] outstr = new string[10];

            meinMain.datatools.Str2NString(pList[0], ref outstr, ' ');//P
            meinMain.ConvertToDouble(outstr[1],ref q0p);
            meinMain.datatools.Str2NString(pList[1], ref outstr, ' ');//PD
            meinMain.ConvertToDouble(outstr[1],ref q0d );
            meinMain.ConvertToDouble(outstr[2],ref q1d );
            meinMain.datatools.Str2NString(pList[2], ref outstr, ' ');//PI
            meinMain.ConvertToDouble(outstr[1],ref q0n );
            meinMain.ConvertToDouble(outstr[2],ref q1n );
            meinMain.ConvertToDouble(outstr[3],ref p1n );
            meinMain.datatools.Str2NString(pList[3], ref outstr, ' ');//PID
            meinMain.ConvertToDouble(outstr[1],ref q0i );
            meinMain.ConvertToDouble(outstr[2],ref q1i );
            meinMain.ConvertToDouble(outstr[3],ref q2i );
            meinMain.ConvertToDouble(outstr[4],ref p1i );

            meinMain.datatools.Str2NString(pList[4], ref outstr, ' ');//DB(v)
            int graddb = Convert.ToInt32(outstr[1]);
            meinMain.fcontrdes._mgradcd = graddb - 1;
            for (i = 0; i < graddb; i++)
            {
                meinMain.datatools.Str2NString(pList[5 + i], ref outstr, ' ');//DB(v)
                meinMain.ConvertToDouble(outstr[0],ref meinMain.fcontrdes.qv[i] );
                meinMain.ConvertToDouble(outstr[1],ref meinMain.fcontrdes.pv[i] );
            }

            meinMain.datatools.Str2NString(pList[5 + graddb], ref outstr, ' ');//DB(v+1)
            int graddb1 = Convert.ToInt32(outstr[1]);
            for (i = 0; i < graddb1; i++)
            {
                meinMain.datatools.Str2NString(pList[6 + graddb + i], ref outstr, ' ');//DB(v+1)
                meinMain.ConvertToDouble(outstr[0],ref meinMain.fcontrdes.q1v[i] );
                meinMain.ConvertToDouble(outstr[1],ref meinMain.fcontrdes.p1v[i] );
            }

            int offs = graddb + graddb1;
            meinMain.datatools.Str2NString(pList[6 + offs], ref outstr, ' ');//OR
            int graddb2 = Convert.ToInt32(outstr[1]);
            for (i = 0; i < graddb2; i++)
            {
                meinMain.datatools.Str2NString(pList[7 + offs + i], ref outstr, ' ');//OR
                meinMain.ConvertToDouble(outstr[0],ref meinMain.fcontrdes.q2v[i] );
                meinMain.ConvertToDouble(outstr[1],ref meinMain.fcontrdes.p2v[i] );
            }
            offs = offs + graddb2;

            meinMain.datatools.Str2NString(pList[7 + offs], ref outstr, ' ');//cascaded
            meinMain.ConvertToDouble(outstr[1],ref q0ac );
            meinMain.ConvertToDouble(outstr[2],ref q0ic );
            meinMain.ConvertToDouble(outstr[3],ref q1ic );

            meinMain.datatools.Str2NString(pList[8 + offs], ref outstr, ' ');//twopoint
            meinMain.ConvertToDouble(outstr[1],ref TwoPointUp);
            meinMain.ConvertToDouble(outstr[2],ref TwoPointDown );

            meinMain.datatools.Str2NString(pList[9 + offs], ref outstr, ' ');//PID free
            meinMain.ConvertToDouble(outstr[1],ref q0f );
            meinMain.ConvertToDouble(outstr[2],ref q1f );
            meinMain.ConvertToDouble(outstr[3],ref q2f );
            meinMain.ConvertToDouble(outstr[4],ref p1f );
            meinMain.ConvertToDouble(outstr[5],ref p2f );
            butAktivatepqChange.Visible = false;
        }

        private void tbBeforePQenter_TextChanged(object sender, EventArgs e)
        {
            butAktivatepqChange.Visible = true;
        }

        private void tBiniQ0_Leave(object sender, EventArgs e)
        {   // KT aus qi at PI
            double q0 =0,q1=0;
            meinMain.ConvertToDouble(tBiniQ0.Text,ref q0);
            meinMain.ConvertToDouble(tBiniQ1.Text,ref q1);
            tbIniKr.Text = (-q1).ToString();
            tBiniTn.Text = (t0rtc / (-q0 / q1 - 1)).ToString();
            q0Init = q0;
            q1Init = q1;
        }

        private void tbIniKr_Leave(object sender, EventArgs e)
        {
            double kr=0,tn=0;
            meinMain.ConvertToDouble(tbIniKr.Text,ref kr );
            meinMain.ConvertToDouble(tBiniTn.Text,ref tn);
            q0Init = kr * (1 + t0rtc / tn);
            q1Init = -kr;
            tBiniQ0.Text = q0Init.ToString();
            tBiniQ1.Text = q1Init.ToString();
        }

        private void Tabs_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            if (Tabs.SelectedIndex == 6)
            {  // fill TB with all controllers
                tbBeforePQenter.Clear();
                tbBeforePQenter.Visible = false;
                tbBeforePQenter.AppendText("P " + q0p.ToString() + CRLF);
                tbBeforePQenter.AppendText("PD " + q0d.ToString() + " " + q1d.ToString() + CRLF);
                tbBeforePQenter.AppendText("PI " + q0n.ToString() + " " + q1n.ToString() + " " + p1n.ToString() + CRLF);
                tbBeforePQenter.AppendText("PID " + q0i.ToString() + " " + q1i.ToString() + " " + q2i.ToString() + " " + p1i.ToString() + CRLF);
                tbBeforePQenter.AppendText("DB(v) " + (meinMain.fcontrdes._mgradcd + 1).ToString() + CRLF);

                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 1); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.qv[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.pv[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("DB(v+1) " + (meinMain.fcontrdes._mgradcd + 2).ToString() + CRLF);

                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 2); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.q1v[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.p1v[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("OR " + (meinMain.fcontrdes._mgradcd + 1).ToString() + CRLF);
                for (int i = 0; i < (meinMain.fcontrdes._mgradcd + 1); i++)
                {
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.q2v[i].ToString() + " ");
                    tbBeforePQenter.AppendText(meinMain.fcontrdes.p2v[i].ToString() + CRLF);
                }
                tbBeforePQenter.AppendText("cascaded " + q0ac.ToString() + " " + q0ic.ToString() + " " + q1ic.ToString() + CRLF);
                tbBeforePQenter.AppendText("Twopoint " + TwoPointUp.ToString() + " " + TwoPointDown.ToString() + CRLF);
                tbBeforePQenter.AppendText("PIDfree " + q0f.ToString() + " " + q1f.ToString() + " " + q2f.ToString() + " " + p1f.ToString() + " " + p2f.ToString());
                tbBeforePQenter.Visible = true;
                butAktivatepqChange.Visible = false;
            }
        }

        private void rbPT1_CheckedChanged(object sender, EventArgs e)
        {
            gb2PT1.Enabled = false;
            gbPT1.Enabled = true;
            numH.Value = 1;

        }

        void CalctwPFC(double t1, double t2, ref double tw, double T0, ref int h)
        {
            if ((t1 != t2) && (t1 != 0) && (t2 != 0)) tw = t1 * t2 / (t1 - t2) * Math.Log(t1 / t2);
            else tw = 1e100;
            h = Convert.ToInt32( tw / T0);
            numH.Value = h;
        }

        private void rb2PT1_CheckedChanged(object sender, EventArgs e)
        {
            gbPT1.Enabled = false;
            gb2PT1.Enabled = true;
            double tw = 0;
            int h = 0;
            double t12 = 0, t22 = 0;
            meinMain.ConvertToDouble(tBnumT12PT1.Text, ref t12);
            meinMain.ConvertToDouble(tBnumT22PT1.Text, ref t22);
            CalctwPFC(t12, t22, ref tw, t0rtc, ref h);
            labtwPFC.Text = "tw " + tw.ToString("g8");
            labhPropoasal.Text = "h= " + h.ToString();
        }

        private void rBPFCcon_CheckedChanged(object sender, EventArgs e)
        {
            if (rBPFCcon.Checked)
            {
                Ncon = 12;
                ConType = "PFC";
                mgradCon = 2;
                pq2DataGrid();
                calcPFC_Parameters();
            }


        }

        void calcPFC_Parameters()
        {
            /*Übernahme der PFC-Parameter*/

            fT0 = t0rtc;  // Sampling time
            iH = (int)numH.Value;
            fTr = (double)numTr.Value;
            fLh = 1 - (double)Math.Exp(-1 * fT0 * iH / fTr);          //Reference Trajectory

            if ((rbPT1.Checked)||(rBPT1Bay.Checked))                                        //PT1-Modell
            {
                meinMain.ConvertToDouble(tBnumKmPT1.Text,ref fKm );
                meinMain.ConvertToDouble(tBnumT1PT1.Text,ref fT1 ); 
                fA = Math.Exp(-fT0 / fT1);
                fAh = Math.Exp(-iH * fT0 / fT1);
                fBh = 1 - fAh;
            }

            if ((rb2PT1.Checked) || (rB2PT1_2.Checked))               //2PT1-Modell
            {
                meinMain.ConvertToDouble(tBnumKm2PT1.Text,ref fKm );
                meinMain.ConvertToDouble(tBnumT12PT1.Text,ref fT1 );
                meinMain.ConvertToDouble(tBnumT22PT1.Text,ref fT2 ); 
                double fT0_fT1 = Math.Exp(-fT0 / fT1);
                double fT0_fT2 = Math.Exp(-fT0 / fT2);
                double fT0ih_fT1 = Math.Exp(-fT0 * iH / fT1);
                double fT0ih_fT2 = Math.Exp(-fT0 * iH / fT2);

                fA = fKm * (1 - 1 / (fT1 - fT2) * (fT1 * fT0_fT1 - fT2 * fT0_fT2));
                fAh = fKm * (1 - 1 / (fT1 - fT2) * (fT1 * fT0ih_fT1 - fT2 * fT0ih_fT2));
                fB = fT1 / (fT1 - fT2) * fT0_fT1 - fT2 / (fT1 - fT2) * fT0_fT2;
                fBh = fT1 / (fT1 - fT2) * fT0ih_fT1 - fT2 / (fT1 - fT2) * fT0ih_fT2;
                fC = fT1 * fT2 / (fT1 - fT2) * (fT0_fT1 - fT0_fT2);
                fCh = fT1 * fT2 / (fT1 - fT2) * (fT0ih_fT1 - fT0ih_fT2);
            }
            if (rB2PT1_3.Checked)
            {
                double c2, c3, d1, d2, d3;  // HoF(z) aus 2PT1
                meinMain.ConvertToDouble(tBnumKm2PT1.Text,ref fKm  );
                meinMain.ConvertToDouble(tBnumT12PT1.Text,ref fT1 );
                meinMain.ConvertToDouble(tBnumT22PT1.Text,ref fT2 );
                if (fT1 < fT2) { double weg = fT2; fT2 = fT1; fT1 = weg; } /*swap*/
                c3 = Math.Exp(-fT0 / fT1); c2 = Math.Exp(-fT0 / fT2);
                d1 = fKm * fT1 * fT2 / (fT2 - fT1); d2 = 1 / fT1 - 1 / fT2 - c2 / fT1 + c3 / fT2;
                d3 = (1 / fT1 - 1 / fT2) * c2 * c3 - c3 / fT1 + c2 / fT2;
                fa1 = -c2 - c3; fa2 = c2 * c3; fb1 = d1 * d2; fb2 = d1 * d3;

            }

        }

        //region Adaptive controller
        //// Alles für Adaption / ident aus BCB

        double[] psi = new double[maxnp2];
        double[] gamma = new double[maxnp2];
        double[,] einh = new double[maxnp2, maxnp2];
        double[,] kovmat = new double[maxnp2, maxnp2];
        double[] tetaid = new double[maxnp2];
        double ui = 0; //Startwerte
        double wichtung, alpha;
        // alle Vektoren und Matrizen starten mit  Index 0!!

        void ZVecMultVec(double[] vec1, double[] vec2, ref double wertz, int a)
        /*Routine zur Multiplikation eines Zeilenvektors mit
         einem Spaltenvektor*/
        {
            wertz = 0;
            for (int r1 = 0; r1 < a; r1++) wertz = wertz + vec2[r1] * vec1[r1];
        } /*PROCEDUREENDE*/
        // --------------------------------------------------------------------------

        void MatMultMat(double[,] mat1, double[,] mat2, ref double[,] mat3, int a)
        /*Routine zur Multiplikation zweier Matritzen*/
        {
            int r1, r2, r3;
            double sum;
            for (r3 = 0; r3 < a; r3++)
                for (r2 = 0; r2 < a; r2++)
                {
                    sum = 0;
                    for (r1 = 0; r1 < a; r1++) sum = sum + mat1[r3, r1] * mat2[r1, r2];
                    mat3[r3, r2] = sum;
                }

        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------
        void MatMultVec(double[,] mat1, double[] vec1, ref double[] vec3, int a)
        /*Routine zur Multiplikation einer Matritze mit einem Vektor*/
        {
            int r1, r2;
            double sum;
            for (r2 = 0; r2 < a; r2++)
            {
                sum = 0;
                for (r1 = 0; r1 < a; r1++) sum = sum + mat1[r2, r1] * vec1[r1];
                vec3[r2] = sum;
            }
        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------

        void VecMultSc(double[] vec1, double Sc, ref double[] vec3, int a)
        /*Routine zur Multiplikation eines Vektors mit einem Skalar*/
        {
            for (int r1 = 0; r1 < a; r1++)
                vec3[r1] = vec1[r1] * Sc;
        } /*PROCEDUREENDE*/


        //// --------------------------------------------------------------------------

        void VecAddVec(double[] vec1, double[] vec2, ref double[] vec3, int a)
        /*Routine zur Addition zweier Vektoren*/
        {
            for (int r1 = 0; r1 < a; r1++) vec3[r1] = vec1[r1] + vec2[r1];
        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------

        void MatSubMat(double[,] mat1, double[,] mat2, ref double[,] mat3, int a)
        /*Routine zur Subtraktion zweier Matritzen*/
        {
            for (int r1 = 0; r1 < a; r1++)
                for (int r2 = 0; r2 < a; r2++) mat3[r1, r2] = mat1[r1, r2] - mat2[r1, r2];
        } /*PROCEDUREENDE*/

        //// --------------------------------------------------------------------------

        void MatMultSc(ref double[,] mat1, double sc, int a)
        {
            // routine dividiert alle werte der Matrix mat1 durch sc
            if (Math.Abs(sc) > 1e-10) sc = 1 / sc; else sc = 1e10;
            for (int r1 = 0; r1 < a; r1++) for (int r2 = 0; r2 < a; r2++) mat1[r1, r2] = mat1[r1, r2] * sc;
        }

        //// --------------------------------------------------------------------------


        void VecMultZVec(double[] Vec1, double[] ZVec2, ref double[,] mat3, int a)
        /*Routine zur Multiplikation eines Spaltenvektors mit
         einem Zeilenvektor*/
        {
            for (int r1 = 0; r1 < a; r1++) for (int r2 = 0; r2 < a; r2++) mat3[r1, r2] = Vec1[r1] * ZVec2[r2];
        } /*PROCEDUREENDE*/


        //// --------------------------------------------------------------------------
        void schaetzvec(double xi, ref double[] tetai, int ni, double[] gamma)
        /* Routine zur Berechnung des Schätzvektors TETA(k) */
        {
            double ei, psit_teta = 0;
            double[] gamma_ei = new double[maxnp2];
            double[] tetain = new double[maxnp2];
            int ni2 = 2 * ni;

            ZVecMultVec(psi, tetai, ref psit_teta, ni2);
            ei = xi - psit_teta;
            VecMultSc(gamma, ei, ref gamma_ei, ni2);
            VecAddVec(tetai, gamma_ei, ref tetain, ni2);
            for (int r1 = 0; r1 < ni2; r1++)      // copy matrices
                tetai[r1] = tetain[r1];

        } /*PROCEDURE-ENDE*/


        //// --------------------------------------------------------------------------

        void kovmatrix(int ni, ref double[,] psfni, double[] gamma, double vf)
        /* Routine zur Berechnung des Kovarianzvektors P(k) */
        {
            int ni2 = 2 * ni;
            double[,] gamma_psit = new double[maxnp2, maxnp2];
            double[,] einh_gamma_psit = new double[maxnp2, maxnp2];

            VecMultZVec(gamma, psi, ref gamma_psit, ni2);
            MatSubMat(einh, gamma_psit, ref einh_gamma_psit, ni2);
            MatMultMat(einh_gamma_psit, psfni, ref gamma_psit, ni2);
            MatMultSc(ref gamma_psit, vf, ni2);
            for (int r1 = 0; r1 < ni2; r1++)      // copy matrices
                for (int r2 = 0; r2 < ni2; r2++) psfni[r1, r2] = gamma_psit[r1, r2];

        } /*PROCEDURE-ENDE*/

        //// --------------------------------------------------------------------------
        void initident(double ai, int ni, double uis)
        /*Initialisierung der Identifikation nach Voridentifikation*/
        {
            int mmax2 = maxnp2, hi1, hi2;
            ui = 0;
            uis=0;                                              /*Startwerte*/
            for (hi1 = 0; hi1 < mmax2; hi1++) for (hi2 = 0; hi2 < mmax2; hi2++)
                    if (hi1 == hi2) kovmat[hi1, hi2] = ai; else kovmat[hi1, hi2] = 0;
            for (hi1 = 0; hi1 < mmax2; hi1++) for (hi2 = 0; hi2 < mmax2; hi2++)
                    if (hi1 == hi2) einh[hi1, hi2] = 1; else einh[hi1, hi2] = 0;
            for (hi1 = 0; hi1 < mmax2; hi1++)
            {
                gamma[hi1] = 0;             /*Korrekturvektor 0 setzen*/
                psi[hi1] = 0;               /*Datenvektor 0 setzen*/
                tetaid[hi1] = 0;
            }

        } /*PROCEDURE-ENDE*/
        

        //// --------------------------------------------------------------------------

        void korrekvec(double uin, double xi, int ni, double[,] psfni,
                            ref double[] gamma, double vf)
        /* Routine zur Berechnung des Korrekturvektors GAMMA(k) */
        {
            double psit_p_psi = 0;
            int ni2 = 2 * ni;
            double[] p_psi = new double[maxnp2];

            for (int hi1 = maxnp2 - 1; hi1 > 0; hi1--) psi[hi1] = psi[hi1 - 1];
            psi[0] = (xi * (-1.0)); psi[ni] = ui;
            MatMultVec(psfni, psi, ref p_psi, ni2);
            ZVecMultVec(psi, p_psi, ref psit_p_psi, ni2);
            psit_p_psi = psit_p_psi + vf;
            psit_p_psi = 1 / psit_p_psi;
            VecMultSc(p_psi, psit_p_psi, ref gamma, ni2);
            ui = uin;
        } /*PROCEDURE-ENDE*/

 
        //// --------------------------------------------------------------------------
 
        void teta2tetab0()
        {
            // tetaid : 0,1,2,...kein b0 m,m+1,m+2... Aus RS online 
            // tetacd : 1,2,3,...b0, m+1,m+2,...   für Contrdes
            int i;
            for (i = 0; i < maxnp2; i++)
                tetaIdent_b0[i] = 0; // clear
            for (i = 0; i < mgradIdent; i++)
            {
                tetaIdent_b0[i + 1] = tetaid[i];
                tetaIdent_b0[i + mgradIdent + 2] = tetaid[i + mgradIdent];
            }
            alpha = 100;
        }
        void calccontroller()
        {
            teta2tetab0(); 
            switch (Ncon)
            {
                case 6:
                    {// DB(v)
                        meinMain.datatools.DB_aus_teta(tetaIdent_b0, ref pv, ref qv, mgradIdent);

                        break;
                    }
                case 7:
                    {// DB(v+1)
                        meinMain.datatools.DB1_aus_teta(tetaIdent_b0, ref p1v, ref q1v, mgradIdent, 1);
                        break;
                    }
                case 8:
                    {// OR
                        meinMain.datatools.OR_aus_teta(tetaIdent_b0, ref p2v,
                            ref q2v, mgradIdent, ref f3or);
                        break;
                    }
            }//  end switch
        }

        string TypIdent = "";
        
        void teta2DisplayIdent(double[] teta)
        {
            double _K = 0, _T1 = 0, _T2 = 0;
            string  error = "";
            meinMain.datatools.kt_aus_tetab0(ref _K, ref _T1, ref _T2, t0rtc, teta, mgradIdent, ref TypIdent, ref error);
            labelType.Text = "Type=  " + TypIdent;
            tBKident.Text = _K.ToString("G8");
            tBT1Ident.Text = _T1.ToString("G8");
            tBT2Ident.Text = _T2.ToString("G8");

            if ((TypIdent == "PT1") || (TypIdent == "IT1"))
            {
                tBT2Ident.Visible = false;
                labT2ident.Visible = false;
                labT1ident.Text = "T1";
            }
            if (TypIdent == "2PT1")
            {
                tBT2Ident.Visible = true;
                labT2ident.Visible = true;
                labT1ident.Text = "T1";
                labT2ident.Text = "T2";
            }
            if (TypIdent == "PT2")
            {
                tBT2Ident.Visible = true;
                labT2ident.Visible = true;
                labT1ident.Text = "wo";
                labT2ident.Text = "d";
            }
        }

        void KT2PFC()
        {
            if ((TypIdent == "PT1") && ((rbPT1.Checked)||(rBPT1Bay.Checked)))
            {
                tBnumKmPT1.Text=tBKident.Text;
                tBnumT1PT1.Text=tBT1Ident.Text;
                calcPFC_Parameters();
            }
            if ((TypIdent == "2PT1") && ((rb2PT1.Checked) || (rB2PT1_2.Checked) || (rB2PT1_3.Checked)))
            {
                tBnumKm2PT1.Text=tBKident.Text;
                tBnumT12PT1.Text=tBT1Ident.Text;
                tBnumT22PT1.Text=tBT2Ident.Text;
                calcPFC_Parameters();
            }

        }
        
        void tetaidtocell(double [] teta)
        {   // with bo- Version
            int i;
            //dataGridViewProcessPar.RowCount = 1;
            dataGridViewProcessPar.Rows[0].Cells[0].Value="1";
            dataGridViewProcessPar.Rows[0].Cells[1].Value= teta[mgradIdent + 1].ToString("G8"); /*b0*/
            dataGridViewProcessPar.Rows[0].HeaderCell.Value = "0";
            for (i = 1; i <= mgradIdent; i++)
            {
                dataGridViewProcessPar.Rows[i].Cells[0].Value=teta[i].ToString("G8");
                dataGridViewProcessPar.Rows[i].Cells[1].Value = teta[mgradIdent + 1 + i].ToString("G8"); /*bi*/
                dataGridViewProcessPar.Rows[i].HeaderCell.Value = i.ToString();
            } /*for (*/


        }

        private void numericUpDown4_ValueChanged(object sender, EventArgs e)
        {
            mgradIdent = (int)numericUpDown4.Value;
            dataGridViewProcessPar.RowCount = (int)numericUpDown4.Value+1;
        }

        private void butSaveIdentProc_Click(object sender, EventArgs e)
        {
            if (saveFileDialogIdentFz.ShowDialog() == DialogResult.OK)
            {
                List<string> pList = new List<string>();
                pList.Add("From RLS online identification");
                pList.Add(numericUpDown4.Value.ToString());

                for (int i = 1; i <= numericUpDown4.Value + 1; i++)
                {
                    pList.Add(dataGridViewProcessPar.Rows[i - 1].Cells[0].Value + " "
                        + dataGridViewProcessPar.Rows[i - 1].Cells[1].Value);
                }
                pList.Add((t0rtc).ToString());  //  in file in sec
                pList.Add("0");  // no integer delay n*T0
                pList.Add("0"); // no continuous delay

                System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialogIdentFz.FileName);
                foreach (string s in pList)
                {
                    sw.WriteLine(s);
                }
                sw.Close();
            }

        }

        private void butInitControl_Click(object sender, EventArgs e)
        {
            initident(alpha, mgradIdent, 0);
            initController();
            // read controller from meinMain.fcontrdes.
            readpv_valuesfromconrdes();
        }

        private void rbIdeal_CheckedChanged(object sender, EventArgs e)
        {
            meinMain.frmSimul.rbIdeal.Checked = rbIdeal.Checked;
        }

        private void rbReal_CheckedChanged(object sender, EventArgs e)
        {
            meinMain.frmSimul.rbReal.Checked = rbReal.Checked;
        }

        private void tsbClearAll_Click(object sender, EventArgs e)
        {
            chart2D1.clearAll();
            minmax.init();
        }

        private void TSBClearLast_Click(object sender, EventArgs e)
        {
            if (minmax.serie > 1)
            {
                chart2D1.clearLast();
                minmax.serie--;
            }
            else
            {
                chart2D1.clearAll();
                minmax.init();
            }

        }

 
        private void timerDraw_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timerDraw.Enabled = false;
            butdrawAgain_Click(sender, null);
        }

        private void butdrawAgain_Click(object sender, EventArgs e)
        {
            if (cbDisplayX.Checked)
            {
                LOrtc.legend = "X " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, ayval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayXr.Checked)
            {
                LOrtc.legend = "Xr " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, axrval, (int)numPoints.Value, ref minmax, LOrtc);
            }
            if (cbDisplayW.Checked)
            {
                LOrtc.legend = "W " + ConType;
                if (rBStud.Checked) LOrtc.legend += "-stud";
                int a = meinMain.datatools.ConvertArray2ChartAdd(ref chart2D1, awval, (int)numPoints.Value, ref minmax, LOrtc);
            }


        }

        //// --------------------------------------------------------------------------
    }   
}
